2000-05-23  Werner LEMBERG  <wl@gnu.org>

	Adding font CWI (constant width italic) to devdvi.

	* font/devdvi/CWI: New file.
	* font/devdvi/generate/Makefile: Add generating rule.
	* font/devdvi/DESC.in, font/devdvi/Makefile.sub, win32-diffs,
	tmac/tmac.dvi: Use it.
	* NEWS: Announce it.

	* font/devlj4/*: Regenerated (only adding kernings for `cq' glyph).
	* font/devlj4/generate/Makefile: Cosmetic changes only.

	* man/groff.man: Removed most of the redundant description of
	special characters (which is in groff_char.man).  Added font
	translation CB->CR for devdvi.  Other minor fixes.

	* tmac/tmac.dvi: Improved appearance of \(co (copyright) and \(rg
	(registered) symbols.

2000-05-22  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile: Added rule for creating info files.

	* font/devdvi/*: Added kernings for `cq' glyph.  Updated to latest
	AMS font metrics.
	* font/devdvi/generate/Makefile: Fixed dependencies.

	* font/devps/*: Regenerated.  Heavy changes for Bookman and
	NewCentury Schoolbook!
	* font/devps/generate/afmname: Will now run with GNU awk.
	* font/devps/generate/textmap: Added forgotten `cq' glyph name.
	* font/devps/generate/Makefile: Cosmetic changes only.

2000-05-21  Werner LEMBERG  <wl@gnu.org>

	* tmac/tmac.an: Added a new command line option `-rSxx' (`xx' can be
	10, 11, or 12) to support output with 11pt and 12pt base font sizes. 
	`.SS' now produces a heading with a smaller size than `.SH'. 
	Completely formatted.
	* doc/groff.texinfo, tmac/groff_man.man, NEWS: Document it.

	* man/groff.man: Improved table appearance.  Use of `eo' request
	to reduce number of doubled backslashes in macro definitions.
	Replacing `\e' with `\(rs'.  Other minor fixes.

	* src/preproc/tbl/main.cc: Insert HTML table end tag before `lf'
	to have correct line number.

	* INSTALL: Small improvement.

2000-05-20  Bernd Warken  <bwarken@mayn.de>

	* man/roff.man, tmac/groff_tmac.man: Updates (with corrections by
	WL).

2000-05-19  Bernd Warken  <bwarken@mayn.de>

	* man/groff.man: Complete update (with a lot of corrections by WL).

2000-05-18  Werner LEMBERG  <wl@gnu.org>

	Adding `cq' (PS name `quoteright') glyph name as an alias for "'".

	* font/*/*: Implement it.
	* man/groff_char.man, NEWS: Document it.

	* src/include/unix.h: Removed.  It isn't used.

	* doc/groff.texinfo: Slight improvements.

2000-05-17  Werner LEMBERG  <wl@gnu.org>

	* README, win32-diffs: Small fixes and improvements.

2000-05-16  Werner LEMBERG  <wl@gnu.org>

	* FDL: New file (the Free Documentation License version 1.1).

	* doc/groff.texinfo: Added many start-up values for gtroff.
	Some structural improvements of the source code.

2000-05-15  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cc: Added small comment about troffrc-end.
	* src/roff/troff/troff.man: Added info about troffrc-end.

2000-05-14  Werner LEMBERG  <wl@gnu.org>

	* Makefile.in (EXTRADIRS): Fix typos.
	(dist): Handle deletion of old .tar.gz file correctly.
	(DISTDIRS): Include all tty output devices.

	* doc/groff.texinfo: Adding more cross references; countless other
	fixes.

2000-05-13  Werner LEMBERG  <wl@gnu.org>

	* MORE.STUFF: Added Robert Marks's utilities.

2000-05-12  Werner LEMBERG  <wl@gnu.org>

	Added win32 port contributed by Blake McBride
	<blake@florida-software.com>.

	* README.WIN32, win32-diffs: New files.
	* NEWS: Updated.

	* src/preproc/grn/hgraph.cc (HGSetBrush): Replace `%lf' with `%f'.
	(tmove, tmove2): Added parentheses to avoid compiler warnings.
	(change): Removed unused variables.

	* src/preproc/grn/main.cc (main, conv): Removed unused variables.
	(savebounds): Changed return value from `int' to `void'.
	* src/preproc/grn/hdb.cc: Ditto.

	* src/devices/grolbp/lbp.cc (lbp_printer::draw): Removed superfluous
	final backslash in comment to avoid compiler warning.

	* src/utils/pfbtops/pfbtops.c: Added `getopt.h'.

	* doc/groff.texinfo: More fixes.

2000-05-11  OKAZAKI Tetsurou  <okazaki@be.to>

	* tmac/tmac.doc: Documentation fix.

2000-05-11  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Reading the source code shows up a lot of
	omissions and incorrect data...  More conversion to @Deffn macros.

2000-05-10  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/reg.cc (number_value_to_ascii): Remove ASCII
	dependency.

	* src/roff/troff/request.h: Removing unused `no_break_flag'.

2000-05-09  Werner LEMBERG  <wl@gnu.org>

	* man/groff.man, man/roff.man, tmac/groff_tmac.man: Minor
	improvements.

	* doc/groff.texinfo: Extended history section.  More conversion to
	@Deffn macros.  More .tr documentation.

2000-05-07  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Completed tab section.  Added info about
	fields.

2000-05-06  Mike MacIsaac  <mikemac@us.ibm.com>

	* PROBLEMS: Describe configure script fix for OS/390 Unix.

2000-05-05  Werner LEMBERG  <wl@gnu.org>

	* font/devdvi/DESC.in: Change size 11pt to 10.95pt (as used in
	LaTeX 2e).
	* NEWS: Document it.

	* man/troff.man: Minor optical improvements.

2000-05-03  Werner LEMBERG  <wl@gnu.org>

	Adding `dq' (PS name `quotedbl') glyph name as an alias for `"'.

	* font/*/*: Implement it.
	* man/groff_char.man, NEWS: Document it.

2000-05-02  Werner LEMBERG  <wl@gnu.org>

	* tmac/groff_tmac.man, man/groff.man, man/roff.man: Fixing @MANxEXT@
	expansion.
	* NEWS: Document the three new man pages.

	* aclocal.m4 (GROFF_CXX_CHECK): Removing obsolete AC_C_CROSS call.
	* configure: Updated.

	* font/devcp1047/R.proto: Fixing fatal bug (a missing `"' character).

2000-05-01  Werner LEMBERG  <wl@gnu.org>

	Added grap support to grog.

	* src/roff/grog/grog.sh, src/roff/grog/grog.pl: Implement it.
	* src/roff/grog/grog.man: Document it.

	* doc/groff.texinfo, NEWS: Add info about grap support.

	Add new man pages comptributed by Bernd Warken <bwarken@mayn.de>
	(with slight fixes by me).

	* tmac/groff_tmac.man: New file documenting tmac mechanism.
	* tmac/Makefile.sub: Add groff_tmac.man.
	* man/roff.man: New file giving overview of roff system.
	* man/troff.man: A short reference of troff.
	* man/Makefile.sub: Add roff.man and troff.man.

2000-04-30  Werner LEMBERG  <wl@gnu.org>

	Added grap support to groff.

	* src/roff/groff/groff.cc: Implement it.
	* src/roff/groff/groff.man: Document it.

	* src/devices/grotty/grotty.man: Add cp1047 device.
	* src/preproc/eqn/eqn.man, src/preproc/eqn/neqn.sh, tmac/eqnrc:
	Ditto.
	* src/roff/groff/groff.man: Ditto.
	* src/roff/nroff/nroff.sh, src/roff/nroff/nroff.man: Ditto.
	* doc/groff.texinfo: Ditto.

	* tmac/troffrc: Fix mapping of latin-1 char 160 (non-breakable space)
	for cp1047.

2000-04-29  Werner LEMBERG  <wl@gnu.org>

	* man/groff_char.man: Add `pc' glyph.
	* tmac/tmac.latin1: Replacing `md' glyph with `pc'.
	* tmac/tmac.tty: Add `pc' glyph.
	* tmac/tmac.tty-char: Use/add `pc' glyph.  Don't call tmac.latin1 if
	we use cp1047 output device.

	* Makefile.in, aclocal.m4: Don't build utf8 on EBCDIC hosts since
	there are still hardcoded latin1->unicode values in utf8's font
	definition files.
	* configure: Updated.
	* NEWS: Minor clarification.  Updated.

	* PROBLEMS: Formatted.  Added info about C++ fix pack for OS/390
	Unix.

2000-04-28  Werner LEMBERG  <wl@gnu.org>

	Adding EBCDIC code page 1047.

	* font/devcp1047/R.proto, font/devcp1047/Makefile.sub,
	font/devcp1047/DESC.proto: New files.

	* aclocal.m4 (GROFF_EBCDIC): Introduce TTYDEVDIRS which can be
	either ascii/latin1 or cp1047.
	* Makefile.in: Use it.
	* configure: Updated.

	Replacing and/or adding `md' (mathdot) glyph with `pc'
	(periodcentered) in all text fonts.

	* font/*/*: Change it.

2000-04-27  Werner LEMBERG  <wl@gnu.org>

	* aclocal.m4 (GROFF_OS390): Fixing compiler flags.

	* configure.in: Add check for strings.h.
	* src/include/driver.h: Use HAVE_STRINGS_H.
	* src/devices/grolbp/lpb.cc: Remove string.h.

	* src/include/groff-getopt.h: New file.  It will be used instead of
	getopt.h (to be included in lib.h) to avoid endless problems with
	picky C++ compilers.
	* src/include/lib.h: Use groff-getopt.h.
	* src/include/Makefile.sub: Updated.

	* configure: Updated.
	* Makefile.in: Updated.

	* NEWS: Mention EBCDIC support.

2000-04-26  Werner LEMBERG  <wl@gnu.org>

	* TODO: Some additions.

2000-04-25  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/troff.man, doc/groff.texinfo: Fixing documentation
	of mso request.

2000-04-23  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/troff.man: Minor fixes.

2000-04-22  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/troff.man, doc/groff.texinfo, NEWS: Document the
	`.T' string register and the incompatible definition of the `.T'
	number register (compared to Unix troff).

	* man/groff_char.man: Add some missing characters.
	* font/devutf8/NOTES: Update.

2000-04-21  Werner LEMBERG  <wl@gnu.org>

	* src/include/htmlindicate.h, src/include/lib.h,
	src/include/posix.h: Fix copyright.

	* src/include/Makefile.sub: Update.

2000-04-20  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/input.cc (input_char_description): Removing
	superfluous space char.

	* tmac/tmac.X: Fix typo \(bq -> \(Bq.

	* doc/groff.texinfo: Document EBCDIC.

2000-04-19  Werner LEMBERG  <wl@gnu.org>

	Introducing `shc' as the glyph name for the soft hyphen character.

	* tmac/tmac.tty, tmac/tmac.latin1, tmac/tmac.html,
	font/devlatin1/R.proto: Use it.

	* NEWS: Updated.

2000-04-18  Werner LEMBERG  <wl@gnu.org>

	* src/devices/grops/ps.cc (ps_printer::flush_sbuf): Removing
	dependency on ASCII order.

2000-04-16  Sandor BARANY  <S.Barany@infosys.tuwien.ac.at>

	* src/libs/libgroff/illegal.c: Added EBCDIC table.
	* src/roff/troff/input.cc: Added adaptation to EBCDIC.

	* src/preproc/refer/refer.cc, src/roff/troff/env.cc: Minor changes
	to increase portability.

2000-04-15  Werner LEMBERG  <wl@gnu.org>

	* aclocal.m4: Added GROFF_EBCDIC and GROFF_OS390 tests.
	Redefined AC_OUTPUT_MAKE_DEFS to replace ASCII character `012' with
	the generic `\n' if under OS/390 Unix.

	* configure.in: Call GROFF_EBCDIC and GROFF_OS390.

	* configure: Regenerated.

2000-04-14  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: More conversions to @Deffn.

2000-04-12  Werner LEMBERG  <wl@gnu.org>

	* tmac/tmac.psfig: Fix incorrect use of `&' operator by replacing it
	with `:'.

	* src/roff/nroff/nroff.man: Add note about tmac.tty-char.

2000-04-10  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: More conversions to @Deffn.

2000-04-08  Werner LEMBERG  <wl@gnu.org>

	* src/libs/libgroff/{getopt.c,getopt1.c}, src/include/getopt.h:
	Updated to latest version (glibc 2.1.3).

2000-04-07  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile (clean): Include more index files.
	Add rule texinfo->dvi.

2000-04-05  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Added new index `op' for operators.  More
	info on end of sentence characters.  More use of @Deffn.

2000-03-30  Werner LEMBERG  <wl@gnu.org>

	* */*.man: Adding a note that a whitespace can be inserted between
	a command line option and its parameter -- we are using GNU getopt.

	* src/roff/groff/groff.man: Add example of `-m mandoc'.

2000-03-28  Werner LEMBERG  <wl@gnu.org>

	Correct anachronism of calling the man macro file with `-man'
	instead of `-m man' etc.

	* tmac/tmac.man, tmac/tmac.mandoc, tmac/tmac.markup, tmac/tmac.mdoc,
	tmac/tmac.me, tmac/tmac.ms: New files tmac.m<package> which simply
	load tmac.<package>.

	* tmac/Makefile.sub: Updated.  Take care of $(tmac_an_prefix) etc.

	* NEWS: Updated.

	* doc/groff.texinfo: Updated.

	* tmac/groff_man.man: Copyright added.

2000-03-27  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Introducing macros `Deffn' and `Defmac' to
	typeset the request resp. escape name with a tt font -- due to a
	bug in texinfo.tex it is necessary to use the `-e' switch with
	texi2dvi.

	Improving info about usage of groff units.

	Other minor fixes.

2000-03-20  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Added section about man macro package
	(I've basically taken groff_man.man).  Introducing new indices `ma'
	for macros/strings and `gl' for glyph names.  Other minor fixes.

	* tmac/groff_man.man: Fixed some typos.

2000-03-19  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Removed all occurrences of `you', `we', etc.
	Other minor fixes.

	* doc/texinfo.tex: New file.

2000-03-18  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Improved section on number registers.  Other
	minor updates.

2000-03-16  Werner LEMBERG  <wl@gnu.org>

	* src/roff/groff/groff.man: Added info about grolbp.  Make nicer
	synopsis.

	* src/devices/grolbp/grolbp.man, src/roff/nroff/nroff.man,
	src/devices/grolj4/grlj4.man, src/devices/grops/grops.man,
	src/preproc/eqn/eqn.man, src/utils/afmtodit/afmtodit.man,
	src/utils/tfmtodit/tfmtodit.man: Make nicer synopsis.

	* src/preproc/grn/grn.man: Better synopsis; added copyright.

	* src/roff/grog/grog.man: Updated copyright date.

2000-03-14  Francisco Andres Verdu  <pandres@dragonet.es>

	* configure.in: Added test for strdup.

	* src/devices/grolbp/lbp.cc: Added a strdup() version in case none
	is available.

	Replaced dynamic allocation of arrays `[...]' with `new' operator.

	Other minor fixes.

2000-03-12  OKAZAKI Tetsurou  <okazaki@be.to>

	* Makefile.comm: Add $(INCLUDES) to $(ALL_CFLAGS).

2000-03-11  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/grn/hdb.cc (DBGetType): Added return value to make
	compilers silent.
	* src/preproc/grn/hgraph.cc: Add #ifdef for hypot().
	* src/include/lib.h: Remove some spaces.

2000-03-10  Werner LEMBERG  <wl@gnu.org>

	* src/libs/libgroff/tmpfile.cc (xtmptemplate, xtmpfile): Removing
	initializers from arguments (some compilers don't like this).

2000-03-09  Gaius Mulley  <gaius@glam.ac.uk>

	* src/libs/libgroff/htmlindicate.cc: Added library file which is now
	used by pic and eqn to tell grohtml where the graphic regions start
	and end.
	* src/libs/libgroff/Makefile.sub: Use it.
	* src/preproc/eqn/main.cc, src/preproc/pic/troff.cc: Altered to use
	graphic_start() and graphic_end() from htmlindicate.cc.

2000-03-09  Werner LEMBERG  <wl@gnu.org>

	* tmac/tmac.safer: Will now work correctly in compatibility mode.
	* tmac/groff_man.man: More fixes.

2000-03-08  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile: Added texput.log to the `clean' target.
	* doc/groff.texinfo: Added info about delimiters for escapes.

2000-03-08  Bernd Warken  <bwarken@mayn.de>

	* src/preproc/pic/pic.man: Add info on conversion of pic images to
	other graphic formats.

2000-03-07  OKAZAKI Tetsurou  <okazaki@be.to>

	* Makefile.in, contrib/mm/Makefile.sub, src/preproc/eqn/Makefile.sub,
	src/roff/groff/Makefile.sub, src/roff/nroff/Makefile.sub,
	src/utils/afmtodit/Makefile.sub: Use $(INSTALL_SCRIPT) for script
	files.

2000-03-07  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Spelling fixes.

2000-03-06  Werner LEMBERG  <wl@gnu.org>

	* tmac/groff_man.man: Completely revised to cover everything in
	tmac.an.

	* doc/groff.texinfo, src/roff/troff/troff.man: Document evc request.
	Other minor fixings.
	* src/roff/troff/env.cc (environment_copy): Improve error message and
	fix itoa->i_to_a.
	* src/roff/troff/TODO: Updated.

	* doc/Makefile: Bug fixes -- this is still provisional, though...

	* tmac/eqnrc: Small fixes.

2000-03-05  Abramo Bagnara <abramo@alsa-project.org>

	Adding a request `evc' to copy environments.

	* src/roff/troff/env.cc (environment::copy, environment_copy):
	Implement it.
	* src/roff/troff/env.h: Add prototype.

2000-03-05  Francisco Andres Verdu  <pandres@dragonet.es>

	Adding strsep() -- Solaris 8 doesn't have it.

	* configure.in: Test it.
	* src/devices/grolbp/lbp.cc: Add code.

2000-03-05  Werner LEMBERG  <wl@gnu.org>

	* src/roff/troff/div.cc (macro_diversion::output,
	top_level_diversion::output): Fixing an incompatibility with
	original troff: \x'0' updates the .a register also.  Thanks to
	<Andries.Brouwer@cwi.nl> for pointing this out.
	* doc/groff.texinfo: Document it.

	* Makefile.in: Create Makefile.dep if necessary before calling the
	submake process to avoid warning about nonexistent file.

	* NEWS, PROJECTS: Updated.

2000-03-04  Werner LEMBERG  <wl@gnu.org>

	* tmac/troffrc: Add tmac.lbp.

2000-03-03  Francisco Andres Verdu  <pandres@dragonet.es>

	* tmac/tmac.lbp: New file.
	* src/devices/grolbp/grolbp.man: Add documentation of `lbpname'
	command.

2000-03-03  Werner LEMBERG  <wl@gnu.org>

	* Makefile.in: Fixing $(subdir).

	* README, NEWS: Small fixes.

	* test-groff: Adding path to grolbp.

	* configure.in: The (new) file src/xditview/Imakefile.in will be
	also configured -- it is now possible to build gxditview in a
	directory different from $srcdir.

2000-03-02  Blake McBride  <blake@florida-software.com>

	* src/libs/libgroff/searchpath.cc (open_file): Adapting to WinNT.

	* MORE.STUFF: Added website of bell labs and info about plot2dev.

2000-03-01  Colin Phipps  <crp22@cam.ac.uk>

	* src/utils/indxbib/indxbib.cc (main): Use mkstemp() for temporary
	files.

2000-02-29  Werner LEMBERG  <wl@gnu.org>

	Adding GNU getopt to the groff distribution.

	* src/include/getopt.h, src/libs/libgroff/{getopt.c,getopt1.c}:
	New files.
	* src/include/Makefile.sub, src/libs/libgroff/Makefile.sub: Update.
	* aclocal.a4: Remove GROFF_GETOPT function.
	* configure.in, Makefile.in, PROBLEMS: Update.
	* src/include/lib.h: Replace getopt tests with getopt.h.
	* src/devices/grolbp/lpb.cc: Remove inclusion of getopt.h.

	* doc/groff.texinfo: Further checking/updating.  Adding more index
	entries.

	* man/groff_out.man: Fix nroff mode activation (for emacs).
	* man/groff_font.man: Add missing ligature.

2000-02-28  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Further checking/updating.  Adding more index
	entries.

	* src/devices/grolbp/grolbp.man: Added a comment line at the
	beginning of the file (similar to shell scripts) which indicates
	that `tbl' should be used as a preprocessor.

2000-02-27  Blake McBride  <blake@florida-software.com>

	Adapting groff to MS Visual C++ 6.0 compiler (tested with
	Windows NT 4.0).  Uses _MSC_VER define where necessary.

	* src/devices/grodvi/dvi.cc: Making stdout a binary stream.
	* src/devices/grolj4/lj4.cc: Making getopt variables `extern "C"'.
	* src/devices/grohtml/html.cc, src/devices/grops/ps.cc,
	src/include/lib.h, src/libs/libgroff/errarg.cc,
	src/libs/libgroff/itoa.c, src/libs/libgroff/nametoindex.cc,
	src/preproc/refer/label.y, src/preproc/refer/label.cc,
	src/roff/groff/pipeline.c, src/roff/troff/column.cc,
	src/roff/troff/div.cc, src/roff/troff/env.cc,
	src/roff/troff/input.cc, src/roff/troff/node.cc,
	src/roff/troff/reg.cc: Renaming itoa() to i_to_a() and iftoa() to
	if_to_a() to avoid name	clashes.
	* src/include/posix.h: Don't use unistd.h.
	* src/libs/libgroff/tmpfile.cc: Use `#ifndef...#else...#endif'
	clause for integrating non-Unix xtmpfile() code.
	* src/roff/troff/input.cc: Adding `public' keyword to macro_header
	structure; use "rt" for popen() in pipe_source(); add getpid()
	dummy function.
	* src/roff/troff/node.cc: Use special versions of popen() in
	real_output_file() and pclose() in ~real_output_file().

2000-02-27  Werner LEMBERG  <wl@gnu.org>

	Adding a new driver, grolbp, for Canon CAPSL printers (LBP-4 and
	LBP-8 series laser printers).  This code has been contributed by
	Francisco Andres Verdu <pandres@dragonet.es>.

	* src/devices/grolbp/*: The grolbp output device.
	* font/devlpb/*: The font description files.
	* Makefile.in: Add grolpb and devlbp subdirectories.

	* src/devices/grodvi/grodvi.man, src/devices/grolj4/grolj4.man,
	src/devices/grotty/grotty.man,src/roff/troff/troff.man: Minor
	typographic fixes.

	* doc/groff.texinfo: Further checking/updating.  Adding more index
	entries.

	* NEWS: Updated.

	* src/devices/grolbp/Makefile.sub: Adding $(srcdir).

	* man/groff_font.man: Adding info about obsolete DESC keywords.
	* src/devices/grolj4/grolj4.man: Documenting additional DESC
	keywords.

2000-02-26  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/grn/grn.man: Added info about the gremlin file format
	(contributed by Daniel Senderowicz <daniel@synchrods.com>).

2000-02-25  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/grn/main.cc: Allow values of `narrow' parameter and
	friends to be non-integer.

	* src/preproc/grn/grn.man: Document it.

	* doc/groff.texinfo: Further checking/updating.  Adding more index
	entries.

2000-02-24  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/grn/main.cc: Introduce BASE_THICKNESS, defining
	line thicknesses to be integer multiples of this value.

	* src/preproc/grn/grn.man: Commenting out the -s option -- the
	corresponding code doesn't work (yet).

	* doc/groff.texinfo: Further checking/updating.  Adding more index
	entries.

2000-02-23  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/grn/{main.cc, hgraph.cc}: Using point units to
	specify line thickness instead of base units.  The new default
	values are now 0.15,pt 0.45pt, and 0.75pt for thin, middle, and
	thick lines respectively.

	Removed unused variable `prevval'.

	* src/preproc/grn/grn.man: Updated.

2000-02-22  Werner LEMBERG  <wl@gnu.org>

	* src/preproc/grn/main.cc: Slight formatting.

	* src/roff/groff/groff.man: Formatting fix.
	* src/preproc/grn/grn.man: Ditto.

	* src/roff/grog/grog.pl: Fixing two embarassing bugs.

	* doc/groff.texinfo: Further checking/updating.

2000-02-21  Werner LEMBERG  <wl@gnu.org>

	* README, INSTALL, PROJECT, PROBLEMS, BUGREPORT: Updated.

	* test-groff: Added grn subdir to path.

	* doc/groff.texinfo: Some restructing and other small improvements.

	* src/roff/groff/groff.cc (help): Fixed info string.

2000-02-20  Werner LEMBERG  <wl@gnu.org>

	* doc/meref.me: Fix description of .GS request.

	* src/roff/troff/troff.man: Fixing typo.

	Adding the `grn' preprocessor for gremlin graphic files.

	* src/preproc/grn/*: This is the Berkeley distribution written by
	David Slattengren and Barry Roitblat, adapted to groff by Daniel
	Senderowicz and Werner Lemberg.

	* doc/grnexampl.{me,g}: A sample for grn.

	* Makefile.in: Added subdirectory entry for grn.

	* src/roff/groff/groff.cc: Added support for grn.  It can be now
	called with the switch `-g'.

	* src/roff/groff/groff.man: Updated.

	* src/roff/grog/grog.{man,pl,sh}: Updated.

	* NEWS: Updated.

2000-02-11  Gaius Mulley  <gaius@glam.ac.uk>

	* src/include/lib.h: Added xtmptemplate and made xtmpfile
	parametrically polymorphic.

	* src/libs/libgroff/tmpfile.cc: Implemented xtmptemplate
	and the alterations to xtmpfile.
	xtmpfile can be requested to return the filename created
	and asked not to unlink the temp file.  The default behaviour
	if parameters are absent is exactly the same as before.

2000-02-11  Abramo Bagnara  <abramo@alsa-project.org>

	A new request `length' is available which returns the length of a
	string in a number register:

	* src/roff/troff/input.cc (length_macro): Implement it.
	* src/roff/troff/input.cc (init_input_requests): Register it.

2000-02-11  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo, src/roff/troff/troff.man: Add documentation
	of the `substring' request.

	* src/roff/troff/troff.man, doc/groff.texinfo: Document `length'
	request.

	* src/roff/troff/TODO, NEWS: Updated.

2000-02-09  Werner LEMBERG  <wl@gnu.org>

	* src/roff/groff/groff.man: Added an example.

2000-02-06  Werner LEMBERG  <wl@gnu.org>

	I've considerably modified the directory structure of the
	distribution to get a more vertical layout.  For example, the number
	of top level directories has been reduced from 42 to 6.

	As a consequence, many changes, especially to the makefiles, were
	necessary:

	* The makefile variables `top_builddir' and `top_srcdir' have been
	introduced.  Virtually all relative paths have been replaced with
	absolute ones using these two variables.

	* Dependencies (in the files `Makefile.dep') are no longer part of
	the distribution.  Instead, they are created during a `make install'
	in the build directory.

	* aclocal.m4 (GROFF_SRCDIR, GROFF_BUILDDIR): Two new functions to
	make `top_srcdir' and `top_builddir' absolute.

	Some other changes:

	* Man pages no depend on the files `VERSION' and `REVISION'.

	* The added shell script `mkinstalldirs' will replace `mkdir' in
	almost all cases.

	* VERSION: Version number increased to 1.16.

2000-02-04  Werner LEMBERG  <wl@gnu.org>

	* grops/psrm.cc (read_one_of): Fixed pointer incrementation.

	* Makefile.in: Removed $(tmac_m) since it is no longer needed
	(after an update of the mm stuff).

	* troff/Makefile.sub (majorminor.cc): Fix dependencies.

2000-02-03  Werner LEMBERG  <wl@gnu.org>

	The .psbb request will now also accept Mac PS images (i.e. using LF
	as the EOL character).

	* troff/input.cc (ps_get_line): New function, taken from psrm.cc
	(with slight modifications).
	* troff/input.cc (do_ps_file): Use it.

	* test-groff: Add grohtml and grolj4 output devices to PATH.

2000-01-30  Werner LEMBERG  <wl@gnu.org>

	* NEWS, MORE.STUFF: Updated.

2000-01-30  Cary D. Renzema  <caryr@dollar.mxim.com>

	Add the `srand' command to pic.

	* pic/lex.cc, pic/pic.y: Implement it.
	* pic/pic.man: Document it.
	* pic/pic.cc, pic/pic.tab.h: Regenerated (with yacc).

2000-01-30  Werner LEMBERG  <wl@gnu.org>

	Add a new request `.psbb'.  This does exactly what the external
	program psbb did.  It scans a PostScript image file for a
	%%BoundingBox comment and extracts the bounding box values (in
	PostScript units) which	are then stored in the four new (read-only)
	number registers `llx', `lly', `urx', and `ury'.

	This will allow the usage of the .PSPIC macro without worrying
	about unsafe behaviour of groff, i.e., it will work without the
	`-U' switch of groff.

	* troff/input.cc: Implement it.
	* tmac/tmac.pspic: Use it.
	* troff/troff.man, grops/grops.man, NEWS: Document it.
	* psbb/*, Makefile.in: Remove it since it is no longer needed.

	This is bloody C code simply adapted from psbb.c!  Any improvements
	welcome.

2000-01-29  Werner LEMBERG  <wl@gnu.org>

	* man/groff_font.man: Minor clarifications.

	* NEWS: Updated.

2000-01-28  Werner LEMBERG  <wl@gnu.org>

	* afmtodit/afmtodit.pl: Use new `--' comment delimiter.

2000-01-28  Gaius Mulley  <gaius@glam.ac.uk>

	* man/groff_font.man: Brought up to date regarding tcommand
	extensions.
	* libgroff/font.cc: Handle everything after `--' as a comment
	in the font files.
	* devps/*: Added comment delimiter inside devps font files.

2000-01-28  Werner LEMBERG  <wl@gnu.org>

	* tmac/tmac.arkup, tmac/groff_markup.man: Replace \fC...\fR with
	\fC...\fP (which now works as expected).

	* troff/troff.man: Fix typo.

2000-01-27  Gaius Mulley  <gaius@glam.ac.uk>

	Completed the pass_filenames implementation in troff.

	* libdriver/input.cc: Will read the new `F' tcommand.
	* troff/node.cc, troff/node.h: Will issue the new `F' tcommand.
	* troff/input.cc: Use it.

2000-01-26  Werner LEMBERG  <wl@gnu.org>

	* troff/env.cc (set_font): Fix the behaviour of \fP.  The previous
	font will now be updated even if an invalid font is selected.

2000-01-24  Werner LEMBERG  <wl@gnu.org>

	* doc/homepage.ms: Updated for new tmac.arkup.

	* tmac/tmac.html: Disable line breaks after hyphen-like characters.

	* tmac/tmac.arkup: Cleanup.

	Added `\&' to .HTML macro to `leave vertical mode', so to say.

	Removed obsolete .LINK macro completely.

	The macros .URL, .FTP, and .MAILTO now accept a third argument which
	will be immediately appended to the second argument (to be used with
	punctuation, for example).

	Disabled .CDFTP macro temporarily for security reasons.

	* tmac/groff_markup.man: Complete revision for latest changes in
	tmac.arkup -- note that it does not yet format correctly with
	grohtml :-(

2000-01-23  Bruno Haible  <haible@clisp.cons.org>

	* nroff/nroff.sh: Accept -Tutf8 option and pass it through.
	* devutf8/R.proto: Add mappings for wp, lh, rh.
	* devutf8/NOTES: Updated.

2000-01-23  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Updated version/copyright info.

2000-01-21  Gaius Mulley  <gaius@glam.ac.uk>

	Added support for two new directives in device descriptions:
	`pass_filenames' (to pass the input file name to the output device)
	and `use_charnames_in_special' (to support e.g. accented characters
	in the `X' request).

	* include/font.h, troff/charinfo.h: Declare it.

	* libgroff/font.cc, libgroff/fontfile.cc: Set it.

	* devhtml/DESC: Use it.

	* troff/input.cc: New function encoded_char.

	* troff/token.h: Add test for `specialness'.

2000-01-21  Werner LEMBERG  <wl@gnu.org>

	* tmac/Makefile.sub: tmac.a4 and tmac.trace have been removed by
	mistake from the list of files to be installed.

2000-01-18  Werner LEMBERG  <wl@gnu.org>

	* README: Added info how to apply patches.

2000-01-15  Jan Echternach  <echter@informatik.uni-rostock.de>

	* troff/node.cc (ligature_note::operator delete):  Fix g++ warning.

2000-01-15  Gaius Mulley  <gaius@glam.ac.uk>

	* troff/input.cc: Add support for troffrc-end.

	* tbl/main.cc: Altered to issue table-start and table-end special
	characters if using the html device.

	* devhtml/*: Modified font files to incorporate html encoding of
	characters.

	* tmac/groff_markup.man: New file documenting tmac.arkup.

	* tmac/troffrc-end: New file.  This is invoked after all user
	specified macros.  Currently used by the html device to	include
	tmac.html.  Thus no need for users to specify -mhtml anymore.

	* tmac/Makefile.sub (NORMALFILES): Add troffrc-end.
	(MAN7): Add groff_markup.man.

	* tmac/tmac.an, tmac/tmac.html: Small html updates.

	* tmac/troffrc: tmac.arkup will now be called for the html device.

	* libgroff/font.cc, libgroff/font.h: Altered to include reading of
	extra device specific information about fonts.

	* doc/homepage.ms: New file.  It is an example how an HTML home page
	could look like with grohtml.

	* doc/Makefile: Add homepage.ms.  Remove rule for pic.html.

2000-01-12  Bruno Haible  <haible@clisp.cons.org>

	* devutf8/R.proto: Add mappings for ti, Fn, st, an.  Change mappings
	of Im, Re.

	* devutf8/NOTES: Updated.

2000-01-08  Bruno Haible  <haible@clisp.cons.org>

	* eqn/box.cc, eqn/lex.cc, eqn/other.cc, eqn/over.cc, eqn/special.cc,
	eqn/text.cc, grodvi/dvi.cc, grops/ps.cc, grops/psrm.cc,
	libbib/index.cc, libbib/linear.cc, libbib/search.cc,
	libdriver/printer.cc, libgroff/font.cc, libgroff/string.cc,
	pic/lex.cc, pic/object.cc, refer/label.y, refer/ref.cc, tbl/main.cc,
	tbl/table.cc, tfmtodit/tfmtodit.cc, troff/dictionary.cc,
	troff/div.cc, troff/env.cc, troff/input.cc, troff/node.cc,
	troff/node.h, troff/reg.cc: Avoid most "g++ -Wall -Wno-sign-compare"
	warnings.

	* troff/node.cc (bracket_node::copy): Initialize last to NULL.

2000-01-12  Fabrizio Polacco  <fab@prosa.it>

	grolj4: Paper size will be searched case-insensitively.

	* include/lib.h: Add check for strcasecmp().
	* grolj4/li4.cc (lookup_paper_size): Use strcasecmp().
	* configure.in: Check for strcasecmp().

2000-01-11  Werner LEMBERG  <wl@gnu.org>

	* troff/Makefile.sub (majorminor.cc): Fix incorrect path to
	`REVISION'.

2000-01-10  Werner LEMBERG  <wl@gnu.org>

	* Makefile.comm, Makefile.in, doc/Makefile: More fixes for the
	revision scheme.

	Add a new read-only register, `.Y', which contains the groff
	revision.

	* troff/input.cc (init_input_requests): Define it.
	* troff/Makefile.sub (majorminor.cc): Define `revision' string.
	* doc/groff.texinfo, troff/troff.man: Document it.

	* libgroff/Makefile.sub (version.cc): Add definition of
	`Version_string[]', consisting of `<major>.<minor>.<revision>'
	* eqn/main.cc, grodvi/dvi.cc, grolj4/lj4.cc, grops/ps.cc,
	grotty/tty.cc, hpftodit/hpftodit.cc, indxbib/indxbib.cc, pic/main.cc,
	refer/refer.cc, soelim/soelim.cc, tbl/main.cc, tfmtodit/tfmtodit.cc,
	troff/input.cc, pfbtops/pfbtops.c: Use it.

2000-01-10  Fabrizio Polacco  <fab@prosa.it>

	Add a revision scheme to the groff package.

	* REVISION: New file.
	* libgroff/Makefile.sub (version.cc): Use it to define
	`revision_string[]'.
	* grops/psrm.cc: Use revision_string (converted to an unsigned
	integer) in constructor of resource_manager.

2000-01-10  Bruno Haible  <haible@clisp.cons.org>

	* devutf8/Makefile.sub, devutf8/DESC.proto, devutf8/R.proto: New
	files.
	* Makefile.in (DEVDIRS): Add devutf8.
	* grotty/tty.cc: Include device.h.
	(glyph): Change type of `code' to `unsigned int'.
	(tty_printer): New field is_utf8.  Constructor takes device argument.
	(tty_printer::tty_printer): If device if `utf8', set is_utf8.
	(tty_printer::add_char): Change type of first arg to `unsigned int'.
	(tty_printer::put_char): New function.
	(tty_printer::end_page): Use put_char() instead of ::putchar().
	(make_printer): Pass device to tty_printer constructor.
	* nroff.sh: Determine default device by calling 'locale'.  As a
	fallback, look at all of $LC_ALL, $LC_CTYPE, $LANG, $LESSCHARSET.
	Recognize UTF-8 locales.
	* tmac/eqnrc: Recognize utf8 like latin1.
	* tmac/troffrc: Device utf8 needs tmac.tty.

2000-01-07  Werner LEMBERG  <wl@gnu.org>

	* tmac/Makefile.sub: tmac.a4 and tmac.trace will now be installed.

2000-01-07  Paul Eggert  <eggert@twinsun.com>

	Add a new predefined writeable number register, `year',
	which contains the current year.

	* doc/groff.texinfo, PROBLEMS, troff/troff.man: Document it.
	* tmac/tmac.s: Use it.
	* troff/input.cc (init_registers): Initialize it.

2000-01-06  Werner LEMBERG  <wl@gnu.org>

	* PROBLEMS: Fixed typo.

2000-01-04  Paul Eggert  <eggert@twinsun.com>

	* PROBLEMS: Add Y2k advice for the yr number register.

2000-01-03  Paul Eggert  <eggert@twinsun.com>

	* doc/groff.texinfo: Fix Y2k bug in documentation of \n(yr.

2000-01-02  Werner LEMBERG  <wl@gnu.org>

	* tmac/tmac.arkup: Slight modification of macros to provide better
	appearance for non-HTML formats.

2000-01-01  Charles Levert  <charles@comm.polymtl.ca>

	* soelim/soelim.cc (include_path_append): realloc(NULL, n)
	does not automatically translate to malloc(n) on all OSes
	(e.g., SunOS) so do it explicitly.  Also, check the returned
	value.

2000-01-01  Werner LEMBERG  <wl@gnu.org>

	* tmac/tmac.arkup: Added .LINE macro.  Some formatting.

	* Makefile.in: Added $(tmac_m) again since the Makefile in `mm'
	expects this variable

2000-01-01  Gaius Mulley <gaius@glam.ac.uk>

	* doc/Makefile: Added instructions to create HTML and text
	versions of some files.

1999-12-31  Werner LEMBERG  <wl@gnu.org>

	* Updated INSTALL.gen.

	* tmac/tmac.arkup: Added fixes so that .FTP and .MAILTO works
	better resp. correctly with non-HTML devices.

Version 1.15 released
=====================

1999-12-28  Werner LEMBERG  <wl@gnu.org>

	* NEWS, VERSION: Changed to 1.15

1999-12-27  Paul Eggert  <eggert@twinsun.com>

	* nroff/nroff.man: -S is safer, not safe.

	* groff/groff.cc (main): Use `safer', not `safe', in variable
	names.  This does not change the behavior.

	* troff/input.cc (main): Likewise.

	* nroff/nroff.sh: Likewise.

	* troff/input.cc (prepend_string): New function.
	(main): Prepend -msafer, so that we check macro libraries for
	safety.

	* PROBLEMS: Report problem with Sun C++ 5.0 and 5.1.

Version 1.14 released
=====================

1999-12-26  Werner LEMBERG  <wl@gnu.org>

	* NEWS, VERSION: Changed to 1.14.

1999-12-24  Werner LEMBERG  <wl@gnu.org>

	* refer/refer.cc: Fixing the last fix.

Version 1.13 released
=====================

1999-12-23  Werner LEMBERG  <wl@gnu.org>

	* tmac/tmac.an: A typo (`.if' instead of `.ie') made the page
	number disappear.

	* NEWS: Updated.

	* tmac/tmac.safer: Forgot to remove `so' from the `rm' request.

	* VERSION: Changed to 1.13 -- to be compliant with the Adobe 3.0
	document conventions, the version number must be a real.

Version 1.12.1 released
=======================

1999-12-22  Werner LEMBERG  <wl@gnu.org>

	* VERSION: Changed to 1.12.1.

1999-12-22  Alan Rooks  <arooks@istar.ca>

	* refer/refer.cc (do_file): Slight modification to satisfy the
	`Standard system CC - C++ Compilation System 3.1 03/03/99' on SCO
	UnixWare 7.1.

1999-12-20  Werner LEMBERG  <wl@gnu.org>

	* changed prep.ai.mit.edu -> ftp.gnu.org; updated copyright
	notices.

	* tmac/tmac.safer, tmac/groff_msafer.man: Remove `so' (again) from
	list of unsafe requests.

	* pic/pic.man: Fixed a typo.

	* man/groff_out.man: Fixed a typo.

1999-12-18  Werner LEMBERG  <wl@gnu.org>

	* Makefile.in: Doc fixes.

1999-12-17  Fabrizio Polacco  <fab@prosa.it>

	* groff/groff.cc: Missing `U' option added to getopt().

	* troff/troff.man: Missing `U' option added to synopsis.

Version 1.12 released
=====================

1999-12-14  Werner LEMBERG  <wl@gnu.org>

	* troff/input.cc (usage), groff/groff.cc (synopsis): Added -U flag
	to the synopsis.

	* nroff/nroff.sh, nroff/nroff.man: Replaced `secure', `unsecure'
	with the more appropriate terms `safer' and `unsafe'.

	* libgroff/strerror.c, aclocal.m4, configure.in: Added checks for
	sys_nerr and sys_errlist[].

	* pic/pic.h, aclocal.m4, configure.in: Added check for hypot().

	* pic/pic.y, pic/pic.cc: Added check for fmod().

1999-12-13  Werner LEMBERG  <wl@gnu.org>

	* VERSION: Changed to 1.12.

	Here some patches from various sources; most of them taken from
	the Debian distribution.

	* tmac/groff_mdoc.man, tmac/groff_mdoc.samples.man,
	tmac/Makefile.sub: New files copied directly from the NetBSD
	distribution.  Probably, some additional adaptation later on is
	necessary...

	* tmac/tmac.safer, tmac/groff_msafer.man: Added `so' to the list
	of unsafe requests.

	* groff/groff.cc, groff/groff.man, nroff/nroff.sh,
	nroff/nroff.man, pic/main.cc, pic/pic.man, troff/input.cc,
	troff/troff.man: Added option `-U' for unsafe mode.  Safe mode
	(`-S') is now the default.

	* README, NEWS: Updated.

1999-12-09  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Regenerated nodes and menus with emacs.

	* doc/Makefile (clean): Added cleaning commands for groff.texinfo.

1999-12-06  Werner LEMBERG  <wl@gnu.org>

	* configure.in: Removed AC_PREFIX_PROGRAM since it causes more
	grief than relief today.  Additionally, it is against the GNU
	coding standards.

	* configure: Recreated.

1999-12-05  Werner LEMBERG  <wl@gnu.org>

	* configure.in: Added GROFF_LIBM.

	* configure: Recreated.

	* aclocal.m4 (GROFF_LIBM): New function which tests whether -lm is
	necessary.

	* Makefile.in: Added definition of $(LIBM).

	* Makefile.comm (LIBM): Removed.

	* pfbtops/Makefile.sub: On AIX, -lm is needed also.

1999-12-03  Gaius Mulley <gaius@glam.ac.uk>

	* doc/Makefile: Added rule for generation pic.html.

	(clean): Files produced by grohtml will be removed also.

	* doc/pic.ms: Small fix.

	* tmac/tmac.html: Fixed suppression of headers.

1999-11-16  Gaius Mulley <gaius@glam.ac.uk>

	* tmac/tmac.html: Fixing horizontal arrows.

	Turning off hyphenation.

	* tmac/tmac.an: Improved support for grohtml; better indentation,
	no footers/headers.

1999-10-31  Gaius Mulley <gaius@glam.ac.uk>

	* tmac/tmac.arkup: Added CDFTP macro

	* tmac/tmac.html: All headers are turned off for ms, me, and mm
	macros.

	* tmac/troffrc: Some additions for HTML stuff.

1999-10-06  Gaius Mulley <gaius@glam.ac.uk>

	* tmac/tmac.html: Small changes.

1999-09-26  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: Minor fixes.

1999-09-26  Gaius Mulley <gaius@glam.ac.uk>

	* devhtml/TR: Changed spacewidth to 3.

	* tmac/Makefile.sub (NORMALFILES): Added tmac.arkup.

	* tmac/tmac.html: Moved markup macros to tmap.arkup.

	* tmac/tmac.arkup: New file.

	* grohtml/ChangeLog: New file.

1999-09-16  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo (Common Features): Added Copying chapter.
	Changed format to @smallbook.

1999-09-15  Werner LEMBERG  <wl@gnu.org>

	* NEWS: Added info about groff.texinfo.

	* doc/groff.texinfo: Will now compile (using texi2dvi) without
	warning messages.

1999-09-14  Werner LEMBERG  <wl@gnu.org>

	* groff/groff.man: More updates.

1999-09-13  Werner LEMBERG  <wl@gnu.org>

	* doc/groff.texinfo: New file.  This manual is still very
	rudimentary.  It has been originally contributed by Trent
	A. Fisher <trent@gnurd.portland.or.us> with first corrections and
	additions by me.

	* INSTALL: Added information about the `doc' subdir

	* troff/troff.man: Minor fixes.

	* groff/groff.man: Added missing `-L arg' to SYNOPSIS section;
	reordered options.

	* troff/input.cc (usage): Added missing `-ffam' to usage message.

	* Makefile.in (dist): groff-$(version).tar.gz must be removed
	also, otherwise it is included itself in another call of `make
	dist'.

	* groff/groff.cc (synopsis): Removed superfluous space.

	* PROJECTS, PROBLEMS, NEWS: Updated.

	* xditview/Makefile: Removed.

	* VERSION: Updated to 1.12beta.

	* BUG-REPORT: Some cosmetic fixes.  Corrected email address.

	* README: Updated: Included documentation about CVS repository,
	mailing lists, and daily snapshots.

	* tmac/Makefile.sub: Fixed $(tmap_wrap) finally.

1999-09-12  Bjarni Ingi Gislason  <bjarniig@rhi.hi.is>

	* tmac/tmac.an: If the tag didn't fit into the space that the
	macro `TP' specifies, the rest of the tag went into the space for
	the next line.

1999-09-12  Jeffrey Copeland  <jeff@opennt.com> 

	* grolj4/lj4.cc: Added duplex printing (option `-d').

	* grolj4/grolj4.man: Document duplex printing.

1999-09-12  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile (pic.ps): Fixed rule which caused problems with
	non-GNUish sed programs.

	* tmac/doc-syms: Removed extra space from -iso8802-3 macro
	definition.

	* configure.in (LIBS): Added `-lc'

	* Makefile.comm (.man.n): Added substitution for @TMAC_AN_PREFIX@.

	* pic/tex.cc (solid_arc): Casting M_PI to double.

	* libgroff/putenv.c (putenv): Changed function header to ANSI C.

	* groff/groff.man, tmac/Makefile.sub (MAN7), tmac/groff_msafer.man
	(new file), tmac/msafer.man (deleted), tmac/groff_me.man (new
	file), tmac/me.man (deleted): {me,msafer} -> groff_{me,msafer}.

	* groff/groff_man.man: New file.  This manual page was originally
	written for the Debian GNU/Linux system by Susan G. Kleinmann
	<sgk@debian.org>.

	* eqn/list.cc (list_box::compute_metrics,
	list_box::compute_sublist_width): Removed variable declaration to
	avoid shadowing warnings.

	* grops/psrm.cc (resource_manager::process_file): Ditto.

	* tfmtodit/tfmtodit.cc (main): Ditto.

	* libgroff/font.cc (font::load_desc): Renamed auxiliary variable
	to avoid shadowing warnings.

	* tbl/table.cc (block_entry::do_divert, table::do_row): Renamed
	shadowing loop variable.

	* groff/groff.man, troff/troff.man: Added doc about grohtml.

1999-09-12  Gaius Mulley  <gaius@glam.ac.uk>

	New grohtml frontend to convert groff input to html.

	* Makefile.in (CCPROGDIRS, DEVDIRS): Added html device.

	* tmac/Makefile.sub (NORMALFILES): Added tmac.html.

	* tmac/eqnrc: Added html device.

	* tmac/tmac.html: New file.

	* eqn/main.cc (do_file, inline_equation), pic/troff.cc
	(troff_output::start_picture, troff_output::finish_picture),
	tbl/main.cc (process_input_file):
	Surrounded output with `graphics_start' and `graphics_end' so that
	the html driver can identify non-text portions.

	* grodvi/dvi.cc (dvi_printer::set_char), grolj4/lj4.cc
	(lj4_printer::set_char), grops/ps.cc (ps_printer::set_char),
	grotty/tty.ps (tty_printer::set_char): Additional parameter
	`name'.

	* include/printer.h: Class printer: New function
	set_char_and_width; new variables (is_char_named, is_named_set,
	named_command, named_char_s, named_char_n) to hold information
	about named characters -- needed by the html driver.

	* libdriver/printer.cc (printer::set_ascii_char,
	printer::set_special_char): Use set_char_and_width.

	* devhtml/*: New device files for html driver.

	* grohtml/*: New driver grohtml.

1999-09-11  Wilfredo Sanchez  <wsanchez@apple.com>

	* tmac/doc-common, tmac/tmac.an: Removed the word `UNIX' in
	default strings.

1999-09-11  Luke Mewburn  <lukem@netbsd.org>

	* libgroff/string.cc (search): Small fix to test against NULL
	pointer.

1999-09-11  Jeff Conrad  <jeff_conrad@msn.com>

	* troff/node.cc (copy): The characters in a bracket escape (e.g.,
	\b'abc') were stacked in reverse order when processed in a
	diversion.

	* troff/node.h: Added `*last' to struct `node' to make the above
	fix work.

	* troff/input.cc (read_draw_node), libdriver/input.cc (do_file):
	The default scale for the 'f' and 't' graphics functions were 'm'
	rather than 'u' (i.e., no scaling).

1999-09-11  Peter Miller  <peterm@jna.com.au>

	* groff/groff.cc (main), groff.man, soelim/soelim.cc (main,
	do_file), soelim/soelim.man: Added `-I file' option to soelim,
	defining include paths.

	* soelim/soelim.cc (include_path_append): New function.

1999-09-11  Larry Jones  <larry.jones@sdrc.com>

	* tbl/main.cc (process_options): Unix (at least Documenter's
	Workbench) tbl allows arbitrary non-alpha characters between
	options.

1999-09-11  Paul Eggert  <eggert@twinsun.com>

	Y2k fixes.  Don't assume that the current year precedes 2000.

	* doc/meref.me: Add \n(y2, \n(y4.

	* tmac/doc-common (Yr): New number register.
	(Dd): Don't assume current year precedes 2000.

	* tmac/tmac.e (td): Likewise.
	(y2, y4): New number registers.

	* pic/pic.man: Update reference for pic paper to May, 1991
	version.

1999-09-11  Werner LEMBERG  <wl@gnu.org>

	* tmac/Makefile.sub (install_data, stamp-wrap, uninstall_sub):
	Removed quotation marks which prevented correct expansion of
	$(tmac_wrap).

	* devlj4/Makefile.sub (LJ4RES): Fixed value (600 instead of 300).

1999-09-10  Werner LEMBERG  <wl@gnu.org>

	* Makefile.sub (DISTCLEANFILES): Added `config.log' and
	`config.cache'.

	* Removed configure.old.

1999-08-31  Werner LEMBERG  <wl@gnu.org>

	* VERSION: Updated to 1.11.1

1999-05-27  Werner LEMBERG  <wl@gnu.org>

	* doc/Makefile: changed `.PS' postfix to `.ps' for consistency.

	* tmac/Makefile.sub (install_data, stamp-wrap, uninstall_sub):
	added quotations around $(tmac_wrap) to avoid syntax error if
	variable is empty.

	* configure: Newly generated using autoconf 2.13.

	* Makefile.in (LDFLAGS): Set variable to @LDFLAGS@.

Fri Aug 15 08:51:47 1997  Eric S. Raymond  <esr@snark.thyrsus.com>

	* README, PROJECTS, NEWS, INSTALL, VERSION, 
	doc/Makefile. doc/pic.ms, groff/groff.man:
	Prepare for 1.11 release.  No code changes.
  	Documentation for pic added (doc/pic.ms).

Sun Nov 26 11:45:13 1995  James Clark  <jjc@jclark.com>

	* Version 1.10 released.

Fri Nov 24 09:56:16 1995  James Clark  <jjc@jclark.com>

	* afmtodit/afmtodit.pl: Avoid comment on first line.

Mon Nov 20 11:13:49 1995  James Clark  <jjc@jclark.com>

	* aclocal.m4 (GROFF_INSTALL_SH): New macro.
	* configure.in: Call it.

	* Makefile.sub (configure): Depends on aclocal.m4 not acgroff.m4.
	(distfiles): Doesn't depend on config.log or config.cache.

Sun Oct  1 08:45:36 1995  James Clark  <jjc@jclark.com>

	* grog/grog.sh: Use print "" rather than print in END rule.

Wed Aug 23 13:30:52 1995  James Clark  <jjc@jclark.com>

	* tbl/main.cc (process_data): Don't give error for excess data
	entries that are comments.

Fri Jul 28 11:00:27 1995  James Clark  <jjc@jclark.com>

	* tbl/main.cc (process_data): Fix case where new for-scope rules
	silently change meaning of code.

Tue Jul  4 23:39:51 1995  James Clark  <jjc@jclark.com>

	* troff/env.cc (hyphenate): Loop over all consecutive sequences
	of non-zero hyphenation codes.

Sat Jul  1 00:42:15 1995  James Clark  <jjc@jclark.com>

	* aclocal.m4 (GROFF_POSIX): Use conflicting declaration technique.

Thu Jun 29 13:58:36 1995  James Clark  <jjc@jclark.com>

	* tmac/tmac.e (ip): Divert the tag so as to freeze the spaces.

Tue Jun 27 12:30:16 1995  James Clark  <jjc@jclark.com>

	* tmac/tmac.andoc: Make it work in compatibility mode.

	* refer/token.h (token_info::is_range_sep): New function.
	* refer/token.cc (init_special_chars): Make \(en a RANGE_SEP.
	* refer/ref.cc (reference::output): More sophisticated check for
	multiple pages.

	* devps/prologue.ps (MANUAL): New procedure.
	* grops/ps.cc (main): New -m option.
	(usage): Include -m.
	(ps_printer::~ps_printer): Implement -m.

	* aclocal.m4 (GROFF_G): New macro.
	* configure.in: Call it.
	* Makefile.in (g): Provided by configure.

	* hpftodit/hpftodit.cc (basename): Rename to xbasename.

	* tmac/tmac.tty: Disable warning about bad fonts.  Remove font
	translations.

	* Makefile.in (tmacpath): Don't include /usr/lib/tmac.
	(tmac_m, tmac_s): Deleted.
	(sys_tmac_prefix, tmac_wrap, tmac_prefix, tmac_an_prefix,
	tmac_s_prefix): New variables.
	(MDEFINES): Change accordingly.
	* Makefile.comm (.man.n): Use new TMAC_* variables.
	* configure.in (GROFF_TMAC): Call.
	* aclocal.m4 (GROFF_TMAC): Define.
	* tmac/Makefile.sub (stamp_wrap): New target.
	(install_data, uninstall_sub): Handle macro wrapping.

Mon Jun 26 14:54:39 1995  James Clark  <jjc@jclark.com>

	* tbl/main.cc (main): Ignore -T option.

Thu Jun 22 09:08:06 1995  James Clark  <jjc@jclark.com>

	* devlj4/generate/special.map: Add definition of \(nb.

	* tmac/tmac.dvi: Add definition of \(nb.

	* troff/dictionary.c (dictionary::dictionary): association::v gets
	initialized by association::association.

	* tmac/Makefile.sub: Avoid using temporary files when installing.

	* troff/env.cc (environment::set_font): Make bad font number a
	warning.

	* Makefile.in (fontpath): Remove $(prefix)/lib/font from fontpath.

	* Makefile.in (datadir): Use share rather than lib.

	* groff/groff.cc (basename): Rename to xbasename.

Wed Jun 21 16:59:46 1995  James Clark  <jjc@jclark.com>

	* Makefile (CCLIBS): Don't use.
	* Makefile.ccpg: Likewise.

	* acgroff.m4: Rename to...
	* aclocal.m4: Modify extensively for autoconf 2.
	* configure.in: Likewise.
	* Makefile.in: Likewise.

	* groff/pipeline.c (const): Declare as empty if __STDC__ not
	defined.
	(xstrsignal): Check for definition of NSIG. Conditionalize
	on SYS_SIGLIST_DECLARED.  Make return type const.

Sat Jun 10 12:28:16 1995  James Clark  <jjc@jclark.com>

	* troff/input.cc (interpolate_macro): Rephrase missing space
	warning.

Thu May 11 01:07:16 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

	* addftinfo/addftinfo.cc, eqn/delim.cc, eqn/lex.cc, eqn/list.cc,
	grodvi/dvi.cc, groff/groff.cc, grops/ps.cc, grops/psrm.cc,
	grotty/tty.cc, include/ptable.h indxbib/indxbib.cc,
	libbib/index.cc, libbib/linear.cc, libbib/search.cc,
	libdriver/input.cc, libdriver/printer.cc, libgroff/font.cc,
	libgroff/lf.cc, libgroff/nametoindex.cc, libgroff/ptable.cc,
	libgroff/string.cc, lkbib/lkbib.cc, lookbib/lookbib.cc,
	pic/lex.cc, pic/object.cc, pic/pic.y refer/label.y refer/ref.cc,
	refer/refer.cc, refer/token.cc, tbl/main.cc, tbl/table.cc,
	tfmtodit/tfmtodit.cc, troff/dictionary.cc, troff/div.cc,
	troff/env.cc, troff/input.cc, troff/node.cc, troff/symbol.cc:
	Fix 'for' scoping.

Wed Apr 19 21:15:11 1995  James Clark  <jjc@jclark.com>

	* troff/input.cc (spring_trap): Push a macro_iterator rather than a
	string_iterator.
	(spring_trap, postpone_traps, unpostpone_traps): Move to later in
	file.
	(macro_iterator::macro_iterator): Add additional argument.

Mon Apr 10 12:06:02 1995  James Clark  <jjc@jclark.com>

	* troff/div.cc (vertical_size::vertical_size): In place of integer
	specifying line spacing use cunits specifying post vertical
	space.
	(macro_diversion::output, top_level_diversion::output): Likewise.
	* troff/div.h: Change declarations accordingly.
	* troff/env.cc (pending_output_line): Replace ls field by post_vs
	field.
	(pending_output_line::pending_output_line,
	pending_output_line::output, environment::output,
	environment::output_line, environment::output_title,
	environment::hyphenate_line):  In place of
	integer specifying line spacing use cunits specifying post vertical
	space.
	(environment::environment): Add post_vertical_spacing and
	prev_post_vertical_spacing arguments.
	(environment::get_post_vertical_spacing): New function.
	(environment::total_post_vertical_spacing): New function.
	(environment::post_vertical_spacing): New function.
	(init_env_requests): Initialize pvs request and .pvs register.
	* troff/env.h: Change declarations.

Tue Mar 28 09:52:07 1995  James Clark  <jjc@jclark.com>

	* tmac/tmac.pspic: Immediately remove the temporary file.

Sat Mar 25 10:43:11 1995  James Clark  <jjc@jclark.com>

	* tmac/tmac.pspic (PSPIC): Scale graphic uniformly even when
	height is specified.

Thu Jan 26 16:20:13 1995  James Clark  <jjc@jclark.com>

	* tbl/table.c (struct vertical rule, class table_entry): Use int
	not short for start_row and end_row.

Fri Jan 13 13:53:05 1995  James Clark  <jjc@jclark.com>

	* troff/input.cc (trapping_blank_line, blank_line_macro): New
	functions.
	(diverted_space_node::reread, process_input_stack): Call
	trapping_blank_line() rather than blank_line().
	(init_input_requests): Bind "blm" to blank_line_macro().

	* tmac/tmac.s (XA): Use .br and par@reset rather than XA.

Tue Jan 10 11:40:35 1995  James Clark  <jjc@jclark.com>

	* troff/env.cc (environment::possibly_break_line): Require that
	width total excluding width of final space node be greater than
	the target text length.

Tue Jan  3 09:13:37 1995  James Clark  <jjc@jclark.com>

	* troff/node.cc (kern_pair_node::vertical_extent): New function.

Sun Dec  4 13:19:07 1994  James Clark  <jjc@jclark.com>

	* troff/node.cc (charinfo_node): New class.
	(glyph_node, composite_node): Derive from charinfo_node.  Change
	member functions accordingly.

Wed Nov 30 10:29:29 1994  James Clark  <jjc@jclark.com>

	* nroff/nroff.sh: Use -Tlatin1 not -TLatin1.

Mon Aug  8 10:17:59 1994  James Clark  (jjc@jclark.com)

	* tmac/tmac.tty-char: Add definitions for \(ab and \[arrowvertex].

	* devps/generate/textmap (notsubset): Add.

	* tmac/tmac.a4: New file.

Sun Jul 24 20:08:42 1994  James Clark  (jjc@jclark.com)

	* pic/main.cc (had_parse_error): New variable.
	(do_picture, do_whole_file): Set had_parse_error if yyparse()
	returns non-zero.
	(main): Return 1 if had_parse_error is true.

Tue Jul 19 13:40:31 1994  James Clark  (jjc@jclark.com)

	* grolj4/lj4.cc (main): Avoid use of strtoul.

Mon Jul 18 15:03:02 1994  James Clark  (jjc@jclark.com)

	* nroff/nroff.sh: Default device is -Tlatin1 if $LC_CTYPE is
	iso_8859_1 or $LESSCHARSET is latin1.

Sun Jul 10 13:38:35 1994  James Clark  (jjc@jclark.com)

	* hpftodit: New directory.
	* Makefile.in (CCPROGDIRS): Add hpftodit.
	* devlj4/generate: New directory.

Thu Jul  7 23:49:48 1994  James Clark  (jjc@jclark.com)

	* configure.in: Don't use AC_VFORK.
	* groff/pipeline.c (run_pipeline): Use fork() always.

Wed Jul  6 11:13:17 1994  James Clark  (jjc@jclark.com)

	* grops/ps.cc (main): Use %1 not %s in error message for -w.

	* Makefile.in (CCPROGDIRS): Add grolj4.
	(DEVDIRS): Add devlj4.
	* grolj4, devlj4: New directories.
	* tmac/troffrc: Handle lj4.
	* tmac/tmac.lj4: New file.

Fri Jun 17 18:02:53 1994  James Clark  (jjc@jclark.com)

	* tmac/tmac.e (@n): Set indent to 0 before calling |h.

Wed Jun  1 07:33:47 1994  James Clark  (jjc@jclark.com)

	* troff/input.cc (do_if_request): At end of second string, switch
	environments before getting next token.

Fri May 20 07:39:18 1994  James Clark  (jjc@jclark.com)

	* devps/psstrip.sed: Split rule that strips whitespace on either
	side of delimiters.

Wed May 18 08:13:47 1994  James Clark  (jjc@jclark.com)

	* troff/node.h (font_family::make_definition): Add return value to
	declaration.  * troff/symbol.h (symbol::operator==,
	symbol::operator!=): Likewise.

Tue May 17 20:46:06 1994  James Clark  (jjc@jclark.com)

	* groff/groff.cc (main, help, synopsis): Handle -S.
	(possible_command::insert_arg): New function.

	* tmac/tmac.safer: New file.
	* tmac/msafer.man: New file.
	* tmac/Makefile.sub (FILES): Add tmac.safer and msafer.man.

Thu Mar 10 01:58:30 1994  Paul Eggert  (eggert@twinsun.com)

	* pic/pic.h, pic/main.cc (safer_flag): New variable.
	* pic/pic.y (placeless_element): Avoid unsafe operations if
	`safer_flag' is set.
	* pic/main.cc (main): Add -S option, which sets `safer_flag'.

Tue May 10 13:02:31 1994  James Clark  (jjc@jclark.com)

	* eqn/lex.cc (get_token): Put call to add_context() in block to
	work around Sun C++ 4.0 bug.

	* include/stringclass.h (operator +): Use ?: instead of `if' to
	work around Sun C++ 4.0 bug.

Thu May  5 11:18:03 1994  James Clark  (jjc@jclark.com)

	* tbl/main.cc (process_format): Accept - as a synonym for the _
	key letter.

	* libbib/index.cc (minus_one): Don't declare as const.

Fri Apr 29 09:32:48 1994  James Clark  (jjc@jclark.com)

	* troff/input.cc (get_char_for_escape_name): Push back a newline.

Wed Apr 27 21:14:18 1994  James Clark  (jjc@jclark.com)

	* troff/input.cc (write_macro_request): New function.
	(init_input_requests): Bind write_macro_request to writem.

Sun Apr 17 11:15:38 1994  James Clark  (jjc@jclark.com)

	* tmac/tmac.s (@EN): Turn filling back on even if there was no
	equation.

	* eqn/lex.cc (do_space): Supply missing argument to lex_error.

	* tmac/tmac.s (@TS): Renamed from TS.
	(TS): Call LP then TS again.
	(cov*ab-init): Alias @TS to TS.

	* tmac/tmac.s: Allow QP or RS to initialize.

	* tmac/tmac.s (par@load-init): New macro.  Call at end of file.
	Move initializations of PS and LL here.
	(par@init): Don't initialize HY.  Avoid changing environment 0.
	(par*env-init): Don't all par@reset.

Thu Apr 14 19:15:45 1994  James Clark  (jjc@jclark.com)

	* include/posix.h: Include <fcntl.h> only if not using <osfcn.h>.

Sun Apr 10 09:54:44 1994  James Clark  (jjc@jclark.com)

	* Makefile.in (MDEFINES): Add LDFLAGS.
	(LDFLAGS): Add definition line.

Thu Apr  7 22:22:22 1994  James Clark  (jjc@jclark.com)

	* troff/input.cc (get_optional_char): Split off error check into...
	(check_missing_character): New function.
	* troff/token.h: Declare it.
	* troff/env.cc (margin_character): Don't call get_optional_char.
	Only call tok.next() after making the node.

	* include/lib.h (getopt): Make 2nd argument char *const *.

Fri Mar 11 07:28:03 1994  James Clark  (jjc@jclark.com)

	* nroff/conftest.sh: Deleted.

Fri Mar  4 10:51:36 1994  James Clark  (jjc@jclark.com)

	* pic/make-dos-dist: Deleted.

Wed Mar  2 20:59:16 1994  James Clark  (jjc@jclark.com)

	* devps/psstrip.sed: Strip comments before stripping trailing
	white space.

Sat Feb 19 13:07:16 1994  James Clark  (jjc@jclark.com)

	* Version 1.09 released.

Wed Feb 16 16:53:49 1994  James Clark  (jjc@jclark.com)

	* tmac/doc-ditroff (hK): Don't reset page number if \nC is > 0.

Mon Feb 14 08:26:40 1994  James Clark  (jjc@jclark.com)

	* libgroff/font.cc (font::load_desc): Fix typo in error message.

Sun Feb 13 09:37:38 1994  James Clark  (jjc@jclark.com)

	* libgroff/new.cc (operator new): Rewrite so as to avoid warning
	about returning without a value.

	* troff/charinfo.h (charinfo::get_special_translation): Cast
	TRANSLATE_NONE to int.

	* refer/token.cc (lookup_token, store_token): Remove bogus loop
	test.  Fix test so that it works with n unsigned.

	* pic/pic.y (defaults_table): Fully bracket initializer.
	* pic/lex.cc (lookup_keyword): Likewise.
	* eqn/lex.cc (token_table, def_table): Likewise.
	* eqn/box.cc (param_table): Likewise.
	* troff/input.cc (warning_table): Likewise.
	* libgroff/font.cc (table): Likewise.
	* grops/ps.cc (ps_printer::special): Likewise.
	* grops/psrm.cc (resource_manager::process_file): Likewise.
	* tfmtodit/tfmtodit.cc (lig_chars, lig_table): Likewise.
	* refer/command.cc (command_table): Likewise.
	* addftinfo/addftinfo.cc (param_table): Likewise.

	* troff/symbol.cc (symbol::symbol): Prevent compiler warnings
	about temp's being unused.
	(unused): New function.

	* groff/pipeline.cc: Declare c_fatal.

	* libbib/linear.cc (bmpattern::search): Cast patterrn[--j] to
	uchar.

	* libbib/index.cc (index_search_item::load): Prevent compiler
	warnings about fd_closer's being unused.
	(unused): New function.

Sat Feb 12 10:31:59 1994  James Clark  (jjc@jclark.com)

	* troff/input.cc (copy_mode_error): Make `prefix' static.
	Fix typo.

	* include/posix.h: Include <osfcn.h> is HAVE_CC_OSFCN_H is
	defined.
	* acgroff.m4, configure.in, Makefile: Rename HAVE_CC_UNISTD_H to
	HAVE_CC_OSFCN_H and modify accordingly.

	* troff/input.cc (init_charset_table): radicalex overlaps
	horizontally.

	* groff/acgroff.m4 (GROFF_ISC_SYSV3): New macro (from
	udodo!hans@relay.NL.net).
	* groff/configure.in: Call it.

	* groff/acgroff.m4 (GROFF_PCLOSE): New macro.
	* groff/configure.in: Call it.
	* include/lib.h: Conditionalize declaration of pclose.

	* troff/div.cc (last_page_number): New global variable.
	(top_level_diversion::begin_page): Exit if we just printed the
	last page.
	* troff/div.h (last_page_number): Declare it.
	* troff/input.cc (parse_output_page_list): Set last_page_number.

	* eqn/sqrt.cc: Rename \(rn to \[radicalex].
	* devps/S, devps/textmap, tmac/tmac.ps, tmac/tmac.dvi,
	tmac/tmac.X: Likewise.
	* tmac/tmac.ps, tmac/tmac.X, tmac.dvi: Add definitions of \(rn.
	* tmac.dvi: Make \(ru and \(ul extend beyond their width by .04m.

Fri Feb 11 11:45:40 1994  James Clark  (jjc@jclark.com)

	* tmac/doc-ditroff (hK): Remove groff specific code which
	prevented page-breaks between separate manual entries.  If this is
	the first page, don't set the page number to 1.

	* acgroff.m4 (GROFF_POSIX): New macro.
	* configure.in: Use it.

	* troff/node.cc (class real_output_file,
	real_output_file::real_output_file,
	real_output_file::~real_output_file): Conditionalize use of
	popen/pclose on POPEN_MISSING.
	* troff/node.h: Conditionalize pipe_command on POPEN_MISSING.
	* troff/input.cc (pipe_command): Give an error if POPEN_MISSING.
	(pipe_source): Similarily.

	* acgroff.m4 (GROFF_PROG_CCC): Update message about libg++.

	* acgroff.m4 (GROFF_GETOPT, GROFF_PUTENV, GROFF_POPEN): Detect
	presence of declarations by trying to compile example with
	conflicting declarations.  (gcc only gives a warning for missing
	declarations.)

Wed Feb  9 09:12:23 1994  James Clark  (jjc@jclark.com)

	* tmac/tmac.pspic (PSPIC): Allow options to specify alignment
	(from Ulrich Lauther).

Tue Feb  8 03:56:40 1994  James Clark  (jjc@jclark.com)

	* libbib/linear.cc (file_buffer::load): Use S_ISREG macro.

Thu Feb  3 09:34:35 1994  James Clark  (jjc@jclark.com)

	* indxbib/indxbib.cc (write_hash_table): Add code for case where
	pointers and ints have different sizes.

Sun Jan  9 16:17:51 1994  James Clark  (jjc@jclark.com)

	* tmac/tmac.s (par*env-init): Call par@reset.

Fri Jan  7 10:24:27 1994  James Clark  (jjc@jclark.com)

	* tmac/tmac.s (@IP): Switch to a new environment when diverting
	tag.
	(par*push-tag-env, par*pop-tag-env): New macros.

Wed Jan  5 21:18:34 1994  James Clark  (jjc@jclark.com)

	* grops/ps.cc (ps_printer::ps_printer): Use MAX_LINE_LENGTH for
	initializing `out'.  Reduce MAX_LINE_LENGTH from 79 to 72.

	* grops/ps.cc (ps_printer::~ps_printer): Output %%CreationDate
	comment.  Include <time.h>.

Wed Dec 15 14:14:00 1993  James Clark  (jjc@jclark.com)

	* grops/ps.cc (is_small_h, is_small_v): Deleted.
	(ps_printer::flush_sbuf): Use absolute motion only at beginning of
	lines.

Tue Dec 14 10:06:34 1993  James Clark  (jjc@jclark.com)

	* troff/input.cc (read_request): Only print a prompt if reading
	from the terminal.  Also clearerr on EOF if reading from the
	terminal.  Declare isatty.

Mon Nov 29 08:38:15 1993  James Clark  (jjc@jclark.com)

	* refer/label.y: Rename map_t to map_func and extractor_t to
	extractor_func.

Sat Oct 30 06:38:12 1993  James Clark  (jjc@jclark.com)

	* include/assert.h: Don't use volatile.
	* libgroff/assert.cc: Likewise.

Fri Oct 29 15:00:23 1993  James Clark  (jjc@jclark.com)

	* troff/input.cc (abort_request): Look at character in tok before
	calling get_copy().

Thu Oct 28 14:09:48 1993  James Clark  (jjc@jclark.com)

	* troff/troff.h (NO_RETURN): Deleted.
	* troff/div.cc (cleanup_and_exit):  Don't declare aas NO_RETURN.
	* troff/input.cc (exit_troff): Likewise

	* Makefile.in: Remove `Making ...' messages since GNU make now
	gives these. 

	* configure.in: Use AC_HAVE_HEADERS(unistd.h) instead of AC_UNISTD_H.

Wed Oct 27 11:12:51 1993  James Clark  (jjc@jclark.com)

	* tmac/tmac.s (@init): Initialize PO to \n(.o here, rather than
	to constant 1 inch.

Sat Oct 23 10:03:52 1993  James Clark  (jjc@jclark.com)

	* tmac/tmac.e (hl): Use \n[.in] rather than \n(.i.

Thu Oct 14 12:09:45 1993  James Clark  (jjc@jclark.com)

	* eqn/delim.cc (delim_box::compute_metrics): Don't increase
	MARK_REG if there was no left delimiter.

Sat Oct  2 19:54:47 1993  James Clark  (jjc@jclark.com)

	* pic/troff.cc (troff_output::text): Set line thickness to
	relative before outputting text.

	* tmac/tmac.e (@k): Don't zero ?T.
	((z): Likewise.

Sat Sep 25 11:08:43 1993  James Clark  (jjc@jclark.com)

	* tmac/tmac.e ($p): Handle possibility that $3 is empty.

Wed Aug 18 08:51:41 1993  James Clark  (jjc@jclark.com)

	* troff/input.cc (decode_args): Warn about unquoted tabs (from
	Paul Eggert).

Tue Aug 10 08:38:32 1993  James Clark  (jjc@jclark.com)

	* troff/input.cc (ignoring): New variable.
	(ignore): Set ignoring during call to do_define_macro.
	(do_define_macro): Clear ignoring before interpolating terminating
	macro.
	(copy_mode_error): New function.
	(get_char_for_escape_name, read_long_escape_name,
	interpolate_arg): Use copy_mode_error.
	(warning_table): Add WARN_IG.
	* troff/troff.h (WARN_IG): Declare.
	(WARN_TOTAL): Change accordingly.

	* groff/pipeline.c (strsignal): Rename to xstrsignal.
	* groff/groff.cc (strsignal): Delete declaration.

Fri Jul 16 01:43:12 1993  James Clark  (jjc@jclark.com)

	* troff/div.cc (page_offset): Use 'm' as default scaling.

Sat Jul  3 09:11:38 1993  James Clark  (jjc@jclark.com)

	* nroff/nroff.sh: Ignore -u.

Wed Jun  9 12:17:27 1993  James Clark  (jjc@jclark.com)

	* Makefile.in (MDEFINES): Pass down MAKEOVERRIDES.

Fri Jun  4 17:35:47 1993  James Clark  (jjc@jclark.com)

	* tmac/tmac.s (par*box-draw): Set adjustment mode to l while
	drawing box.
	(B2): With -Tascii, leave additional vertical space before
	and after. Ensure that the left and right indent is restored to
	what it was even if the point size changes.  Don't call
	par@finish. Change the indent, line length and title length
	directly.  With -Tascii, make the width of the box 1n less.
	(B1): Remember 1n at the current point size.  Don't call
	par@reset.  Change the indent, line length and title length
	directly.  Ensure that the temporary indent is preserved.
	(par*box-mark-top): Turn off no spacing mode.

Thu Jun  3 17:47:14 1993  James Clark  (jjc@jclark.com)

	* Makefile.in (dist): Use .gz suffix.

Thu May 27 20:04:59 1993  James Clark  (jjc@jclark.com)

	* troff/input.cc (main): Add return 0.
	* pic/main.cc (main): Use return instead of exit.
	* tbl/main.cc (main): Likewise.
	* eqn/main.cc (main): Likewise.
	* grops/ps.cc (main): Likewise.
	* grotty/tty.cc (main): Likewise.
	* groff/groff.cc (main): Likewise.
	* grodvi/dvi.cc (main): Likewise.
	* refer/refer.cc (main): Likewise.
	* indxbib/indxbib.cc (main): Likewise.
	* lkbib/lkbib.cc (main): Likewise.
	* soelim/soelim.cc (main): Likewise.
	* addftinfo/addftinfo.cc (main): Likewise.
	* acgroff.m4 (GROFF_PROG_CCC, GROFF_CC_COMPILE_CHECK,
	GROFF_COOKIE_BUG, GROFF_CC_ANSI_BUG): Likewise.

	* troff/token.h (process_input_stack): Don't declare as static.
	* troff/input.cc: Likewise.

	* troff/node.c (invalidate_fontno): Make it a static member of
	class font_family.  Change callers.
	* troff/node.c: Change declaration.

	* tbl/main.cc (struct input_entry_format): Add explicit public
	specifier.
	* tbl/table.cc (struct text_stuff, struct single_hline_stuff,
	struct double_hline_stuff): Likewise.
	* tbl/table.h (struct entry_format): Likewise.
	* pic/object.h (struct saved_state): Likewise.

	* include/stringclass.h: Add forward declarations of friend
	functions that are later declared as inline.  Don't include inline
	specifier in friend declaration.

	* libgroff/lib.h: Declare popen and pclose.
	* acgroff.m4 (GROFF_POPEN): New macro.
	* configure.in: Call it.

	* include/lib.h (PI): New constant. Undef first if necessary.
	* tfmtodit/tfmtodit.cc (main): Use PI rather than M_PI.
	* grops/ps.cc (degrees, radians): Likewise.
	* libgroff/font.cc (font::get_skew): Likewise.

	* grops/ps.cc (is_ascii): New function.
	(ps_output::put_string): Use is_ascii.  Use csprint rather than
	isprint.
	(ps_printer::define_encoding): Use csspace.
	* libgroff/strtol.c (ISASCII): New macro.
	(strtol): Cast arguments to is*() and tolower() to unsigned char.
	Use ISASCII rather than isascii.
	* libgroff/cmap.cc: Use isascii() only if <ctype.h> defines it.
	* libgroff/cset.cc: Likewise.
	* libdriver/input.cc: Include cset.h.
	(do_file, get_integer, possibly_get_integer): Use csdigit() rather
	than isdigit().

	* refer/refer.cc (main): Use %ld rather than %d for longs.

	* libbib/index.cc (index_search_item_iterator::get_tag): Use
	S_ISREG macro.

	* addftinfo/addftinfo.cc (param_t): Add explicit `int'.

Mon May 24 08:51:37 1993  James Clark  (jjc@jclark.com)

	* troff/input.cc (hyphenation_code): Skip white space between
	char/code pairs.

Sun May 16 08:15:52 1993  James Clark  (jjc at jclark.com)

	* tbl/table.h (table::entry_list_tailp): New member.
	(table::table): Initialize it.
	(table::add_entry): Use entry_list_tailp to avoid O(n^2)
	behaviour.

Sat May 15 17:26:00 1993  James Clark  (jjc at jclark.com)

	* grotty/tty.cc (tty_printer::add_char): Don't discard characters
	with negative horizontal positions. Remove casts of glyph::hpos to
	int.
	(USHRT_MAX): Delete definition.
	(SHRT_MAX, SHRT_MIN): New definitions.
	(glyph::hpos): Change type to short.
	(tty_printer::end_page): Output multiple backspaces if necessary.
	 Remove casts of glyph::hpos to int.
	
Fri May  7 12:14:37 1993  James Clark  (jjc at jclark.com)

	* tmac/tmac.s (@RT): New definition.

Thu May  6 21:36:54 1993  James Clark  (jjc at jclark.com)

	* refer/refer.cc (do_file): Make sure current_filename is set when
	filename is "-".

	* pic/common.cc (common_output::dot_line): Handle zero length
	lines.

Sun May  2 19:54:16 1993  James Clark  (jjc at jclark.com)

	* tmac/tmac.s (par@reset): Get value for .hy for \n[HY].
	(par@init): Initialize \n[HY].

Mon Apr 26 11:43:16 1993  James Clark  (jjc at jclark.com)

	* troff/dictionary.cc (dictionary::remove): Continue when
	r < j < i.

Sun Apr 25 11:03:00 1993  James Clark  (jjc at jclark.com)

	* Makefile.com (.y.cc): Avoid ending up with two versions of
	$(YTABH).

Thu Apr 22 21:03:45 1993  James Clark  (jjc at jclark.com)

	* tmac/tmac.dvi (\(,c): Define only if it does not exist.
	(\(,C): Likewise.  Also fix typo.

Wed Apr 21 08:47:32 1993  James Clark  (jjc at jclark.com)

	* lib.h: Delete extraneous semi-colon.

	* Add pso request: `so' from a pipe.
	* troff/input.c (file_iterator::file_iterator): Add 3rd argument.
	(file_iterator::close): New function.
	(file_iterator::~file_iterator, file_iterator::next_file): Use
	file_iterator::close.
	(file_iterator::backtrace): Say `process' rather than `file' when
	the stream is popened.
	(pipe_source): New function.
	(init_input_requests): Bind ".pso" to pipe_source.

Tue Apr 20 00:02:26 1993  James Clark  (jjc at jclark.com)

	* afmtodit/afmtodit.pl: Avoid single quotes in comments.

	* pfbtops/pfbtops.c: Output 64 characters per line.  Output hex
	digits in lower case.

Mon Apr 19 09:55:57 1993  James Clark  (jjc at jclark)

	* Version 1.08 released.

	* Makefile.in (dist): Insert || true after ln -s commands that
	might fail.

	* mm: Update to mm 1.16.

	* acgroff.m4 (GROFF_CSH_HACK): New macro.
	* configure.in: Call GROFF_CSH_HACK.  Substitute for
	SH_SCRIPT_SED_CMD.
	* Makefile.in (SH_SCRIPT_SED_CMD): New variable.  Include in
	MDEFINES.
	* nroff/Makefile.sub (nroff): New target.
	(install_data): Install nroff.
	* eqn/Makefile.sub (neqn): Sed with SH_SCRIPT_SED_CMD.
	* grog/Makefile.sub (grog): Sed grog.sh with SH_SCRIPT_SED_CMD.

Sat Apr 17 08:24:28 1993  James Clark  (jjc at jclark)

	* eqn/Makefile.sub (neqn): Add chmod +x.

	* grog/Makefile.sub (grog): Remove spurious semi-colon.

Fri Apr 16 22:41:57 1993  James Clark  (jjc at jclark)

	* troff/input.cc (string_iterator::string_iterator()): Initialize
	lineno and count.

Tue Apr 13 10:22:28 1993  James Clark  (jjc at jclark)

	* troff/div.cc (macro_diversion::space,
	top_level_diversion::space): Don't set high_water_mark.
	(macro_diversion::output, top_level_diversion::output): Don't
	include post line space in high water mark.

Wed Apr  7 12:48:18 1993  James Clark  (jjc at jclark)

	* eqn/eqn.y: Don't define YYDEBUG.
	* pic/pic.y: Likewise.

Mon Apr  5 10:15:15 1993  James Clark  (jjc at jclark)

	* tmac/tmac.e ([3): Add space after comma following editors.
	Change double spaces to single spaces.
	([4): Change double spaces to single spaces.

	* grops/ps.h (USE_PS_ADOBE_2_0): New flag for broken_flags.
	* grops/ps.cc (ps_printer::~ps_printer): If the USE_PS_ADOBE_2_0
	bit is set in broken_flags, use 2.0 rather than 3.0 as the version
	after %!PS-Adobe- (for Newsprint).

	* troff/div.cc (top_level_diversion::begin_page): When
	before_first_page is 1, set page_number to 1.

Sun Apr  4 14:28:53 1993  James Clark  (jjc at jclark)

	* eqn/box.cc (box::top_level): Protect equation with \&.

Sat Apr  3 23:27:25 1993  James Clark  (jjc at jclark)

	* groff/groff.cc (possible_command::set_name): Delete old name.

	* groff/groff.cc (possible_command::~possible_command): Use
	a_delete.

	* troff/node.cc (troff_output_file::begun_page): New member.
	(troff_output_file::troff_output_file): Initialize it.
	(troff_output_file::really_begin_page): Only output V command if a
	page has been begun.

	* pic/pic.y (placeless_element): Delete argument to PRINT after
	use.

Fri Apr  2 11:31:02 1993  James Clark  (jjc at jclark)

	* Make wrapman work.
	* troff/div.h (class top_level_diversion): Replace
	first_page_begun by before_first_page (with opposite sense).
	* Change first_page_begun to before_first_page inverting sense.
	* troff/div.cc (class nl_reg): New class.
	(init_div_requests): Use class nl_reg for \n(nl.
	(top_level_diversion::begin_page): Don't call
	output_file::begin_page if before_first_page is 2;
	reset before_first_page afterwards.  If have_next_page_number is
	false, then always increment page_number.
	* tmac/tmac.an: Set traps within TH rather than at the top-level.
	Restore compatibility mode after loading, and then disable
	compatibility mode in TH.

Thu Apr  1 11:09:34 1993  James Clark  (jjc at jclark)

	* grotty/tty.cc (tty_printer::end_page): Don't discard characters
	past last line.
	* troff/node.h (output_file::trailer): Declare.
	* troff/div.cc (cleanup_and_exit): Call output_file::trailer().
	* troff/node.cc (output_file::trailer): New function.
	(troff_output_file::~troff_output_file): Move most code into...
	(troff_output_file::trailer): New function.
	(class troff_output_file): Delete page_length member. Declare
	trailer().
	(troff_output_file::really_begin_page): Use current page length
	for final V command.

	* tbl/main.cc (struct options): New decimal_point_char member.
	(options::options): Initialize this.
	(process_options): Implement decimalpoint option.
	(process_data): Pass decimal_point_char option to table::table.
	* tbl/table.h (class table): New decimal_point_char member.
	(table::table): Add additional argument.
	* tbl/table.cc (find_dot): Rename to find_decimal_point. Add
	second argument specifying decimal point character.  Use this
	instead of '.'.
	(table::table): Initialize decimal_point_char.
	(table::add_entry): Change call to find_dot.

	* troff/input.cc (get_copy, token::next): Implement \V.
	(interpolate_environment_variable): New function.

Tue Mar 30 14:41:39 1993  James Clark  (jjc at jclark)

	* pic/lex.cc (lookup_keyword): Rename MIN to K_MIN, MAX to K_MAX.
	* pic/pic.y: Likewise.

	* grotty/tty.cc (tty_printer::add_char, tty_printer::end_page):
	Add casts to int.
	* refer/ref.cc (reference::insert_field, reference::delete_field):
	Likewise.
	* troff/number.cc (parse_term): Likewise.

	* acgroff.m4 (GROFF_PROG_YACC): New macro.
	* configure.in: Use GROFF_PROG_YACC.

	* acgroff.m4 (GROFF_PROG_CCC): Don't add -O automatically for gcc
	and g++.
	* Makefile.in (OPTIMIZE): New define.
	(DEBUG): Empty by default.
	(CCFLAGS, CFLAGS): Include $(OPTIMIZE).

	* acgroff.m4 (GROFF_SYS_SIGLIST): Don't quote program.
	(GROFF_ARRAY_DELETE): Likewise.
	(GROFF_CC_COMPILE_CHECK): Quote use of $2 and $3.

	* troff/env.cc (trie::~trie): Make virtual to shut up g++.

	* devps/psstrip.sed: Use different delimiter on last line (so that
	it works with BSD 4.4 sed.)

Mon Mar 29 17:07:14 1993  James Clark  (jjc at jclark)

	* devps/psstrip.sed: Delete comments.

	* acgroff.m4 (AC_GETOPT): Don't test whether <unistd.h> declares
	optind, opterr, optarg.
	* lib.h: When UNISTD_H_DECLARES_GETOPT is defined, declare optind,
	opterr, optarg.

Sun Mar 28 17:44:25 1993  James Clark  (jjc at jclark)

	* Makefile.in (check): Dummy target.

Wed Mar  3 04:53:38 1993  James Clark  (jjc at jclark)

	* Version 1.07 released.

	* Integrate mm 1.11.

	* tbl/table.cc (alphabetic_block_entry::print): start_row was used
	where start_col was meant.

Thu Feb 25 07:55:36 1993  James Clark  (jjc at jclark)

	* grog/grog.sh, grog/grog.pl: Recognize PH and SA as -mm macros.

Wed Feb 24 10:15:34 1993  James Clark  (jjc at jclark)

	* troff/input.cc (token::next): Make \z\o'...' and similar things
	work.

	* env.h (MARGIN_CHARACTER_ON, MARGIN_CHARACTER_NEXT): New
	constants.
	(environment): Add margin_character_flags member.
	* env.cc (environment::environment(symbol),
	environment::environment(const environment *): Initialize
	margin_character_flags.
	(margin_character): Rewrite.
	(environment::output_line): Add a margin character if
	margin_character_flags is non-zero.  Turn off the
	MARGIN_CHARACTER_NEXT bit.  If that makes margin_character_flags
	zero, use margin_character_node without copying and then set
	margin_character_node to 0.

	* devps/DESC.in: Change minimum size to 1000.

Tue Feb 23 14:57:49 1993  James Clark  (jjc at jclark)

	* troff/symbol.h (symbol::hash): Change return type to unsigned
	long.
	* troff/dictionary.cc (dictionary::lookup, dictionary::remove):
	Add casts to int.

	* test-groff: Use -r rather than -x.

	* grops/psfig.diff: Include in distribution again.

Mon Feb 22 09:10:44 1993  James Clark  (jjc at jclark)

	* Makefile.in (dist): Use gzip.

Sun Feb 21 11:12:53 1993  James Clark  (jjc at jclark)

	* acgroff.m4 (GROFF_GETOPT): Check for declaration of getopt() in
	unistd.h as well as in stdlib.h.
	* include/lib.h: Include <stdlib.h> is STDLIB_H_DECLARES_GETOPT is
	defined; otherwise include <sys/types.h> and <unistd.h> if
	UNISTD_H_DECLARES_GETOPT is defined.

	* configure.in: use builtin(include, ... rather than include(...
	* configure: Regenerate with autoconf 1.3.

	* libdriver/print.cc (printer::adjust_arc_center): Use new
	algorithm suggested by Andy Fyfe.

	* libdriver/printer.cc (printer::adjust_arc_center): New function.
	* include/printer.h: Declare this.
	* grops/ps.cc (ps_printer::draw): Use it.
	* grodvi/dvi.cc (dvi_printer::draw): Use it.

Fri Feb 19 23:13:51 1993  James Clark  (jjc at jclark)

	* Makefile.comm (.man.n): Replace macrodir by tmacdir.

Thu Feb 11 16:46:59 1993  James Clark  (jjc at jclark)

	* eqn/main.cc (main): Handle "eqn -".

Mon Jan  4 20:29:56 1993  James Clark  (jjc at jclark)

	* tmac/tmac.e (++): Install fix from comp.bugs.4sd.

	* mm: Integrate version 1.08.

	* pic/troff.cc (troff_output::finish_picture): Set
	EQN_NO_EXTRA_SPACE reg to 0 rather than removing it.
	* eqn/box.cc (box::extra_space): Set EQN_NO_EXTRA_SPACE_REG to 0
	if it's not defined. Check whether the register is non-zero rather
	than whether it's not defined.
	* tmac.e ({, <): Make argument to \x zero if \n(0x is non-zero.

	* indxbib/indxbib.cc: Move all signal handling into...
	* indxbib/signal.c: New file.
	* configure.in: Call AC_RETSIGTYPE.

	* acgroff.m4 (GROFF_STRUCT_EXCEPTION): New macro.
	* configure.in: Call GROFF_STRUCT_EXCEPTION.
	* libgroff/matherr.c: Protect with ifdef HAVE_STRUCT_EXCEPTION.

	* troff/input.cc (token::token, token::operator=): Work round SGI
	C++ bug.
	* pic/object.cc (position::position): Likewise.

Mon Dec 28 21:50:21 1992  James Clark  (jjc at jclark)

	* pic/pic.h: Move declaration of hypot().

Wed Dec 16 12:28:29 1992  James Clark  (jjc at jclark)

	* pic/pic.h: Declare hypot().

	* pic/pic.h: Define M_PI if necessary.

Thu Dec 10 12:03:29 1992  James Clark  (jjc at jclark)

	* tmac/tmac.e (re): Add alternative version that doesn't use groff
	`.ta T' feature.

	* devps/prologue.ps (RE): Handle the possibility that the old font
	doesn't have a FontName entry.

Wed Dec  2 10:25:29 1992  James Clark  (jjc at jclark)

	* tmac/tmac.e (fam): Redefine to set family in environment 2.
	(@C): Use @fam not fam.

Thu Nov 26 16:01:25 1992  James Clark  (jjc at jclark)

	* lookbib/lookbib.cc (main): Change type of start to const char *.
	* lkbib/lkbib.cc (main): Likewise.

	* eqn/lex.cc (definition::definition): Don't use member
	initializer syntax for members of anonymous unions.

	* troff/input.cc (input_stack::backtrace): Change type of to const
	char *.

Wed Nov 25 13:43:09 1992  James Clark  (jjc at jclark)

	* include/stringclass.h (class string): Declare inline friend
	functions as inline in class declaration.
	* troff/hvunits.h (class hunits, class vunits): Likewise.
	* include/refid.h (class reference_id): Likewise
	* troff/troff.h (points_to_units(units), scale(units, double)):
	Delete declarations.
	* libdriver/input.cc (get_char): Delete declaration.
	* include/lib.h: Change 2nd argument of getopt from const char **
	to char **.
	* troff/symbol.cc (symbol::symbol): Cast `new char *[n]' to `const
	char **' before assigning to a `const char **'.
	* tbl/table.cc: Delete extra declarations of prints().

Tue Nov 24 14:33:13 1992  James Clark  (jjc at jclark)

	* libgroff/font.cc (font::load_desc): Cast `new char *[n]' to `const
	char **' before assigning to a `const char **'.

	* libgroff/errarg.cc (errarg::errarg): Don't use member
	initializer syntax for members of anonymous unions.

Sat Nov 21 05:02:23 1992  James Clark  (jjc at jclark)

	* mm: Integrate version 1.07.

Tue Nov 17 16:44:27 1992  James Clark  (jjc at jclark)

	* troff/input.c (translate2): Rename to
	(translate_no_transparent).
	(init_input_requests): Rename tr2 to trnt.

Mon Nov 16 09:49:32 1992  James Clark  (jjc at jclark)

	* troff/charinfo.h (class charinfo): Add transparent_translate field.
	(charinfo::set_translation, charinfo::set_special_translation):
	Add second argument that specifies value for
	transparent_translate.
	(charinfo::get_translation, charinfo::get_special_translation):
	Add optional second argument that specifies whether translation is
	being used for transparent throughput.
	* troff/input.cc (charinfo::set_translation,
	charinfo::set_special_translation): Handle second argument.
	(charinfo::charinfo): Initialize transparent_translate.
	(translate): Split main part off into
	(do_translate): New function.  Pass argument saying whether
	translation applies to transparent throughput.
	(translate2): New request.
	(init_input_requests): Bind translate2 to `tr2'.

Wed Nov 11 11:43:20 1992  James Clark  (jjc at jclark)

	* tbl/table.h (class table): Add `nokeep' flag.
	* tbl/main.cc (process_options): Handle `nokeep' option.
	* tbl/table.cc (table::init_output, table::do_row, table::do_top,
	table::do_bottom): Don't output keep/release macro definitions or
	calls when `nokeep' option has been specified.

Sat Nov  7 01:28:33 1992  James Clark  (jjc at jclark)

	* tmac/tmac.Xps (Xps-char): Use " as delimiter for \Z.

Wed Nov  4 16:29:04 1992  James Clark  (jjc at jclark)

	* tbl/table.cc (table_entry::divert, block_entry::do_divert,
	block_entry::divert, alphabetic_block_entry::divert): Add extra
	argument giving column separation.
	(table::compute_widths): Pass column separation to
	table_entry::divert().
	(block_entry::do_divert): If an entry spans multiple columns and a
	minimumum width has been specified for each column, then set the
	line length to the sum of the widths (plus possibly the column
	separations).

	* troff/input.cc (set_escape_char): Don't set the escape_char
	until after calling has_arg().

Tue Nov  3 11:23:27 1992  James Clark  (jjc at jclark)

	* tbl/table.cc (table::do_top): Add missing \s0 for double box
	case.

	* tbl/table.cc (table::print_double_hline): Avoid extra new line
	in case where r > nrows - 1.

	* tbl/table.cc (BODY_HEIGHT): Deleted.
	(LINE_SEP): New definition.
	(table::print_single_hline, table::print_double_hline,
	table::compute_vrule_top_adjust, table::compute_vrule_bot_adjust,
	table::do_row, table::do_top): Use LINE_SEP space before a line
	instead of \n[.v]-BODY_HEIGHT-BODY_DEPTH.

	* tbl/table.cc (text_entry::print_contents): New function.
	(text_string_name, right_text_string_name): Deleted.
	(TEXT_STRING, RIGHT_TEXT_STRING): Deleted.
	(simple_text_entry::do_width, numeric_text_entry::do_width,
	alphabetic_text_entry::do_width): Don't store the contents of the
	entry in a string.
	(left_text_entry::simple_print, right_text_entry::simple_print,
	center_text_entry::simple_print,
	alphabetic_text_entry::simple_print,
	numeric_text_entry::simple_print): Print the entry directly
	instead of using the stored string.

Fri Oct 30 10:39:32 1992  James Clark  (jjc at jclark)

	* devps/Makefile: Strip PostScript files.
	* devps/prologue: Rename to...
	* devps/prologue.ps.
	* devps/psstrip.sed: New file.
	* devps/download: Use .pfa rather than .ps for installed versions
	of fonts.

Thu Oct 29 09:14:43 1992  James Clark  (jjc at jclark)

	* troff/env.cc (input_trap): Give a warning if the argument is out
	of range.

	* troff/env.cc (adjust): Treat negative argument as missing. Round
	argument > 5 down to 5.

	* troff/env.cc (center, right_justify): Make negative argument zero.

	* troff/div.cc (page_offset, vertical_position_traps): Treat
	invalid argument as missing.
	* troff/env.cc (line_spacing, line_length, title_length, indent,
	underline, hyphen_line_max_request, control_char,
	no_break_control_char, widow_control_request, adjust, input_trap,
	point_size): Likewise.
	* troff/node.cc (ligature, kern_request, bold_font, track_kern,
	constant_space): Likewise.
	* troff/input.cc (compatible, shift, warn_request,
	set_escape_char): Likewise.

	* tbl/main.cc (format::format): Avoid doing `new int[0]'.
	* tbl/table.cc (table::table): Likewise.

	* Makefile.dev (install_dev): depends on $(DEVFILES).

Wed Oct 28 08:30:57 1992  James Clark  (jjc at jclark)

	* devX75, devX75-12, devX100, devX100-12: New directories.
	* Makefile.in: Add these to DEVDIRS.

	* troff/Makefile.sub, eqn/Makefile.sub, indxbib/Makefile.sub,
	afmtodit/Makefile.sub, tmac/Makefile.sub, nroff/Makefile.sub,
	grog/Makefile.sub, mm/Makefile.sub (uninstall_sub): New target.
	* Makefile.in (uninstall, uninstall_sub, uninstall_dirs): New
	targets.
	* Makefile.ccpg, Makefile.cpg, Makefile.dev, Makefile.man
	(uninstall): New target.
	* Makefile.comm (uninstall, uninstall_sub, uninstall_man,
	uninstall_prog, uninstall_dev): New targets.

	* troff/div.cc (return_request): Treat an invalid argument as
	missing.

Mon Oct 26 11:33:47 1992  James Clark  (jjc at jclark)

	* tmac/tmac.e ((f): Set up the environment even when there's a
	current diversion.  Transperently throughput a call to @N.
	(@N): New macro.

Thu Oct 22 05:05:59 1992  James Clark  (jjc at jclark)

	* tbl/table.cc (table::compute_vrule_top_adjust): Round adjustment
	up to vertical resolution.

	* tbl/table.cc (table::do_row): Change row number after printing
	stuff list.

	* pic/lex.cc (get_token_after_dot): Make .left and .right work.

Wed Oct 21 14:46:45 1992  James Clark  (jjc at jclark)

	* Rename CHANGES to NEWS.

Tue Oct 20 23:25:21 1992  James Clark  (jjc at jclark)

	* libgroff/new.cc (operator new): Avoid calling malloc(0).

Mon Oct 19 09:10:13 1992  James Clark  (jjc at jclark)

	* man.ultrix: Removed.

Sun Oct 18 06:35:15 1992  James Clark  (jjc at jclark)

	* Makefile.comm (extraclean): Delete files whose names begin with
	`='.

	* pic/troff.cc (troff_output::text): Fix typo in implementation of
	aligned text.

Sat Oct 10 09:32:29 1992  James Clark  (jjc at jclark)

	* troff/env.cc (hyphenate_request, vertical_spacing, no_number):
	* troff/div.cc (page_length, need_space, space_request): Treat
	invalid optional argument as missing.
	* troff/env.cc (number_lines): If the first argument is present
	but not a number, turn on line numbering, don't change the next
	line number and parse the remaining arguments.

	* tmac/tmac.e (@q): Do the `ne' before changing to environment 2.

Thu Oct  8 10:24:40 1992  James Clark  (jjc at jclark)

	* eqn/box.h: Change declaration accordingly.
	* eqn/box.cc (set_gsize): Change return type to int.  Return 0 if
	the specified size was bad but don't give an error.  Check for
	overflow.
	* eqn/main.cc (main): Change caller. Leave validation to set_gsize.
	* eqn/lex (do_size): Likewise.

Wed Oct  7 09:48:59 1992  James Clark  (jjc at jclark)

	* acgroff.m4 (GROFF_PROG_CCC): Use fopen when checking for C++
	compatible headers.

Sun Oct  4 18:24:02 1992  James Clark  (jjc at jclark)

	* tbl/table.cc (table::init_output): Improve error message when
	table won't fit on one page.

Fri Oct  2 10:41:40 1992  James Clark  (jjc at jclark)

	* pic/troff.cc (troff_output::start_picture): Generate line
	containing a horizontal motion equal to the width of the picture.

	* groff/groff.cc (main): Allow PROG_PREFIX to be set at runtime
	using GROFF_COMMAND_PREFIX environment variable.

Fri Sep 25 11:40:40 1992  James Clark  (jjc at jclark)

	* mdate.sh: Use $NF rather than $(NF).

Tue Sep 22 09:47:24 1992  James Clark  (jjc at jclark)

	* pic/main.cc (main):  Use %1 not %c in argument to warning.

	* eqn/main.cc (main): Output code to check that geqn was given the
	correct -T option.

Mon Sep 21 10:59:16 1992  James Clark  (jjc at jclark)

	* Makefile.in (dist): Instead of doing `make -f ../Makefile', do
	`ln -s ../Makefile .; make; rm -f Makefile'.

	* troff/hyphen: Rename to...
	* troff/hyphen.us:
	* troff/input.cc (main): Delete -H option. Don't call
	read_hyphen_file().
	* troff/env.cc: Include searchpath.h and macropath.h.
	(exception_dictionary): Deleted.
	(ht): Deleted.
	(read_hyphen_file): Deleted.
	(hyphenation_language): New struct.
	(class trie, class hyphen_trie): Move declarations up.
	(trie_node::~trie_node): Deleted.
	(trie::delete_trie_node): New function.
	(trie::do_delete): New pure virtual function.
	(hyphen_trie::do_delete): New function.
	(trie::~trie): New function.
	(hyphen_trie::~hyphen_trie): New function.
	(trie::clear): No need to chcek that tp is not 0.
	(current_language, language_dictionary): New variables.
	(hyphen_word): Give an error if no current language.  Use
	exceptions dictionary in current language.
	(hyphen_trie::read_patterns_file): Find file using macro_path.
	Allow comments (starting with %) in patterns file.  Don't make it
	a fatal error if the file can't be found.
	(hyphenate): Return if no current language.  Get the exceptions
	dictionary and the hyphenation patterns from the current language.
	(set_hyphenation_language): New variable.
	(hyphenation_patterns_file): New function.
	(hyphenation_language_reg): New class.
	(hyphenation_language_reg::get_string): New function.
	(init_hyphen_requests): Bind "hla" to set_hyphenation_language and
	"hpf" to hyphenation_patterns_file.  Initialize `.hla' number
	register.
	* groff/groff.cc (main, help, synopsis): Delete -H option.
	* include/Makefile.sub: Don't define HYPHENFILE.
	* Makefile.in: Delete hyphenfile variable and remove from MDEFINES.
	* Makefile.comm (.man.n): Don't substitute for HYPHENFILE.
	* tmac/troffrc: Set hyphenation language to `us'. Load `hyphen.us'
	hyphenation patterns.

Sun Sep 20 09:33:02 1992  James Clark  (jjc at jclark)

	* eqn/neqn.sh: New file.
	* eqn/Makefile.sub: Handle neqn.sh.

	* eqn/eqn.h: Declare `nroff' variable.
	* eqn/box.cc (param_table): Add `nroff' param.
	(nroff): Define it.
	* eqn/lex.cc (yylex): Handle TDEFINE and NDEFINE using `nroff'
	variable.
	* tmac/eqnrc: Set `nroff' to 1 for -Tascii or -Tlatin1.

	* troff/troff.h (WARN_FONT): New warning.
	(WARN_TOTAL): Change accordingly.
	* troff/input.cc (DEFAULT_WARNING_MASK): Include WARN_FONT.
	(warning_table): Add WARN_FONT.
	* troff/node.cc (mount_font_no_translate): Pass argument to
	font::load_font.  If this is non-zero, give a warning.
	Don't give an error message when accessing a font that has already
	been found to be invalid.
	* include/font.h (font::load, font::load_font): Add additional
	optional argument which suppresses error message if the font is
	not found.
	* libgroff/font.cc (font::load_font): Handle additional argument.
	(font::load): Add additional argument. If this is non-null, set it
	to 1 and don't give error message.

	* include/printer.h (printer::end_page): Add argument giving
	length of page.
	* libdriver/input.cc (do_file): Pass this.
	* grops/ps.cc (ps_printer::end_page): Add argument.
	* grodvi/dvi.cc (dvi_printer::end_page,
	draw_dvi_printer::end_page): Add argument.
	* grotty/tty.cc (class tty_printer): Remove lines_per_page and
	columns_per_page members. New member nlines.
	(DEFAULT_LINES_PER_PAGE): Deleted.
	(tty_printer::tty_printer): Don't compute lines_per_page from
	font::paperlength. Don't compute columns_per_page from
	font::paperwidth.
	(tty_printer::add_char): Don't check horizontal position against
	columns_per_page. Grow glyphs vector if neccessary.
	(tty_printer::end_page): Add argument giving page_length in units.
	Discard lines past end of page.

Wed Sep 16 06:29:52 1992  James Clark  (jjc at jclark)

	* tmac/tmac.tty-char: Fix definition of \(/l.

	* tmac/tmac.X: Define \(en.

Tue Sep 15 10:37:13 1992  James Clark  (jjc at jclark)

	* acgroff.m4 (GROFF_PRINT): If a system has lpr and lp but not
	lpq, then use lp rather than lpr.

	* tmac/tmac.s (par@reset): Don't call `ad'.
	(par*env-init): Call `ad'.

Sun Sep 13 18:48:20 1992  James Clark  (jjc at jclark)

	* mdate.sh: Use $(NF) instead of $6 to extract year from output of
	date.

	* troff/symbol.cc: #undef BLOCK_SIZE if it's defined.
	* indxbib/indxbib.cc: Likewise.

Sun Sep  6 09:44:46 1992  James Clark  (jjc at jclark)

	* libgroff/putenv.c: New file.
	* libgroff/Makefile.sub: Add putenv.c to CSRCS.
	* Makefile.in: Say that putenv.o can be one of LIBOBJS.
	* configure.in: Test for putenv with AC_REPLACE_FUNCS. Test for
	stdlib.h with AC_HAVE_HEADERS.

Sat Sep  5 18:11:52 1992  James Clark  (jjc at jclark)

	* indxbib/dirnamemax.c: Include <sys/dir.h> only if <dirent.h>
	does not exist.

Fri Sep  4 09:43:26 1992  James Clark  (jjc at jclark)

	* eqn/box.cc (gsize): Make it an int.
	(set_gsize): Parse argument handling increment or decrement.
	(box::top_level): Convert gsize to a string.

	* troff/input.cc (exit_troff): Make buf unsigned char [].
	Call to make_temp_iterator casts buf to char*.

	* Makefile.in ($(TARGETS), dot): Pass $(MDEFINES) to recursive makes.

	* Makefile.ccpg (depend.temp): Depends on $(YTABC).
	* Makefile.cpg (depend.temp): Likewise.

	* Makefile.dep: Remove Makefile.dep from $(REALCLEANFILES).

	* Makefile.comm: Add y.output to MOSTLYCLEANFILES.

Thu Sep  3 08:01:55 1992  James Clark  (jjc at jclark)

	* tmac/tmac.s (B, I, BI, CW): Rewrite avoiding aliases.

Tue Sep  1 18:24:53 1992  James Clark  (jjc at jclark)

	* Version 1.06 released.

	* Integrate mm 1.04.

Fri Aug 28 11:28:19 1992  James Clark  (jjc at jclark)

	* Makefile.comm, Makefile.ccpg, Makefile.cpg: Fix TAGS target.

Thu Aug 27 11:03:33 1992  James Clark  (jjc at jclark)

	* afmtodit/afmtodit.pl: Add -n option that disables generation of
	ligatures command.
	* devps/generate/Makefile (CR, CB, CI, CBI): Pass -n flag to
	afmtodit. Regenerate.

	* tmac/tmac.e ()z): Adjust _b if necessary so as to avoid moving
	@f back past the current position.

	* tmac/tmac.e: Change calls to @R so that comments are not part of
	arguments.

Tue Aug 25 10:42:07 1992  James Clark  (jjc at jclark)

	* configure.in: Check for mkstemp with AC_HAVE_FUNCS.

	* acgroff.m4 (GROFF_PROG_CCC): Don't check for <osfcn.h>. Instead
	check that we can link a call to a function declared in <stdio.h>.
	(GROFF_UNISTD_H): New macro.
	* configure.in: Call it.
	* Makefile.in: Document it.
	* include/posix.h: New file.
	* troff/troff.h: Don't include <osfcn.h>
	* troff/input.cc: Include posix.h.
	* libgroff/new.cc, libgroff/tmpfile.cc: Include posix.h rather than
	osfcn.h.
	* indxbib/indxbib.cc, libbib/{search.cc,linear.cc,index.cc}:
	Include posix.h rather <sys/types.h>, <sys/stat.h>, <osfcn.h>,
	<fcntl.h>.
	* indxbib/indxbib.cc (S_IRUSR, S_IRGRP, S_IROTH): Delete definitions.
	* libbib/index.cc (S_ISREG, O_RDONLY): Delete definitions.
	* libbib/search.cc (O_RDONLY): Delete definition.
	* refer/refer.cc, include/driver.h, pic/pic.h, groff/groff.cc:
	Don't include <osfcn.h>.

	* acgroff.m4 (GROFF_TIME_T): New macro.
	* configure.in: Call it.
	* Makefile.in: Document it.

	* acgroff.m4 (GROFF_TRADITIONAL_CPP): New macro.
	* configure.in: Call it.
	* Makefile.in: Document -DTRADITIONAL_CPP.
	* include/ptable.h: Don't include generic.h.
	(name2): Define it.

	* tmac/tmac.s (][): Make [T1 and [T2 aliases for [T.
	Afterwards remove [T1 and [T2.
	(ref*spec!0, ref*spec!2): Use T1 rather than T.
	(ref*spec!1, ref*spec!4, ref*spec!4): Use T2 rather than T.
	(ref*add-T2): Renamed from ref*add-T.
	(ref*add-T1): New macro.

Mon Aug 24 11:11:11 1992  James Clark  (jjc at jclark)

	* acgroff.m4 (AC_PROG_CCC): Use GROFF_EXIT rather than exit 1.

	* libbib/index.cc: Include <fcntl.h>.
	(O_RDONLY): Define if necessary.
	(make_index_search_item, index_search_item_iterator::get_tag,
	index_search_item::check_files): Use O_RDONLY.
	* libbib/seach.cc: Include <fcntl.h>, <sys/types.h>, <sys/stat.h>.
	(O_RDONLY): Define if necessary.
	(search_list::add_file): Use O_RDONLY.
	* indxbib/indxbib.cc: Include <fcntl.h>, <sys/types.h>,
	<sys/stat.h>.
	(S_IRUSR, S_IRGRP, S_IROTH): Define if necessary.
	(main): Use these.

	* libbib/index.cc (S_ISREG): Define it if necessary.
	(index_search_item::load): Use S_ISREG.

	* include/driver.h: Include <errno.h>.

Sun Aug 23 11:32:18 1992  James Clark  (jjc at jclark)

	* eqn/box.cc (body_height): Increase default value to 85.
	(body_depth): Increase default value to 35.

Fri Aug 21 05:34:42 1992  James Clark  (jjc at jclark)

	* eqn/pbox.h (SAVE_FONT_STRING): Define it.
	* eqn/box.cc (box::top_level): Hide use of \R in a string that is
	protected from expansion with \E.

	* acgroff.m4 (GROFF_PAGE): Use `case' to test domain.

	* Makefile (Makefile): New target.

	* Makefile.sub (configure, distfiles): New targets.

	* acgroff.m4 (GROFF_BROKEN_SPOOLER_FLAGS): Avoid using ${var:-val}
	construct.

Thu Aug 20 12:27:26 1992  James Clark  (jjc at jclark)

	* eqn/box.cc (param_table): Add body_height and body_depth.

	* eqn/lex.cc (def_table): Make circumflex in hat_def roman.

Tue Aug 18 16:24:25 1992  James Clark  (jjc at jclark)

	* psbb/Makefile.sub: Don't link with libgroff.a.

	* acgroff.m4 (GROFF_PUTENV): New macro.
	* configure.in: Call GROFF_PUTENV.
	* Makefile.in: Document STDLIB_H_DECLARES_PUTENV.
	* groff/groff.cc: Don't declare putenv if STDLIB_H_DECLARES_PUTENV
	is defined.

	* troff/env.cc (distribute_space): Rename force_forward argument
	to force_reverse.  Reverse the list if force_reverse is true.

Mon Aug 17 17:49:05 1992  James Clark  (jjc at jclark)

	* tmac/tmac.an: Don't define a string `T'. Just define Tm.

	* eqn/pile.cc (matrix_box::compute_metrics): Don't allow computed
	height or depth to be negative.  Guard against SUP_RAISE quantity
	being negative.

Sat Aug 15 08:18:54 1992  James Clark  (jjc at jclark)

	* devps/generate/textmap: Add `an' (arrowhorizex).
	* tmac/tmac.ps: \(an overlaps horizontally.
	* tmac/tmac.dvi, tmac/tmac.tty: Add `an'.

	* devps/symbolchars: Add arrowverttp, arrowvertbt.
	* devps/textmap: Add arrowvertex.
	* eqn/delim.cc (delim_table): Add uparrow, downarrow and
	updownarrow delimiters.
	* tmac/tmac.ps, tmac/tmac.X: Add definition of \(va.

	* tbl/table.cc (simple_entry::position_vertically,
	block_entry::position_vertically):  For a centered entry, perform
	the motion in two stages.

	* refer/refer.cc (split_punct): Don't call lookup_token if there
	is no token.

Fri Aug 14 11:14:58 1992  James Clark  (jjc at jclark)

	* troff/input.cc (token::next): Delete token_node after copying
	token.

	* grodvi/grodvi.cc (dvi_printer::dvi_printer): Initialize
	cur_point_size.

	* libdriver/printer.cc (printer::load_font): Delete old_font_table.

	* grops/ps.cc (ps_printer::define_encoding): Delete elements of vec.

Tue Aug 11 13:50:38 1992  James Clark  (jjc at jclark)

	* grops/ps.cc (usage): -b option takes an argument.

	* devps/prologue (PLG): New procedure.
	* grops/ps.cc (main, usage): New -g option.
	(ps_printer::~ps_printer):  If guess_flag is set, guess the paper
	length using PLG.

Mon Aug 10 11:17:53 1992  James Clark  (jjc at jclark)

	* include/cset.h: Include <limits.h> if we have it.

	* libgroff/illegal.cc: New file.
	* include/lib.h (illegal_input_char): Use table.
	* troff/input.cc (ESCAPE_RIGHT_PARENTHESIS): Renumber to 0206.
	* pic/lex.cc (ARG1): Renumber to 14.
	* eqn/lex.cc (ARG1: Likewise.

	* troff/Makefile.sub (majorminor.cc): Handle 3 part versions
	(eg 1.05.90) correctly.

Sun Aug  9 13:35:43 1992  James Clark  (jjc at jclark)

	* tmac/tmac.e (sr): Deleted. Set $r and $R directly.
	Rename $r and $R registers to $v and $V.
	($r, $R): Initialize to 0.
	(@v, @V): New macros.
	(sz): Call @v.
	(@M): Call @V.

	* troff/input.cc (main, usage): Add -R option that says not to
	load troffrc.
	* eqn/main.cc (main, usage): Rename -n to -R.

Sat Aug  8 00:16:00 1992  James Clark  (jjc at jclark)

	* devps/DESC.in: Leave font positions 5-9 blank.
	* devdvi/DESC.in: Likewise.

	* grog/grog.pl: Handle `.PS <file' correctly.

	* troff/input.cc (input_stack::push): Improve error message when
	input stack limit exceeded.

Fri Aug  7 13:08:16 1992  James Clark  (jjc at jclark)

	* refer/refer.cc (main): Fix typo in handling of `a' option.

	* refer/refer.cc (do_bib): In state START after a newline remain
	in state START.

	* groff/groff.sh: Deleted.
	* groff/Makefile.sub: Delete handling of groff.sh.

	* pic/troff.cc (troff_output::text): Test \n(0p rather than \*(.T
	to determine whether to use \X'ps:...'.
	* tmac/troffrc: Set 0p register to 0.
	* tmac/tmac.ps: Set 0p register to 1.

	* groff/groff.cc: Support -X option. Give warning for -TXps and
	transform to -X -Tps. Pass troff a -r.X=1 option if -X is used.
	* tmac/troffrc: Support -r.X=1.

	* pic/troff.cc (troff_output::dot): Don't test
	zero_length_line_flag.

Thu Aug  6 13:32:08 1992  James Clark  (jjc at jclark)

	* include/lib.h: Declare getopt() and friends unless
	STDLIB_H_DECLARES_GETOPT is defined.

	* doc/chars.tr: Delete.
	* man/groff_char.man: New file.

Wed Aug  5 00:38:58 1992  James Clark  (jjc at jclark)

	* tmac/tmac.e (np, bu): Test \n($p with string expression in case
	user has changed register format.

Mon Aug  3 11:22:18 1992  James Clark  (jjc at jclark)

	* groff/groff.cc: Get rid of device_table.  Get postprocessor from
	`postpro' command in DESC file.  Get spooler command from `print'
	command in DESC file.  Execute spooler command with /bin/sh.

	* groff/groff.cc: Split Unix-specific parts into...
	* groff/pipeline.c: New file.

	* LICENSE: Delete.
	* COPYING: New file.
	* all files: Update copyright notices.

	* Rearrange files.  Redo Makefiles.  Use autoconf.

Sat Aug  1 09:36:50 1992  James Clark  (jjc at jclark)

	* troff/input.c (charinfo_to_node_list): Interpret character
	definition with escape_char of `\'.

Tue Jul 28 12:20:12 1992  James Clark  (jjc at jclark)

	* lib/strerror.c, lib/iftoa.c, lib/itoa.c: Don't include lib.h.
	Define INT_DIGITS as big enough for 64-bit integer.
	* lib/strtol.c: Don't include lib.h.
	* lib/lib.h: Delete ifdef __cplusplus stuff.

Mon Jul 27 11:08:50 1992  James Clark  (jjc at jclark)

	* ps/devps/Makefile: Add DESC to DEVICEFILES.  Separate out rule
	for making DESC.  Make $(FONTS) depend on DESC. afmtodit should
	get DESC from current directory.

Sun Jul 26 15:38:26 1992  James Clark  (jjc at jclark)

	* tbl/main.c (main): Always reset the line number when reading
	from stdin.

	* tbl/table.c (table::print_single_hline, table::print_double_hline,
	table::define_bottom_macro, table::do_row, table::do_top): Round
	vertical spacing up to vertical resolution.

Fri Jul 24 14:32:07 1992  James Clark  (jjc at jclark)

	* ps/ps.h (enum resource_type): Avoid comma at end of
	enumerator-list.
	* dvi/dvi.c (class dvi_printer): Likewise.
	* dvi/tfmtodit.c (gf::load): Likewise.
	* refer/label.y (struct expression): Likewise.
	* refer/refer.c (class label_processing_state): Likewise.
	* refer/indxbib.c (do_file): Likewise.
	* troff/troff.c (enum warning_type): Likewise.
	* tbl/main.c (process_data): Likewise.
	* troff/charinfo.h (class charinfo):

Wed Jul 22 09:17:58 1992  James Clark  (jjc at jclark)

	* dvi/devdvi/textt.map: Add entry for `-'.  Regenerate fonts.

Tue Jul 21 11:39:26 1992  James Clark  (jjc at jclark)

	* groff.c: Move to new groff subdirectory.
	* groff/Makefile: New file.
	* Makefile: Remove handling of groff.c. Add groff to SUBDIRS.

	* man/mdate.sh: Use ls -L if supported.

	* Consolidate all header files produced by gendef into lib/defs.h.
	* lib/macropath.c, lib/fontfile.c, lib/device.c: Include defs.h.
	Don't include path.h.
	* lib/Makefile (path.h): Don't generate.
	* troff/input.c: Include defs.h. Don't include config.h.
	* troff/Makefile (config.h): Don't generate.
	* refer/index.h: Don't include suffix.h.
	* refer/index.c: Include defs.h.
	* refer/indxbib.c: Include defs.h.
	* refer/refer.h, refer/lkbib.h: Don't include path.h. Include
	defs.h.
	* refer/Makefile (suffix.h, path.h): Don't generate.
	* groff.c: Don't include config.h. Include defs.h.
	* Makefile (config.h): Don't generate.
	(lib/defs.h): Generate.
	(topclean): Remove lib/defs.h.

Mon Jul 20 10:12:57 1992  James Clark  (jjc at jclark)

	* lib/malloc.c, lib/getpagesize.h: Deleted.
	* Makefile: Add COOKIE_BUG configuration option.  Delete malloc
	related stuff.
	* lib/Makefile: Delete malloc-related stuff.
	* lib/new.c: Workaround COOKIE_BUG if necessary.

	* refer/lkbib.c, refer/indxbib.c: Don't include refer.h.  Include
	needed header files directly.
	* refer/refer.h: Omit definition of DEFAULT_INDEX.
	* Makefile: Include definition of DEFAULT_INDEX in path.h.

Sun Jul 19 10:19:22 1992  James Clark  (jjc at jclark)

	* lib/font.c (FONT_COMMAND_HANDLER): Pass command name and single
	argument.
	* lib/font (font::load_desc, font::load): Don't split argument of
	unknown command.
	(font::handle_unknown_font_command): Change type.
	* ps/ps.c (ps_font::handle_unknown_font_command,
	handle_unknown_desc_command): Change type.
	* dvi/dvi.c (dvi_font::handle_unknown_font_command): Change type.

Fri Jul 17 11:12:49 1992  James Clark  (jjc at jclark)

	* lib/font.h (font::handle_unknown_font_command): Add file and
	line arguments.
	* lib/font.c (font::handle_unknown_font_command):
	* ps/ps.c (ps_font::handle_unknown_font_command):
	* dvi/dvi.c (dvi_font::handle_unknown_font_command): Add file and
	lineno arguments.  Use _with_file_and_line functions for error
	reporting.

	* lib/fontfile.c (font::unknown_desc_command_handler): New static
	data member.
	* lib/font.c (font::set_unknown_desc_command_handler): New
	function.
	(font::load_desc): For unknown commands, call
	unknown_desc_command_handler if not null.
	* lib/font.h (class font): Declare them.
	(FONT_COMMAND_HANDLER): New typedef.
	* ps/ps.c (handle_unknown_desc_command): New function.
	(main): Set bflag if we had a -b option. Call
	font::set_unknown_desc_command_handler.
	(broken.h): Don't include.
	* ps/Makefile: No need for broken.h.  Pass BROKEN_SPOOLER_FLAGS to
	submake 
	* ps/devps/Makefile: Add `broken' command to DESC file using
	BROKEN_SPOOLER_FLAGS.

	* macros/tmac.e ([, ]): Add as synonyms for { and }.

	* macros/tmac.e ($p): Only exdent if \$3 > 0.

	* macros/tmac.e (@R, @S): New macros.
	Declare @, po, $0, $i, $p, df, so, fu, bt, *, ?a, ?b, ?C, ?e, ?H,
	?I, ?n, ?o, ?R, ?s, ?T, ?W, ?w registers with @R.
	Declare $H, $[0-9], .. macros with @S.
	Declare |0, |1, |2, |3 strings with @S.

	* macros/tmac.e (@S): Rename to @U.

	* macros/tmac.e (@z): Define @b and bp as empty instead of
	deleting them,

	* macros/tmac.e (@m): Deleted.
	(@h): Don't call @m.
	(@z): Don't set @m trap.

	* macros/tmac.e ($h, $f): Define |z as empty string.

	* macros/tmac.e (@D): Rework to avoid unbalanced .el requests.
	(@q): Likewise.

	* macros/tmac.e (@h): Set ?H, ?C , ?s registers to 0 rather than
	removing them.
	()f): Likewise for * register.

	* macros/tmac.e (sr): Don't ever scale the arguments. If the third
	argument is missing, don't change $R.  Call sr with three
	arguments when initializing.

Thu Jul 16 12:17:12 1992  James Clark  (jjc at jclark)

	* macros/tmac.e (sr): New macro.
	Initialize $r and $R using sr.

	* macros/tmac.e (,): Delete \*(#[.

	* troff/env.c (set_tabs): Read the tab type even if the position
	is bad.  Allow the position of the first tab stop to be negative.

Wed Jul 15 13:14:37 1992  James Clark  (jjc at jclark)

	* refer/dirnamemax.c: Use pathconf() if <unistd.h> defines
	_POSIX_VERSION.
	* refer/Makefile: Compile dirnamemax.c using -DHAVE_UNISTD_H
	rather than -DPATHCONF_MISSING.
	* Makefile: Get rid of PATHCONF_MISSING.

	* refer/map.c: New file.
	* refer/index.c: Interface to mmap through map.c.  Rename map_size
	to map_len.
	* refer/Makefile: Handle map.c.
	* Makefile: Include -DHAVE_MMAP in OLDCFLAGS rather than CFLAGS.

Tue Jul 14 14:15:20 1992  James Clark  (jjc at jclark)

	* Makefile: RANLIB should be `true' if there is no ranlib.
	* lib/Makefile (libgroff.a): Simplify.
	* driver/Makefile (libdriver.a): Simplify.

	* Makefile: Change -DWAIT_COREDUMP_0200 to -DWCOREFLAG=0200.
	* groff.c (WCOREDUMP): Use WCOREFLAG.  Define only if not already
	defined.

Sat Jul 11 09:19:17 1992  James Clark  (jjc at jclark)

	* troff/env.c (compare_ranges): Declare as extern "C".

	* troff/input.c (init_registers): Use `struct tm' instead of `tm'.

	* macros/tmac.s, macros/tmac.e: Change .nx /dev/null to .nx.

Wed Jul  8 11:52:27 1992  James Clark  (jjc at jclark)

	* pic/troff.c (troff_output::text): Merge in grops_output::text,
	but conditionalize use of \X based on \*(.T.
	(grops_output::*): Deleted.
	* pic/output.h: Delete declaration of make_grops_output.
	* pic/main.c (main): Ignore -p and -x.  driver_extension_flag is 1
	by default. -n sets it to 0.
	(usage): Corresponding changes.
	* groff.c (main): Don't pass -x or -p to pic.
	* groff.sh: Likewise.

	* ps/ps.c (ps_printer::do_exec, ps_printer::do_file): Force ndefs
	to be non-zero.

	* ps/devps/afmtodit: Change calculation of asc_boundary and
	desc_boundary.  Make these bounds inclusive.
	* ps/devps: Regenerate font files.

Tue Jul  7 13:14:15 1992  James Clark  (jjc at jclark)

	* macros/tmac.latin1: New file.
	* macros/tmac.tty-char: Use tmac.latin1.
	(tmac.tty-tr): Deleted.
	* macros/Makefile: Install tmac.latin1.
	* macros/tmac.dvi: Use tmac.latin1.
	* macros/troffrc: Translate \[char160] onto no-break space here.
	* macros/{tmac.dvi,tmac.ps,tmac.tty,tmac.X75}: Don't do it here.

Mon Jul  6 11:06:52 1992  James Clark  (jjc at jclark)

	* macros/tmac.Xps: Use `do' request.

	* macros/tmac.ps: Use `do' request.

	* macros/tmac.e (@C): Use `do' request.

	* macros/tmac.X, macros/tmac.Xps: Moved from xditview.
	* macros/Makefile: Install tmac.X*.

	* tty/tmac.tty, tty/tmac.tty-char: Move to macros.
	* tty/Makefile: Don't install tmac.tty*.
	* macros/Makefile: Install tmac.tty*.

	* dvi/tmac.dvi: Move to macros.
	* dvi/Makefile: Don't install tmac.dvi.
	* macros/Makefile: Install tmac.dvi.

	* ps/tmac.ps*: Move to macros.
	* ps/Makefile: Don't install tmac.ps*.
	* macros/Makefile: Install tmac.ps*.

	* eqn/box.c: Provide draw_lines parameter corresponding to -D
	option.
	* macros/eqnrc: Set draw_lines parameter based on device.
	* groff.c: Don't pass -D flag to eqn.
	* groff.sh: Likewise.
	* eqn/main.c: Warn about use of -D.

	* troff/input.c (process_startup_file): New function.
	(main): Call process_startup_file().
	* macros/troffrc: New file.
	* macros/Makefile: Install troffrc.
	* groff.c (main): Don't pass extra -m option to troff. For a 
	pseudo device pass the name of the pseudo device to troff using
	-d.
	* groff.sh: Likewise.
	* groff.c (possible_command::prepend_arg): Deleted.

	* troff/input.c (do_request): New function.
	(init_input_requests): Bind "do" to do_request.

	* eqn/main.c (main): Instead of loading eqnchar from device directory,
	load eqnrc from macro directory.
	* macros/eqnrc: New file.
	* macros/Makefile: Install eqnrc.
	* ps/devps/eqnchar: Deleted.
	* ps/devps/Makefile: Don't install eqnchar.
	* dvi/devdvi/eqnchar: Deleted.
	* dvi/devdvi/Makefile: Don't install eqnchar.
	* groff.c (main): Pass -M to eqn. Don't pass -F to eqn. New
	variable optM.

	* lib/device.[ch]: New files.
	* lib/font.h (font::set_device_name, font::get_device_name):
	Deleted.
	* lib/fontfile.c: Use device.h.
	* lib/Makefile: Handle device.[ch]. Make paths.h define DEVICE.
	* troff/input.c: Delete definition of `device'.
	(main): Don't initialize device.
	* troff/troff.h: Include device.h rather than declaring device.
	* troff/Makefile: No need to handle DEVICE.
	* driver/input.c: Include device.h. Don't use
	font::{set,get}_device_name.
	* groff.c, Makefile: Rename device.h to config.h.
	* groff.c: Use library device variable.
	* eqn/main.c: Use library device variable.
	* eqn/Makefile: No need to handle DEVICE.

	* lib/searchpath.[ch]: New files.
	* lib/Makefile: Handle searchpath.[ch].
	* troff/input.c (open_file, init_dirs): Deleted.
	(macro_dirs): Deleted.
	(open_mac_file, macro_source): Use class search_path.
	(add_string, struct string_list): Move definition.
	(main): Change -M option to use macro_path. Delete call to
	init_dirs().
	* lib/fontfile.c (font::command_line_font_dir, font::open_file):
	Rewrite to use class search_path.
	* lib/font.h, lib/fontfile.c (font::cl_font_dirs): Deleted.
	* lib/Makefile: fontfile.c depends on searchpath.h.
	* lib/Makefile: Rename fontpath.h to paths.h. Make paths.h define
	MACROPATH.
	* lib/macropath.[ch]: New files.
	* troff/Makefile: No need to handle MACROPATH.

	* troff/input.c: Delete DUMP code.
	* lib/fontfile.c, lib/font.h: Delete
	font::forget_command_line_font_dirs.

	* troff/input.c (push_token): New function.
	(handle_first_page_transition): Use push_token().
	(process_input_stack): Change handling of a space at the beginning
	of the line.

Sun Jul  5 17:11:09 1992  James Clark  (jjc at jclark)

	* troff/input.c (font_dirs): Delete unused variable.

	* eqn/lex.c (do_set): Correct error messages.

Sat Jul  4 10:20:55 1992  James Clark  (jjc at jclark)

	* troff/input.c (do_define_string): Allow the string name to be
	followed immediately by a tab.
	(define_character): Likewise.

Thu Jul  2 10:59:15 1992  James Clark  (jjc at jclark)

	* ps/ps.c (ps_printer::draw): When drawing an arc, don't allow k to
	be negative.

	* troff/input.c (input_iterator::is_file): New virtual function.
	(file_iterator::is_file): New function.
	(input_stack::end_file): New function.
	(input_stack::next_file): Handle the situation where there is no
	file on the input stack correctly.  Avoid making two passes over
	the input stack.
	(next_file): Make the filename optional; in this case call
	input_stack::end_file().

Wed Jul  1 10:17:25 1992  James Clark  (jjc at jclark)

	* dvi/tmac.dvi: Change the definitions of \(ul and _ so that they
	produce a real _ charater when the current font is CW and _
	otherwise.

	* lib/errarg.c (errarg::errarg(const char *)): Invert conditional
	expression to work around gcc 2.2 bug.

Wed Jun 24 08:12:24 1992  James Clark  (jjc at jclark)

	* eqn/main.c (main): Don't give an error if we can't find eqnchar.

	* troff/env.c (environment::add_padding): New function.
	(environment::add_char): Use add_padding().
	(environment::space): Likewise.
	(environment::wrap_up_field): Add some padding if there is none
	and there's no current tab.
	* troff/env.h: Declare environment::add_padding.

Mon Jun 22 08:37:45 1992  James Clark  (jjc@jclark)

	* pic/pic.y: undef fmod and rand before declaring them.

Sun Jun 14 11:40:18 1992  James Clark  (jjc@jclark)

	* troff/input.c (main): If the DESC file specifies a font name of
	0, then leave the corresponding font position empty.

	* nroff.sh: New file.
	* Makefile (install.nobin): Install nroff.sh.

	* tty/devlatin1/R.proto: Add ao as synonym for de.
	* tty/tmac.tty-char: Define ao as o.

	* tty/dev{ascii,latin1}/R.proto: Add aq.
	* tty/tmac.tty-char: Delete definition of aq.

Mon Jun  8 11:43:20 1992  James Clark  (jjc@jclark)

	* troff/input.c (init_charset_table): Don't translate 0240.
	* ps/tmac.ps: Translate char160 to space.
	* dvi/tmac.dvi: Likewise.
	* tty/tmac.tty: Likewise.

Sun Jun  7 10:52:35 1992  James Clark  (jjc@jclark)

	* dvi/tmac.dvi: Add support for all Latin-1 characters.

	* macros/tmac.s: Delete definitions of \(rg, \(ah, \(ad, \(a-,
	\(ao, \(ac, \(ho, \(-D, \(Sd, \(TP, \(Tp, \(ss, \(AE, \(ae, \(OE,
	\(oe, \(r?, \(r!.

	* tty/tmac.tty-char: Add \(ah.

	* dvi/tmac.dvi: Add definitions of Tp, TP, Sd, -D, ho.
	No need to define \(FM and \(!/. Conditionalize all character
	definitions.

	* ps/devps/lgreekmap: Add +h, +f, +p.

	* ps/tmac.psnew: New file.
	* ps/Makefile: Install tmac.psnew.

	* troff/input.c (charinfo_to_node_list): Don't ever interpret
	character definitions in compatible mode.

	* troff/input.c (remove_character): New function.
	(init_input_requests): Bind remove_character to "rchar".

	* ps/tmac.psold: New file.
	* ps/Makefile: Install tmac.psold.
	* ps/tmac.ps: Load tmac.psold. Move definitions of ISO Latin-1
	characters into tmac.psold.  Make these definitions unconditional.

	* tty/tmac.tty-char: Define \n(_C only if it is not already defined.

	* ps/tmac.ps: Don't define \('c and \('C.

	* ps/devps/textmap: Move Greek characters to...
	* ps/devps/symbolchars:

Sat Jun  6 16:41:17 1992  James Clark  (jjc@jclark)

	* ps/devps/text.enc: Add quotesingle.
	* ps/devps/textmap: Add +h, +f, +p, Fn, Bq, bq, aq, lz.
	* tty/tmac.tty-char: Likewise.
	* dvi/devdvi/texmi.map: Add +h, +f, +p.
	* dvi/devdvi/texi.map: Add Fn.
	* dvi/devdvi/msam.map: Add lz.
	* dvi/tmac.dvi: Handle Bq, bq, aq.

	* pic/lex.c (get_token): Recognize 'th.
	* pic/map.y: Allow `expr'th in contexts where ORDINAL was allowed.

Fri Jun  5 11:20:46 1992  James Clark  (jjc@jclark)

	* ps/devps/textmap: Move di, mu, +- to...
	* ps/devps/symbolchars:

	* macros/tmac.s (@XS): Don't call par@reset or fi.
	(XA): Call LP. Turn off adjustment. Reduce line length.

	* macros/tmac.s: Initially alias XS to LP.
	(XS): Rename to @XS.
	(cov*ab-init): Alias XS to @XS.

Thu Jun  4 09:12:05 1992  James Clark  (jjc@jclark)

	* troff/token.h: Delete TOKEN_CHAR_HEIGHT, TOKEN_CHAR_SLANT,
	TOKEN_FONT_NAME, TOKEN_FONT_POSITION, TOKEN_SIZE tokens.
	(token::is_size, token::changes_env): Deleted.
	* troff/number.c (parse_term): No need to process \s explicitly.
	Call tok.next() only after scale indicator has been processed.
	* troff/input.c (do_overstrike, do_bracket): No need to process \s,
	\f etc explicitly.
	(token::next): Handle \s, \f, \S, \H immediately rather than
	returning them as tokens.
	(token::operator==, token::description, token::add_to_node_list,
	token::process): Remove handling of deleted tokens.

	* troff/env.c (environment::add_char): When adding padding
	indicator character, call start_line() if necessary.

Wed Jun  3 09:55:50 1992  James Clark  (jjc@jclark)

	* ps/devps/afmtodit: Don't output 0 kerns.

	* ps/devps/afmtodit: Remove directory from name of encoding in
	font description file.

	* ps/devps/afmtodit: Improve error messages.

	* ps/devps/afmtodit: Allow DESC file to be specified with -d.

	* ps/devps/Makefile: Incorporate FontMakefile. Rework.
	* ps/devps/FontMakefile: Deleted.
	* ps/devps/afmname: New file.

	* ps/devps/symbol.sed: New file.
	* ps/devps/symbol.diff: Deleted.
	* ps/devps/FontMakefile: Generate symbol.afm using symbol.sed.
	Generate zapfdr.afm from zapfd.afm.

	* tty/tmac.tty (tty-char): Prefix definition with ".

	* macros/tmac.an (TP): Don't start a diversion if one has already
	been started.

	* tty/tmac.tty-char: Add Latin-1 characters.

	* tty/tmac.tty-char: Incorporate suggestions from Paul Eggert.

Tue Jun  2 00:54:34 1992  James Clark  (jjc@jclark)

	* tbl/table.c (table::allocate): Delete old_vline, old_entry.
	Move declaration of struct horizontal_span.

	* tbl/table.c (table::table): Initialize span_list.
	(table::~table): Delete span_list.

	* lib/ptable.h (PTABLE(T)::~PTABLE(T)): Delete v.

	* ps/devps/Makefile: Avoid dependency on GNU make.

	* ps/tmac.ps: Check that character does not already exist before
	defining it.

	* tty/tmac.tty: Add definitions of \(ff, \(!=, \(==, \(~=, \(sq,
	\(OE, \(oe, \(AE, \(ae, \(lh, \(rh. Delete definitions of \(en,
	\(ru, \(ul, \(br, \(bv, \(sl which are in the font description
	files.

	* tty/tmac.tty-char: New file.
	* tty/Makefile: Install tmac.tty-char.
	* tty/tmac.tty: Move definitions of \(ua, \(da, \(uA, \(dA into
	tmac.tty-char.

	* tty/tmac.tty: Fix definition of \(34.

	* tty/dev{ascii,latin1}/R.proto: Add ha and ti. Map
	bracket-drawing characters onto |. Add *o.

	* troff/env.c (environment::wrap_up_tab): Increment field_spaces
	only if current_field.

	* troff/dictionary.c (dictionary::lookup): Free old_table after
	rehashing. 

Mon Jun  1 10:15:22 1992  James Clark  (jjc@jclark)

	* tty/dev{ascii,latin1}/R.proto: Add uppercase Greek characters
	whose glyphs are identical to glyphs of some Roman character.

	* tty/devlatin1/R.proto (bu): Deleted.
	* tty/devascii/R.proto (bu): Deleted.
	* tty/tmac.tty: Add definition of \(bu.

	* eqn/main.c (do_file): Pass FILE as argument.
	(main): Automatically load eqnchar.  New options -F and -n.
	Pass do_file an opened FILE.
	* groff.c: Don't pass eqnchar to eqn. Pass -F options onto eqn.
	No need to include font.h.
	* groff.sh: Likewise.  Don't need to use - for standard input.
	Prefix files with -- if first file starts with -.

	* macros/tmac.e: Conditionalize use of \$* on \n(.g.

	* troff/env.c (environment::possibly_break_line): Don't set line
	to 0 across call to output_line().  Don't call output_line() until
	after discarding nodes after break.

Sun May 31 10:45:29 1992  James Clark  (jjc@jclark)

	* request.h (macro::empty): Declare it.
	* input.c (macro::empty): New method.
	(interpolate_macro):  Don't give a WARN_SPACE if the two-character
	macro is empty.

Sat May 30 10:27:15 1992  James Clark  (jjc@jclark)

	* troff/env.c (environment::start_field): Decrement space_total
	when a space is frozen.

Fri May 22 14:34:38 1992  James Clark  (jjc@jclark)

	* macros/tmac.an (R): Delete macro.

	* troff/input.c (get_copy, token::next): Support \# (like \" but
	newline is ignored).

	* troff/input.c (token::next): Fix error message in 'Y' case.

Thu May 21 09:26:24 1992  James Clark  (jjc@jclark)

	* eqn/delim.c (define_extensible_string): Recognize any prefix of
	a delimiter name.

Fri May 15 10:20:41 1992  James Clark  (jjc at jclark)

	* c++test.c: Include <osfcn.h>.

	* lib/strtol.c, lib/getcwd.c, ps/psbb.c: Declare errno in case
	<errno.h> doesn't.

Fri May  8 09:37:19 1992  James Clark  (jjc at jclark)

	* tbl/table.c (table::divide_span): Don't count column separation
	if expand was specified.

	* tbl/main.c (process_format): Don't ignore width specs in
	continued format.  Give warning for changing equal widths or
	column separation in continued format.
	(process_data): Set column separation, minimum width, equal
	columns at end of table.

Thu May  7 08:50:40 1992  James Clark  (jjc at jclark)

	* troff/node.c (kern_pair_node::add_discretionary_hyphen,
	node::add_discretionary_hyphen): Use soft_hyphen_char.
	(set_soft_hyphen_char): New function.
	(init_node_requests): Bind to shc.  Initialize soft_hyphen_char.

	* Makefile (c++tested): Give more helpful message if test fails.

Tue May  5 10:58:39 1992  James Clark  (jjc at jclark)

	* troff/input.c (init_charset_table): Translate 0240 to
	an unbreakable space.

	* troff/token.h (token::hyphen_indicator): New function.
	* troff/charinfo.h (TRANSLATE_HYPHEN_INDICATOR): New special
	translation.
	* troff/input.c (translate): Allow translation to \%.
	* troff/node.c (node::add_char): Handle
	TRANSLATE_HYPHEN_INDICATOR.	
	(make_node): Don't allow TRANSLATE_HYPHEN_INDICATOR here.

	* troff/input.c (init_charset_table): Don't set BREAK_AFTER flag
	for \(hy.

	* tty/devlatin1/R.proto: \(hy and - should print as 055.

Tue Apr 21 09:24:42 1992  James Clark  (jjc at jclark)

	* groff.c (run_commands): If the last command gets a SIGPIPE send
	a SIGPIPE to all children than haven't yet terminated.  When
	command terminates, set pid field to -1.

Fri Apr 17 11:20:48 1992  James Clark  (jjc at jclark)

	* groff.c (main): Pass an appropriate -filename option to gxditview.

Thu Apr 16 15:11:40 1992  James Clark  (jjc at jclark)

	* Makefile.bd (install): Remove existing program before copying.

	* Makefile, */Makefile, Makefile.bd, groff.sh, groff.c: Allow
	programs which have Unix counterparts to be installed with
	user-specified prefix.

	* troff/input.c (exit_troff): Don't check if exit_started.
	(exit_request): Don't call exit_troff if exit_started.

	* Makefile.bd (install.mm): Rename to install.dwbmm.

Tue Apr 14 10:05:10 1992  James Clark  (jjc at jclark)

	* driver/input.c (do_file): Add missing break for '#' case.

Mon Apr 13 10:11:02 1992  James Clark  (jjc at jclark)

	* troff/input.c (input_stack::clear):  Clear past any boundaries and
	then add the boundaries back.

	* troff/input.c (exit_troff): Return immediately if already
	exiting.

	* macros/tmac.s (pg@end-text): New macro.  Use pg@end-text for the
	end macro.
	(pg*end-page): If the text has ended and there are no more
	footnotes or keeps, exit.

	* macros/doc-ditroff (Lq, Rq): Define as \(lq and \(rq.

	* troff/input.c (init_charset_table): Make \(rq transparent by
	default.

	* macros/tmac.an: Define lq and rq strings.

	* macros/tmac.s (Q, U): Define as \(lq and \(rq.

Sun Apr 12 12:54:37 1992  James Clark  (jjc at jclark)

	* troff/env.c (environment::final_break): New function.
	(environment::newline): Set prev_line_interrupted to 2 if
	exit_started.
	* troff/env.h: Declare environment::final_break.
	* troff/input.c (exit_troff): Call environment::final_break()
	instead of environment::do_break().

	* macros/Makefile: Install man.local if $(MACRODIR)/man.local
	doesn't already exist.
	* macros/man.local: New file.
	* macros/tmac.an: Load man.local.
	* macros/man.ultrix: New file.

Sat Apr 11 17:32:04 1992  James Clark  (jjc at jclark)

	* troff/input.c (exit_groff): Rename to...
	(exit_troff): New function.

	* troff/div.c (exit_started, done_end_macro,
	seen_last_page_ejector): New global variables.
	(began_page_in_end_macro): New static variable.
	(exit_flag): Deleted.
	(top_level_diversion::top_level_diversion): Initialize
	last_page_count.
	(top_level_diversion): More elaborate test for whether
	cleanup_and_exit() should be called.
	Set began_page_in_end_macro if the end macro isn't yet finished.
	* troff/div.h (top_level_diversion::last_page_count): New data
	member.
	(top_level_diversion::set_last_page): New function.
	(exit_started, done_end_macro, seen_last_page_ejector): Declare.
	* troff/env.c (do_break): Zero prev_line_interrupted.
	* troff/input.c (exit_flag): Delete declaration.
	(LAST_PAGE_EJECTOR): New magic cookie.
	(token::next): Handle LAST_PAGE_EJECTOR.
	(exit_groff): Set exit_started and done_end_macro instead of
	exit_flag.  Call top_level_diversion::set_last_page.  Push a
	LAST_PAGE_EJECTOR instead of calling push_page_ejector().  Do
	another ejection after setting seen_last_page_ejector.

Thu Apr  9 04:37:11 1992  James Clark  (jjc at jclark)

	* etc/grog.sh, etc/grog.sh: Recognize -me sh macro.

	* macros/tmac.e (TH): Make sure there's room for the initial
	header.

	* macros/tmac.s (par@init): Make PD and DD at least \n(.V.
	Set FVS in points rather than units.

Mon Apr  6 11:21:32 1992  James Clark  (jjc at jclark)

	* troff/div.c (top_level_diversion::add_trap): Don't consider the
	position of empty slots.

Fri Apr  3 10:46:45 1992  James Clark  (jjc at jclark)

	* ps/devps/S: Fix height and depth of parenrightex.
	* ps/devps/symbol.diff: Regenerate.

Sat Mar 28 21:17:52 1992  James Clark  (jjc at jclark)

	* tmac.e (u): Do underlining as in -mgs.

Fri Mar 27 09:23:44 1992  James Clark  (jjc at jclark)

	* tty/tty.c (tty_printer::end_page): If overstriking is
	suppressed, still turn overstruck horizontal and vertical lines
	into +.

	* lib/new.c: Back out Feb 24 change; no longer needed with gcc
	2.1.

	* refer/label.y (format_expr::evaluate): Avoid use of %0*d.

Wed Mar 18 09:29:10 1992  James Clark  (jjc at jclark)

	* Version 1.05 released.

Tue Mar 17 16:50:45 1992  James Clark  (jjc at jclark)

	* tty/tty.c: Instead of keeping an array of glyphs and then
	sorting it, keep a ordered linked list of glyphs for each line.

	* driver/driver.h: Include stddef.h.

	* tty/tty.c (compare_glyph):
	* refer/refer.c (rcompare):
	* troff/env.c (compare_ranges): Arguments of qsort comparison
	function should be const void *.

	* troff/number.c (parse_term):
	* dvi/dvi.c (draw_dvi_printer::draw): Avoid initialization in
	switch statement.

	* refer/label.y (consider_authors): Don't access variables
	constructed under a condition outside that condition: put braces
	round for statement containing declaration; redeclare use of same
	variable later.

	* pic/pic.y (text_expr): Delete production that allows
	parenthesised text_expr.
	(expr): Allow a conditional_expr to appear in parentheses.
	(conditional_expr): Rename to any_expr.

	* mm: Install new version 1.01 from jh.

	* lib/font.c (font::get_width): Cache scaled widths.
	(font::font): Initialize widths_cache.
	(font::~font): Destroy widths_cache.
	* lib/font.h: Add font::widths_cache. Declare font_widths_cache.

Mon Mar 16 10:16:10 1992  James Clark  (jjc at jclark)

	* c++test.c, c++test.ref: New files.
	* Makefile: Check that the C++ compiler works.

	* ps/tmac.pspic (PSPIC): Do a break.

	* ps/tmac.ps: Move definition of PSPIC into...
	* ps/tmac.pspic: New file.
	(PSPIC): Draw box around picture, but make it invisible to grops.
	* ps/tmac.ps: Load tmac.pspic.
	* ps/Makefile: Install tmac.pspic.

Sun Mar 15 14:18:08 1992  James Clark  (jjc at jclark)

	* lib/font.c (scale_round): If n is negative,
	subtract .5 before truncating floating point result.

	* lib/fontfile.c: Include <errno.h>.

Tue Mar 10 14:17:03 1992  James Clark  (jjc at jclark)

	* driver/input.c (get_char): Inline. Don't update current_lineno.
	Change callers to up date current_lineno if necessary.
	Use get_char() instead of getc(current_file).

Sun Mar  8 18:05:28 1992  James Clark  (jjc at jclark)

	* ps/tmac.ps: Fix up spacing of \(mo and \(nm.

Fri Mar  6 19:38:58 1992  James Clark  (jjc at jclark)

	* tty/tty.c (tmac.tty): Define \(rg as (R).

Tue Mar  3 10:11:25 1992  James Clark  (jjc at jclark)

	* lib/lib.h: New define a_delete.
	* Use a_delete instead of delete when deleting an array of objects
	without destructors.

	* lib/lib.h: Rename adelete to ad_delete.
	* Change uses of adelete.

Mon Mar  2 12:41:05 1992  James Clark  (jjc at jclark)

	* eqn/eqn.y: Include lib.h.

	* troff/node.c (grow_font_table): Delete old_font_table.

	* mm: Install new version from jh.

Fri Feb 28 10:42:23 1992  James Clark  (jjc at jclark)

	* tbl/table.h (format_type): Make global instead of local to class
	entry_format.  Prefix enumerators with FORMAT_.
	* tbl/table.c, tbl/main.c: Corresponding changes.
	* refer/token.h (token_type): Make global.  Prefix enumerators
	with TOKEN_.
	* refer/token.[ch]: Corresponding changes.
	* Makefile: Get rid of -DNO_NESTED_TYPES configuration option.

	* troff/div.c (node::set_vertical_size): Don't name argument.

Thu Feb 27 10:29:19 1992  James Clark  (jjc at jclark)

	* Makefile: New configuration option ARRAY_DELETE_NEEDS_SIZE.
	* lib/lib.h: Define adelete accordingly.
	* pic/object.c (graphic_object::graphic_object):
	* tbl/main.c (format::~format):
	* tbl/table.c (table::~table):
	* refer/ref.c (reference::~reference, reference::merge,
	reference::insert_field, reference::delete_field): Use adelete.

	* Makefile: Change NESTED_TYPES to NO_NESTED_TYPES.
	* refer/token.h:
	* tbl/table.h: Corresponding changes.

	* common.c (common_output::dashed_arc, common_output::dotted_arc):
	Ensure total_angle is positive.

Wed Feb 26 08:49:26 1992  James Clark  (jjc at jclark)

	* refer/ref.c (reference::merge, reference::insert_field,
	reference::delete_field): Avoid delete[0].

	* refer/token.c (init_special_chars): Move calls to cmupper
	outside calls to init_two_char_letter to work around bug in gcc
	2.0.

Mon Feb 24 14:20:00 1992  James Clark  (jjc at jclark)

	* lib/new.c (operator new): Use __builtin_new for g++.

	* pic/object.c (graphic_object::~graphic_object):  Don't use
	delete [] on 0.

	* pic/object.c (output::compute_scale): Initialize max_width and
	max_height.

Sat Feb 15 09:55:20 1992  James Clark  (jjc at jclark)

	* troff/input.c (write_request): Call fflush.

	* troff/node.h (class composite_node): Move declaration to node.c
	* troff/input.c (charinfo_to_node): Rename to ...
	(charinfo_to_node_list): Return node list rather than composite
	node.
	* troff/node.c (make_composite_node): New function.
	(make_node, add_char): Call make_composite_node instead of
	charinfo_to_node.
	(class composite_node): Add a tfont * member.  Delete font_size
	member.
	(composite_node::composite_node, composite_node::copy,
	composite_node::size): Corresponding changes.
	(composite_node::tprint): Provide constant spacing, emboldening
	and track kerning as specified in tfont.
	(composite_node::width): Change width calculation accordingly.
	* troff/env.h (environment::composite): New member.
	(environment::is_composite, environment::set_composite): New
	functions.
	* troff/env.c (environment::environment): Initialize composite.
	* troff/input.c (charinfo_to_node): Call
	environment::set_composite.
	* troff/node.c (make_composite_node, make_glyph_node): Use the
	plain version of the tfont if the environment is composite.

	* troff/node.c (font_info::get_space_width): Additional argument
	giving space_size.  Handle constant space correctly. Scale by
	space_size unless constant spaced.
	(env_sentence_space_width): New function.
	* troff/node.h: Declare it.
	* troff/env.h (environment::get_space_size,
	environment::get_sentence_space_size,
	environment::get_narrow_space_width,
	environment::get_half_narrow_space_width): Make inline.
	(environment::get_space_width): Make inline.  Just call
	env_space_width.
	* troff/env.c: Delete definitions for funtions made inline.
	(environment::space_newline, environment::space): Use
	env_sentence_space_width(). Don't scale by space_size.
	* troff/node.h: Move declarations of env*space_width() functions
	into env.h.

Sat Feb  8 09:30:22 1992  James Clark  (jjc at jclark)

	* macros/tmac.s (PS): Don't try to set negative indent.

Thu Feb  6 09:00:35 1992  James Clark  (jjc at jclark)

	* pic/pic.y: Fix min function.

Tue Jan 28 07:52:29 1992  James Clark  (jjc at jclark)

	* man/mdate.sh: Clear LANGUAGE.

Sun Jan 19 13:02:41 1992  James Clark  (jjc at jclark)

	* pic/pic.y, pic/lex.c: Rename COMMAND token to COMMAND_LINE.
	* pic/lex.c: New COMMAND keyword.
	* pic/pic.y (print_args, print_arg): New rules.
	(placeless_element): Use print_args for PRINT.
	New COMMAND element.

Tue Jan  7 13:14:31 1992  James Clark  (jjc at jclark)

	* troff/input.c (terminal): Handle missing argument correctly.

	* pic/pic.y (text_expr): New rule.

	* pic/pic.y: Implement := operator.

Sun Jan  5 10:23:02 1992  James Clark  (jjc at jclark)

	* etc/grog.pl, etc/grog.sh: Distinguish old and new versions of
	mdoc.

Sat Jan  4 14:42:26 1992  James Clark  (jjc at jclark)

	* ps/devps/dingbatsrmap: Include this in the distribution.

	* macros/tmac.doc: Replace with new version from 2nd Networking
	Release. Fix loading of doc-* files.
	* macros/{doc-common,doc-ditroff,doc-nroff,doc-syms}: New files.
	* macros/tmac.doc.old: New file.  Apply fixes that had been
	applied to old tmac.doc.
	* macros/tmac.andoc: Check that we're running under groff.
	* macros/Makefile: Rework.

Fri Jan  3 13:27:51 1992  James Clark  (jjc at jclark)

	* tbl/table.h (format_type): 
	* refer/token.h (token_type): If NESTED_TYPES is defined, use
	typedef to make these types visible at file scope.
	* Makefile: Add NESTED_TYPES configuration option.

	* troff/div.c (mark): At the top level use the value of
	nl_reg_contents rather than the current vertical position.

Thu Jan  2 10:34:51 1992  James Clark  (jjc at jclark)

	* tty/tty.c: Implement \D for horizontal or vertical lines.
	(tty_printer::set_char): Use vec_used+2 as serial number.
	Don't allow size of vector to exceed USHRT_MAX-2.
	Split off part into...
	(tty_printer::add_char): New function.
	(tty_printer::draw): New function.
	(compare_glyph): Handle equal serial numbers.
	(tty_printer::end_page): Handle overstruck characters from \D.
	(main, usage): Implement -d option.

Mon Dec 23 10:37:51 1991  James Clark  (jjc at jclark)

	* tbl/main.c (process_format):
	* eqn/text.c (split_text):
	* troff/input.c (token::next): Use inner block for declarations
	with initializers in switch statement.

Mon Dec 16 20:52:03 1991  James Clark  (jjc at jclark)

	* pic/common.c (common_output::dash_line): Cope with zero-length
	lines.

Sun Nov 17 12:04:08 1991  James Clark  (jjc at jclark)

	* Version 1.04 released.

Wed Nov 13 05:27:21 1991  James Clark  (jjc at jclark)

	* macros/tmac.an (TH): Define a macro an-init to define variables
	based on command line arguments.
	(an-header): Call it.

Sun Nov  3 12:07:34 1991  James Clark  (jjc at jclark)

	* Makefile (install.mm): Rename to install.dwbmm.

	* Makefile: Integrate mm.
	* mm: New directory.

Wed Oct 30 10:11:34 1991  James Clark  (jjc at jclark)

	* refer/dirnamemax.c: If PATHCONF_MISSING is defined, include
	<sys/types.h>.

	* pic/troff.c (troff_output::simple_spline,
	troff_output::simple_polygon): Rename variable `v' to `d' to avoid
	shadowing parameter.

	* lib/tmpfile.c (xtmpfile): Declare dir as const char *.

	* lib/ptable.h: Add explicit casts when converting from unsigned
	long to unsigned.

	* dvi/devdvi/{SA,SB,msam.map,msbm.map}: New files.
	* dvi/devdvi/Makefile: Install SA, SB.

	* refer/indxbib.c: Add declaration of mktemp.

	* refer/lookbib.c: Add declaration of isatty.

Fri Oct 25 09:00:17 1991  James Clark  (jjc at jclark)

	* pic/lex.c (interpolate_macro_with_args):  While collecting
	arguments, keep track of whether we're in a string.

Wed Oct 23 08:42:48 1991  James Clark  (jjc at jclark)

	* ps/tmac.ps (PSPIC): Do the .sp after the \X, and move the \X
	down with \v, so as to avoid problems with top of page trap
	setting no space mode.

Tue Oct 22 17:38:49 1991  James Clark  (jjc at jclark)

	* eqn/lex.c (get_delimited_text): Allow tab before macro body.

Tue Oct 15 17:24:53 1991  James Clark  (jjc at jclark)

	* ps/psrm.c (ps_get_line): Fix bug when lines longer than 255.
	Improve error message.

Fri Oct 11 11:09:38 1991  James Clark  (jjc at jclark)

	* ps/psrm.c (print_ps_string): Don't pass negative numbers to
	printf("%03o");

Wed Oct  9 17:50:14 1991  James Clark  (jjc at jclark)

	* groff.c (possible_command::execp): Always use _exit() after a
	failed exec.

	* Makefile: Add HAVE_UNION_WAIT, HAVE_PID_T, WAIT_COREDUMP_0200,
	NO_SYS_WAIT_H 	configuration options.
	* groff.c: Use these options.  Use POSIX-style macros to extract
	fields from the status returned by wait().

Fri Oct  4 12:12:27 1991  James Clark  (jjc at jclark)

	* tbl/table.c (table::compute_separation_factor): Allow the
	separation factor to drop to 0.

Tue Oct  1 18:12:38 1991  James Clark  (jjc at jclark)

	* refer/search.c: Include <errno.h>.

Sun Sep 29 08:40:57 1991  James Clark  (jjc at jclark)

	* pic/pic.y (YYDEBUG): Don't define for Borland C++.

	* lib/lib.h: #ifdef out declarations of itoa and iftoa for Borland
	C++. 

	* pic/lex.c (input_stack::bol): Move definition out of class body.

	* pic/main.c: On MSDOS munge argv[0].

	* lib/ptable.h: Define name2 as _Paste2 for Borland C++.

	* lib/ptable.c (hash_string): Use unsigned long rather than
	unsigned.
	(next_ptable_size): Use unsigned rather than int.  Give an error
	message if we've hit the largest table size.
	* lib/ptable.c: Corresponding changes.  Also use unsigneds for the
	table size.

	* pic/object.h (object_spec): Make flags unsigned long.  Declare
	flags as const unisgned long rather than as enums.

	* pic/output.c: Deleted.

	* pic/troff.c (troff_output::simple_ellipse): Remove spurious %.

	* tbl/table.c (simple_entry::note_double_vrule_on_{left,right}):
	Add additional argument.
	(line_entry::note_double_vrule_on_{left,right}): Set value of
	douvle_vrule_on_{right,left} flag according to argument.
	(simple_line_entry::simple_print,
	simple_line_entry::double_line_print): If adjacent to double vrule
	on a corner extend rather than shorten the rule by half the double
	vrule sep.

	* troff/number.c (parse_term): In checking for overflow, handle the
	case where the current horizontal position is negative.

Thu Sep 12 08:26:09 1991  James Clark  (jjc at jclark)

	* pic/object.c (draw_arrow): Check for object having zero length.

Wed Sep 11 10:32:38 1991  James Clark  (jjc at jclark)

	* eqn/main.c (do_file): Split off inline equation handling into...
	(inline_equation): New function.  Search for starting delimiter
	using...
	(delim_search): New function. Don't recognize a delimiter that
	occurs in the name of an escape sequence, number register, string
	etc.

Tue Sep 10 04:01:11 1991  James Clark  (jjc at jclark)

	* eqn/delim.c (delim_box::compute_metrics): Don't call
	define_extensible_string if left is 0.
	(delim_box::output):  Don't print the left delimiter if left is 0.
	(delim_box::debug_print): Check for left == 0 before calling printf.

Fri Aug 23 13:02:30 1991  James Clark  (jjc at jclark)

	* troff/Makefile (majorminor.c): Include only digits in
	minor_version.

Thu Aug 22 09:35:37 1991  James Clark  (jjc at jclark)

	* refer/dirnamemax.c: new file.
	* refer/genlimits.c: Deleted.
	* refer/indxbib.c (main): Use dir_name_max() instead of NAME_MAX.
	Don't check path length.
	* refer/Makefile: Add dir_name_max.o; delete genlimits.
	* Makefile: Add PATHCONF_MISSING option.

	* refer/indxbib.c (get_cwd): New function.
	(main): Use get_cwd().
	* lib/getcwd.c: New file.
	* Makefile: Delete -DHAVE_GETWD. Include GETCWD variable. Pass
	GETCWD in SUBFLAGS.
	* lib/Makefile: Compile getcwd.o.

	* ps/tmac.psatk (psatk-defs): Define showpage after pushing
	userdict.

	* refer/indxbib.c (main): Check success of mktemp.

	* lib/tmpfile.c: New file.
	* lib/Makefile: Add tmpfile.c.
	* lib/lib.h: Declare xtmpfile(); include <stdio.h>.
	* ps/ps.h: Delete declaration of mktemp().
	* ps/ps.c (ps_printer::ps_printer): Use xtmpfile().
	* refer/refer.c (divert_to_temporary_file): Use xtmpfile().
	* driver/driver.h: No need now to include errno.h.

	* everywhere: Set errno to 0 before calling fopen().

	* eqn/eqn.h, etc/soelim.c, driver/driver.h, etc/addftinfo.c,
	dvi/tfmtodit.c, groff.c, refer/index.c, refer/linear.c,
	refer/lookbib.c, refer/refer.h, ps/psbb.c: Include <errno.h>.

Mon Aug 19 10:52:18 1991  James Clark  (jjc at jclark)

	* troff/env.h (translate_space_to_dummy): Declare it.
	* troff/env.c (environment::space_newline, environment::space):
	If translate_space_to_dummy is set then make the width of spaces 0.
	* troff/input.c (translate): If the second character of a
	translation is a space, translate to unbreakable space.  If the
	first character is a space, set or clear translate_space_to_dummy
	according to whether the second character is \&.  Weird!

Tue Jul 30 10:03:56 1991  James Clark  (jjc at jclark)

	* groff.c (run_commands): Don't use non-zero exit code because a
	command gets SIGPIPE.

	* groff.c, groff.sh: Use -mXps with -TXps.

	* ps/ps.c (ps_printer::special): Move call to flush_sbuf() into...
	(ps_printer::do_exec, ps_printer::do_file, ps_printer::do_def,
	ps_printer::do_mdef, ps_printer::do_import): Call flush_sbuf().
	(ps_printer::special): New specials invis and endinvis.
	(ps_printer::do_invis, ps_printer::do_endinvis): New functions.
	(ps_printer::set_char, ps_printer::draw): Return if invis_count>0. 
	(ps_printer::end_page): Check that invis_count == 0.
	(ps_printer::invis_count): New member.
	(ps_printer::ps_printer): Initialize invis_count to 0.

	* troff/env.c (environment::hyphenate_line): Hyphenation
	indicator at beginning of word inhibits splitting after -, \(em
	etc.

	* pic/pic.y (element): Allow another element to follow } without
	any intervening separator.

Mon Jul 22 12:27:37 1991  James Clark  (jjc at jclark)

	* pic/lex.c (get_delimited): Allow tabs before delimiter.

Wed Jul 17 10:59:08 1991  James Clark  (jjc at jclark)

	* groff.c: Get rid of HAVE_UNION_WAIT stuff.  Instead suppress
	declaration of wait() in header files.
	* Makefile: Get rid of -DHAVE_UNION_WAIT.

	* tbl/table.c (alphabetic_text_entry::add_tab): New function.

	* lib/lib.h: Declare return type of strerror as char *.

	* man/Makefile: Add g flag to sed substitutions.
	* Makefile (shgroff, bindist): Likewise.

Sun Jul 14 11:57:02 1991  James Clark  (jjc at jclark)

	* ps/ps.c (ps_printer::do_import): Move push of userdict into...
	* ps/devps/prologue (PBEGIN): Define showpage after pushing
	userdict.

Sat Jul 13 20:53:04 1991  James Clark  (jjc at jclark)

	* ps/devps/prologue (PBEGIN): Zap any definition of showpage in
	userdict.

Fri Jul 12 07:10:09 1991  James Clark  (jjc at jclark)

	* man/mdate.sh: Handle the fact that BSD ls -l does not print the
	group.

Sun Jul  7 08:00:23 1991  James Clark  (jjc at jclark)

	* troff/input.c (define_number_reg):  If currently undefined,
	don't define it if the argument is an invalid expression.

	* Makefile: Ignore return value of `if' commands without `else'
	parts.

	* Makefile: Split up CPPDEFINES into a series of separate
	configuration options.

	* troff/input.c (init_registers): Use time_t instead of long
	unless LONG_FOR_TIME_T is defined.  Use returned result rather
	than passing pointer.
	* Makefile: Document LONG_FOR_TIME_T as a CPPDEFINE.

	* lib/Makefile (fontpath.h): Use gendef.

Thu Jul  4 09:48:05 1991  James Clark  (jjc at jclark)

	* troff/input.c (input_iterator::shift): Delete argument name.
	* troff/node.c (suppress_output_file::really_begin_page,
	suppress_output_file::really_transparent_char, node::ascii_print,
	node::tprint): Delete names of unused arguments.

Wed Jul  3 17:34:57 1991  James Clark  (jjc at jclark)

	* refer/label.y (string):  Pass $4 to command_error.

Tue Jul  2 15:06:01 1991  James Clark  (jjc at jclark)

	* Version 1.03 released.

Sat Jun 29 08:14:01 1991  James Clark  (jjc at jclark)

	* Makefile: Pass definition of SHELL in SUBFLAGS.

	* gendef: New file.
	* Makefile, eqn/Makefile, refer/Makefile, troff/Makefile,
	ps/Makefile: Use gendef to construct header files that are
	constructed from the Makefile.

	* macros/Makefile: make all should build stripped version of tmac.e.

	* refer/Makefile (clean): Remove y.output.

Fri Jun 28 09:44:36 1991  James Clark  (jjc at jclark)

	* ps/pfbtops.c (main): Add -v option which prints out a version
	number.
	* ps/Makefile (pfbtops): Link with libgroff.a.

Fri Jun 21 07:43:23 1991  James Clark  (jjc at jclark)

	* refer/search.h (linear_searcher::get_nkeys): Delete declaration.
	* refer/linear.c (linear_searcher::get_nkeys): Delete definition.

	* refer/lkbib.c (main): Always terminate reference with blank
	line.
	* refer/lookbib.c (main): Likewise.

	* refer/linear.c (file_buffer::load): Check that the file is not a
	binary file.

	* refer/Makefile (genlimits): Possibly add -DHAVE_SYS_DIR_H.
	(genlimits.c): Include <sys/dir.h> if HAVE_SYS_DIR_H is defined.
	Delete second inclusion of <sys/param.h>.

Tue Jun 18 01:32:26 1991  James Clark  (jjc at jclark)

	* troff/token.h (token::special): Deleted.

	* tbl/main.c (process_format): Rework so that opt->tab_char is
	recognized only when appropriate.

	* ps/Makefile (clean): Remove pfbtops.

Sun Jun 16 09:37:19 1991  James Clark  (jjc at jclark)

	* lib/font.c (text_file::next): Don't return if we have got a
	blank line.

Fri Jun 14 09:52:26 1991  James Clark  (jjc at jclark)

	* refer/refer.c (store_reference): Get hash code from old_table[i]
	when rehashing the table.

Thu Jun 13 01:26:43 1991  James Clark  (jjc at jclark)

	* eqn/box.c (box::top_level): Save size and prev size using \R and
	restore it afterwards. Set the size to the size at the beginning
	of the line.
	* eqn/pbox.h: Declare SAVED_INLINE_PREV_SIZE_REG,
	SAVED_INLINE_SIZE_REG, and SAVED_SIZE_REG.

	* refer/Makefile (limits.h): Use ./genlimits.

Wed Jun 12 16:05:34 1991  James Clark  (jjc at jclark)

	* refer/index.c: Delete declarations of stat() and fstat().

Tue Jun 11 14:52:49 1991  James Clark  (jjc at jclark)

	* tty/tmac.tty: Add character definitions for \(>= and \(<=.

Mon Jun 10 22:49:48 1991  James Clark  (jjc at jclark)

	* etc/grog.sh, etc/grog.pl: Change regex for .PS.

Fri Jun  7 09:13:06 1991  James Clark  (jjc at jclark)

	* troff/input.c (token::get_char): Handle \e.

	* refer/linear.c: Delete declarations of fstat() and stat().

Wed Jun  5 09:11:59 1991  James Clark  (jjc at jclark)

	* troff/node.c, troff/env.c, troff/input.c, Makefile: Remove
	OP_DELETE_BROKEN stuff, since we now have a fix for g++.

Mon Jun  3 13:41:32 1991  James Clark  (jjc at jclark)

	* troff/input.c (do_define_macro): Improve error handling for end
	of file while defining macro.

Sun Jun  2 10:20:24 1991  James Clark  (jjc at jclark)

	* eqn/box.h: Fix declaration of set_gsize.
	* eqn/box.c (set_gsize): Make argument const char *.
	(gsize): Declare as char *.
	* eqn/main.c (main): Don't convert gsize to int.
	* eqn/lex.c (do_gsize): Pass char * to set_gsize.

	* Version 1.02 released.

Sat Jun  1 12:19:46 1991  James Clark  (jjc at jclark)

	* macros/tmac.andoc: New file.
	* macros/Makefile: Install tmac.andoc.

	* troff/node.c, troff/env.c, troff/input.c: Conditionalize use of
	operator new and delete on OP_DELETE_BROKEN not being defined.
	* Makefile: Mention OP_DELETE_BROKEN.

Mon May 27 13:49:07 1991  James Clark  (jjc at jclark)

	* Makefile (bindist): Pass SUBFLAGS.

Sun May 26 14:13:22 1991  James Clark  (jjc at jclark)

	* Makefile, groff.c: Pass definitions to groff.c via device.h.

	* tty/tty.c (tty_font::load_tty_font): Avoid shadowing
	parameter.

	* ps/Makefile, ps.c: Pass BROKEN_SPOOLER_FLAGS via broken.h.

	* ps/ps.h, ps/psrm.c: Make comment_table and
	header_comment_table local to resource_manager::process_file.

	* groff.sh: With -TXps pass -printCommand option to gxditview.

	* groff.c (possible_command::print): Implement using
	append_arg_to_string.

	* xditview: Merge in new implementation with own ChangeLog.

Sat May 25 18:33:20 1991  James Clark  (jjc at jclark)

	* groff.c (main): Implement PRINT_OPTION.
	(append_arg_to_string): New command.
	(device_table): Set PRINT_OPTION flag for Xps.

Fri May 24 09:48:58 1991  James Clark  (jjc at jclark)

	* troff/groff.h: Rename to troff.h.

	* pic/lex.c (lookup_keyword, docmp): New functions.
	(get_token): Use new lookup_keyword.
	Don't include key.h.
	* pic/key.[ch], pic/pic.gperf: Deleted.
	* pic/Makefile: Remove gperf stuff.

	* pic/Makefile, pic/output.h: Move definition of TEX_SUPPORT
	into output.h.
	* pic/tex.c: Move include of pic.h before test of TEX_SUPPORT.

	* troff/Makefile, troff/node.c: Move definition of
	STORE_WIDTH into node.c.

	* etc/grog.pl, etc/grog.sh: Support -mdoc.

Thu May 23 12:30:49 1991  James Clark  (jjc at jclark)

	* dvi/devdvi/texr.map, dvi.devdvi/texi.map,
	dvi/devdvi/texb.map: Add lq and rq.
	dvi/devdvi: Regenerate fonts.
	* ps/devps/textmap: Add lq and rq.
	* ps/devps: Regenerate fonts.
	* tty/devascii/R.proto, tty/devlatin1/R.proto: Add lq and rq.
	* macros/tmac.e: Define \*(lq and \*(rq to be \(lq and \(rq.

	* pic/object.c (position_rectangle): When checking radius
	cope with possiblity that width or height is negative.
	(box_object::box_object): Have separate xrad and yrad with
	signs matching signs of dim components.
	(box_object::{north,south}_{east,west}): Use xrad and yrad.
	(box_object::print): With rounded boxes use absolute values
	for dim and rad arguments.

	* lib/Makefile, lib/fontfile.o: Pass definition of FONTPATH
	in fontpath.h.

	* eqn/Makefile, eqn/main.c: Pass definition of DEVICE in device.h.

	* various files: Add explicit destructors to keep Saber CC +d
	happy.

Wed May 22 11:37:11 1991  James Clark  (jjc at jclark)

	* eqn/box.c (box::top_level): Restore fonts correctly after
	font changes in line containing inline equation.  Also
	restore previous font as well as current font.
	* eqn/pbox.h: Define necessary string and register names.

	* troff/input.c (token::next): Case 'R' calls do_register.
	(do_register): New function.

Tue May 21 11:28:23 1991  James Clark  (jjc at jclark)

	* groff.c, groff.sh: Support Xps device.  Allow each device
	to have a pseudo_name and a real_name.

	* groff.c (run_commands): Don't print `Broken pipe' messages.

	* ps/pfbtops.c: New file.
	* ps/Makefile: Add pfbtops.

	* troff/number.c (parse_term): Improved error message.

Mon May 20 11:22:14 1991  James Clark  (jjc at jclark)

	* groff.c, groff.sh, etc/grog.sh, etc/grog.pl: Support grefer.

	* Makefile: Integrate refer.
	* refer: New directory.
	* man/grefer.man, man/glookbib.man, man/gindxbib.man,
	man/lkbib.man: New files.
	* man/Makefile: Support refer man pages.

	* lib/lib.h: Declare is_prime.
	* lib/prime.c: New file.

	* troff/input.c (macro_source): New function.
	(init_input_requests): Bind "mso" to macro_source.

	* troff/env.c (environment::possibly_break_line): Maintain
	pointer to pointer to node to be split in ndp so as to avoid
	using address of freed node.

	* troff/env.c (environment::hyphenate_line): Maintain pointer to
	pointer to first node to be hyphenated in startp so as to
	avoid using address of freed node.

	* troff/env.c (class trie, class hyphen_trie): Make the
	elements of the trie be of type char not unsigned char.
	Declare arguments to be const char* instead of unsigned char *.
	
	* troff/env.c (hyphenate): Initialize hbuf[0].

	* troff/input.c (set_string): Declare p to be char * and cast
	*p to unsigned char when necessary.

	* troff/input.c (do_define_macro): Declare s to be const
	char*. Cast element to unisgned char when necessary, Declare
	d to be an int.  Handle EOF better.

	* troff/Makefile, troff/input.c: Different scheme for passing
	definitions of MACROPATH, HYPHENFILE and DEVICE.

Tue May 14 13:41:36 1991  James Clark  (jjc at jclark)

	* tty/devascii/R.proto: Delete entry for em.
	* tty/devlatin1/R.proto: Likewise.

Sat May 11 11:13:28 1991  James Clark  (jjc at jclark)

	* troff/input.c (translate): Stop when we get a space. Treat eof
	like newline.

	* macros/tmac.an (IP): Only pass quoted argument to TP when \n(.$>1.

Wed Apr 24 19:24:33 1991  James Clark  (jjc at jclark)

	* tbl/main.c (process_format): A font name following a `f'
	modifier that starts with a digit can be only one character long.
	Also deal with EOF on the second character of the font name.

Wed Apr 17 11:23:43 1991  James Clark  (jjc at jclark)

	* troff/input.c (token::next): Turn \~ into an
	unbreakable_space_node.
	* troff/node.c (unbreakable_space_node): New class.
	* troff/node.h: Declare it.

Tue Apr 16 10:47:12 1991  James Clark  (jjc at jclark)

	* dvi/dvi.c (dvi_printer::set_char): Make code an int.  Check that
	it's >= 0, before outputting it as a single byte.

Mon Apr 15 11:20:23 1991  James Clark  (jjc at jclark)

	* lib/font.c: Make font_char_metric::code an int.
	(font::get_code): Change return type to int.
	(font::load): Allow code to be arbitrary integer.
	* lib/font.h (font::get_code): Change return type to int.
	(font::number_to_index): Change argument type to int.
	* troff/input.c (token::next):  In case 'N', allow any value.
	Store value in token::val.
	(token::operator==): For TOKEN_NUMBERED_CHAR test equality of val.
	(token::get_char, token::add_to_node_list, token::process): Get
	number from val.
	(charinfo::set_number): Change argument to int.
	(charinfo::get_number):  Require that NUMBERED flag be set.
	(get_charinfo_by_number): Store numbered characters not between 0
	and 255 in a dictionary.
	* troff/charinfo.h (get_charinfo_by_number): Change argument type
	to int.
	(charinfo::number): Change type to int.
	(charinfo::set_number): Change type of set_number to int.
	* troff/node.c (troff_output_file::put_char_width,
	troff_output_file::put_char): Test whether character is numbered
	using charinfo::numbered().
	* driver/printer.c (printer::set_numbered_char): Allow arbitrary
	values of num.
	* lib/nametoindex.c: New implementation to cope with arbitrary
	number characters.

	* troff/input.c (token::operator==): Test val for
	TOKEN_CHAR_HEIGHT, TOKEN_CHAR_SLANT, TOKEN_FONT_POSITION, and
	TOKEN_SIZE.

	* man/Makefile: Add definiton of BROKEN_SPOOLER_FLAGS.
	(.man.n):  sed out @BROKEN_SPOOLER_FLAGS@.

Sun Apr 14 12:57:00 1991  James Clark  (jjc at jclark)

	* ps/devps/zapfdr.ps: Don't copy UniqueID.  Avoid use of newdict
	variable.

	* all Makefiles: rm targets of cp and >.

	* xditview/xtotroff.c (MapFont): Unlink troff_name before opening
	it.

	* eqn/lex.c (def_table): Add dollar.

Sat Apr 13 13:02:44 1991  James Clark  (jjc at jclark)

	* troff/input.c (do_width): Push back newline before closing delim
	like do_bracket.

Fri Apr 12 15:16:03 1991  James Clark  (jjc at jclark)

	* groff.c (possible_command::prepend_arg): New function.
	(main): Prepend device -m option.
	* groff.sh: Put device -m options before command-line options.

Tue Apr  9 10:24:43 1991  James Clark  (jjc at jclark)

	* macros/tmac.an (IP): Quote argument to TP.

	* ps/ps.c (main): New option -b, which sets...
	(broken_flags): New variable.
	(ps_printer::~ps_printer): Incorporate the setup section in the
	prolog if (broken_flags & NO_SETUP_SECTION).
	(ps_printer::begin_page): Generate {Begin,End}PageSetup comments.
	(ps_printer::merge_download_fonts, ps_printer::merge_import_fonts,
	ps_printer::merge_ps_fonts, ps_printer::print_font_comment,
	ps_printer::print_needed_font_comment,
	ps_printer::print_supplied_font_comment,
	ps_printer::print_include_font_comments,
	ps_printer::lookup_doc_font, ps_printer::download_fonts,
	ps_printer::read_download_file, read_document_fonts, add_font,
	skip_line, parse_fonts_arg, document_font::document_font,
	document_font::~document_font, document_font::download,
	ps_output::include_file):  Deleted.
	(ps_printer::~ps_printer): Generate %%EOF. Generate %!PS-Adobe-3.0
	rather than %!PS-Adobe-2.0.  Make calls to
	resource_manager::need_font for each font that we used. Replace
	calls to merge_ps_fonts, merge_download_fonts, print_font_comment,
	print_supplied_font_comment, print_needed_font_comment by call to
	resource_manager::print_header_comments. Output %%Orientation
	comment. Output %%Requirements: numcopies comment if ncopies > 1.
	Don't output the prolog directly.  Instead call
	resource_manager::output_prolog.  Only define #copies when ncopies
	> 1.  Delete calls to print_include_font_comments  and
	download_fonts.  Add call to resource_manager::document_setup.
	(ps_printer::do_file): Call resource_manager::import_file instead
	of including it ourselves.
	(ps_printer::do_import): Likewise.  Also don't call
	merge_import_fonts. Push userdict on the dictionary stack before
	and pop it afterwards.
	Move declaration of ps_output into ps.h.
	* ps/psrm.c: New file implementing resource_manager class.
	* ps/ps.h: New file declaring ps_output and resource_manager
	classes.
	* ps/devps/zapfdr.ps:
	* ps/devps/symbolsl.ps:
	* ps/devps/prologue:  Use 3.0 conventions.
	* ps/Makefile: Pass definition of BROKEN_SPOOLER_FLAGS in DEFINES.
	Add default definition of BROKEN_SPOOLER_FLAGS.
	* Makefile: New variable BROKEN_SPOOLER_FLAGS.  Add
	BROKEN_SPOOLER_FLAGS to SUBFLAGS.

Mon Apr  8 09:26:54 1991  James Clark  (jjc at jclark)

	* etc/grog.pl: New file.
	* Makefile (GROG): New variable.
	Add GROG to SUBFLAGS.
	* etc/Makefile (GROG): New variable.
	(install.nobin): Install $(GROG) rather than grog.sh.

Thu Apr  4 11:36:45 1991  James Clark  (jjc at jclark)

	* eqn/special.c (special_box::compute_metrics): Make the input and
	output strings the same.  Get the new height and depth from the
	predefined height and depth registers.  Also make subscript kern
	and skew available.
	(special_box::compute_subscript_kern, special_box::compute_skew):
	New functions.

	* eqn/box.c (pointer_box::compute_skew,
	simple_box::compute_metrics, box::top_level)
	* eqn/text.c (prime_box::compute_metrics,
	prime_box::comput_subscript_kern)
	* eqn/limit.c (limit_box::compute_metrics):
	* eqn/delim.c (build_extensible, delim_box::compute_metrics):
	* eqn/sqrt.c (sqrt_box::compute_metrics): Protect possibly
	negative numbers in `nr' requests with a leading 0.

Wed Apr  3 15:58:23 1991  James Clark  (jjc at jclark)

	* eqn/special.c: New file.
	* eqn/eqn.y: Declare token SPECIAL.  Make it right associative.
	Add new rule for simple.
	* eqn/lex.c (token_table): Add SPECIAL.
	* eqn/box.h: Declare make_special_box.
	* eqn/Makefile: Add special.[co].

Sat Mar 30 10:57:53 1991  James Clark  (jjc at jclark)

	* ps/devps/prologue: Possibly set packing to true while defining.
	Create grops dictionary here.  Initialize local variables before
	defining procedures.
	(PICTURE): Rename to PBEGIN. Also do save, noop showpage, count
	the dictionary stack. Set strokeadjust and overprint to false if
	the relevant operators are defined.
	(PEND): New procedure.
	* ps/ps.c (ps_printer::~ps_printer): In the prolog just include
	prologue.  Do everything else in the setup section.
	(ps_printer::do_import): Just call PBEGIN and PEND around the
	picture. Also push userdict before, and pop it afterwards.

Wed Mar 27 07:59:50 1991  James Clark  (jjc at jclark)

	* troff/node.c (bracket_node::tprint): Brackets were being printed
	1m too low.

	* macros/tmac.an (SH, SS): Set fill mode.

Tue Mar 26 07:46:31 1991  James Clark  (jjc at jclark)

	* troff/div.c (top_level_diversion::begin_page): Set
	high_water_mark to 0.

Fri Mar 22 09:19:46 1991  James Clark  (jjc at jclark)

	* man/mdate.sh: New file.
	* man/mdate.c: Deleted.
	* man/Makefile: Use mdate.sh instead of mdate.
	(mdate): Deleted.

	* eqn/lex.c (do_gsize): Supply missing argument to error message.

Tue Mar 19 11:06:50 1991  James Clark  (jjc at jclark)

	* man/mdate.c: New file.
	* man/*.man: Replace modification date by @MDATE@.
	* man/Makefile (.man.n): Replace @MDATE@ by `mdate $<`.
	(mdate): New target.

	* lib/font.c (text_file::next): Deal with arbitrarily long lines.
	Remove illegal input characters.

Mon Mar 18 08:32:25 1991  James Clark  (jjc at jclark)

	* macros/tmac.s (pg*start-col): Do .ns *after* running the hooks.

Sat Mar 16 03:52:25 1991  James Clark  (jjc at jclark)

	* troff/div.c (begin_page): Change behaviour when
	!first_page_begun and !break_flag.

	* troff/input.c (do_name_test): Return 0 if argument is empty.

	* troff/input.c (read_long_escape_name): Require closing ] to be
	at same input level as opening [.

	* troff/input.c (read_increment_and_escape_name): New function.
	(get_copy, process_input_stack): Use this for \n.

Fri Mar 15 00:31:48 1991  James Clark  (jjc at jclark)

	* troff/div.c (top_level_diversion::begin_page): Ignore the
	current value of page_number if !first_page_begun.

	* groff.c (main): Fix declaration of buf.

	* troff/input.c (do_name_test): New function.
	(token::next): Implement \A.
	(token::next): Implement \e by turning it into a TOKEN_ESCAPE.
	(token::description, token::add_to_node_list, token::process):
	Handle TOKEN_ESCAPE.
	* troff/token.h: New token TOKEN_ESCAPE.

Thu Mar 14 10:22:26 1991  James Clark  (jjc at jclark)

	* pic/main.c (do_picture): Allow space before and after filename
	following `<'.  Check that the filename is not empty.

Wed Mar 13 12:49:40 1991  James Clark  (jjc at jclark)

	* Version 1.01 released. 

	* dvi/devdvi/CompileFonts: Add cm*ss10 fonts.

	* dvi/tmac.dvi: ftr HR to H.

	* macros/tmac.e: Round up computation of $r.

	* xditview/tmac.X:  Don't give up completely in compatibility mode.
	Use \n(.s instead of \n[.s].

	* dvi/tmac.dvi: Don't give up completely in compatibility mode.
	Use \(ci instead of \[ci]. Use \n(.s instead of \n[.s].
	Add u to factors inside \s[...]. Rename frac to dvi-frac.
	Translate \(FM onto \[prime] and \(!/ onto \[slashnot]; use these
	short names in the char definitions.

	* ps/tmac.ps: Don't give up completely in compatibility mode.
	Fix the fraction definitions to use \n(.s and \(f/. Add an extra
	quote in front of \n(.s. Add u to factors inside \s[...].

Mon Mar 11 12:01:20 1991  James Clark  (jjc at jclark)

	* tty/tmac.tty: Call the nroff request.

	* macros/tmac.e ((x, )x):  Better definitions that work properly
	in a diversion.
	(@0, @1): Helper macros for (x.

	* macros/tmac.e ($s, hl): Use \l rather than \D.

	* tty/tmac.tty: Make it work better in compatibility mode.
	(pchar): Rename to tty-char.

	* macros/tmac.e (@E): New macro.
	(r, i, b, rb, bi): Use @E.

	* macros/tmac.e (@F): Don't use (;...) syntax.

	* macros/tmac.e: Remove mention of \*(||/revisions.  Mention that
	it was modified for groff.

	* macros/tmac.e: Make sure \n(ps and \n(es are >= \n(.V.

	* macros/tmac.e (<., .>): Removed.
	([., .]): If \n(.V>=1v, use [] instead of superscripting.

	* macros/tmac.e: Remove check that groff is being used.

	* macros/tmac.e (@C): Change families only if using groff; turn
	compatibility mode off while changing familes. Save compatibility
	mode before changing families and restore it afterwards.

	* macros/tmac.e (@h): Remove test for offset + line length.

	* macros/tmac.e (sorry): Rename to @S.  Use \$1 instead of \$0
	(lo, th, ac): Define to call @S instead of using als.

	* macros/tmac.e: Make $r and $R now contain \n(.v*100/\n(.sp, ie
	the ratio of the vertical spacing to the point size in units
	expressed as a percentage.  Use these instead of $10r and $10R,
	Delete $10r and $10R.

	* lib/font.c (font::load): In default computation of space_width,
	divide by sizescale.  Use scale_round.

	* macros/tmac.an (TP): Don't call `nf'.
	(an-do-tag): Don't call `fi'.

Sun Mar 10 09:52:35 1991  James Clark  (jjc at jclark)

	* troff/input.c (process_input_stack): Handle the case where
	spaces at the beginning of an input line are followed by a
	newline.

Thu Mar  7 20:18:07 1991  James Clark  (jjc at jclark)

	* groff.c (device_table): Add PIC_X_OPTION for dvi device.
	* groff.sh: Use pic -x with the dvi device.

	* dvi/devdvi/FontMakefile (H): Don't use -s.

	* dvi/devdvi/HI, dvi/devdvi/HB: New files.
	* dvi/devdvi/Makefile: Add HI and HB to FONTS.
	* dvi/devdvi/FontMakefile: Add rules for HI and HB. Include these
	in FONTS.

Mon Mar  4 13:20:14 1991  James Clark  (jjc at jclark)

	* ps/psfig.diff: New file.
	* ps/tmac.psfig: New file.

Sat Mar  2 00:15:09 1991  James Clark  (jjc at jclark)

	* macros/tmac.s (]=, ref*do-tl, ref*bib-print): Deleted.
	(]-): Don't call ref*do-tl.

	* macros/tmac.s (ref*end-print): Use XP if [F not defined.

	* macros/tmac.s (ref*normal-print): Call FS rather than fn@do-FS.
	(fn@do-FS): Rename to fn*do-FS.

	* troff/input.c (transparent_translate): New function.
	(process_input_stack): Apply transparent_translate before calling
	diversion::transparent_output(unsigned char).

Wed Feb 27 00:13:25 1991  James Clark  (jjc at jclark)

	* troff/input.c (do_define_macro): Define the macro before calling
	skip_line.

	* xditview/Makefile: Add DEVICES variable.  Change install target
	to use this.

Tue Feb 26 10:46:22 1991  James Clark  (jjc at jclark)

	* groff.c (run_commands): Handle the possibility that there are
	child processes other than those forked by us.

Sun Feb 24 21:32:30 1991  James Clark  (jjc at jclark)

	* lib/string.c (string::append): New function.
	* lib/stringclass.h: Declare it.

Thu Feb 21 11:49:26 1991  James Clark  (jjc at jclark)

	* eqn/main.c (main): New option -N which sets
	no_newline_in_delim_flag. 
	(do_file): If no_newline_in_delim_flag is set don't allow newlines
	in delimiters.
	* groff.c (main): Pass -N on to eqn.
	(help, synopsis): Mention -N.
	* groff.sh: Implement -N.

Wed Feb 20 15:16:10 1991  James Clark  (jjc at jclark)

	* macros/tmac.s (]=, ref*bib-print, ref*do-tl): New macros.
	(]-): Call ref*do-tl if ref*need-tl is non-zero.
	(XP): Allow as initializer.

Tue Feb 19 14:09:06 1991  James Clark  (jjc at jclark)

	* troff/env.c (environment::wrap_up_field): If field_spaces are
	non-zero and we have a current_tab, subtract padding from
	tab_distance.  If this makes tab_distance <= 0, use the next tab
	stop instead.  If there isn't any next tab or it's a left tab,
	wrap up the current tab.
	(environment::start_field): Initialize tab_precedes_field.
	(environment::wrap_up_tab): If there's a current field, update
	pre_field_width, field_distance and tab_precedes_field.
	* troff/env.h (environment::tab_precedes_field): New member.

Fri Feb 15 01:24:00 1991  James Clark  (jjc at jclark)

	* ps/ps.c (ps_printer::do_file): New function.
	(ps_printer::special): Bind to `file' special.
	(ps_printer::do_exec): Set ndefined_styles to 0.

Sat Feb  9 03:03:04 1991  James Clark  (jjc at jclark)

	* eqn/text.c (split_text): Grok \* and similar escapes sequences.
	Avoid stripping first character from the start of unrecognized
	escapes.  Use lex_error instead of error to report errors.
	* eqn/lex.c (get_token): Rework handling of escapes.
	(lex_error): Move declaration into...
	* eqn/eqn.h.

	* xditview/xditview.c (main): Make -page option work.

	* Makefile: Correct comment about -DBROKEN_SPOOLER and pageview.

Wed Feb  6 12:28:43 1991  James Clark  (jjc at jclark)

	* macros/tmac.s (B2): Correct size of box.

Tue Feb  5 00:37:35 1991  James Clark  (jjc at jclark)

	* macros/tmac.s (B2): Postpone drawing the box until in the
	top-level diversion.

	* tty/tmac.tty: Add font translations for C, CR, CW.

	* groff.c (synopsis, help): Document -i.
	* groff.sh: Implement -i.

	* macros/tmac.s (@NH): Put a `.' after multi-part numbers.
	Simplify the construction of SN.

	* troff/number.c (parse_term): Give `|' a higher precedence.
	* tbl/table.c (numeric_text_entry::simple_print): Parenthesise
	accordingly.

	* macros/tmac.s (B2): Use par@finish instead of par@reset.

Mon Feb  4 12:36:09 1991  James Clark  (jjc at jclark)

	* lib/string.c (string::move): New function.
	* lib/stringclass.h: Declare it.

Sat Feb  2 16:02:16 1991  James Clark  (jjc at jclark)

	* troff/env.c (distribute_space): Add optional argument
	`force_forward'.
	(environment::wrap_up_field): Call distribute_space with
	`force_forward' argument of 1.

Fri Feb  1 19:36:33 1991  James Clark  (jjc at jclark)

	* lib/string.c, lib/stringclass.h (string::operator+=(char)):
	Inline it.  Move reallocation into...
	(string::grow1): New function.
	* pic/Makefile, tbl/Makefile, eqn/Makefile, ps/Makefile: Redo
	dependencies to include library header files.
	* lib/Makefile: Make string.c and lf.c depend on stringclass.h.

Thu Jan 31 15:02:27 1991  James Clark  (jjc at jclark)

	* macros/tmac.s (@NH): Use the same number registers than -ms does
	for the heading level counters.  Use the same string that -ms does
	for the number for this heading.

Wed Jan 30 14:25:40 1991  James Clark  (jjc at jclark)

	* lib/new.c (operator new): Cast result of malloc to char *.

	* troff/input.c (spring_trap, lookup_request): Add assert that nm
	is not null.

Tue Jan 29 18:08:05 1991  James Clark  (jjc at jclark)

	* groff.c (main): Support -i.

Sun Jan 27 13:23:17 1991  James Clark  (jjc at jclark)

	* pic/pic.h: Include <osfcn.h>.

	* ps/ps.c: Add declaration of mktemp.

	* Makefile: Add -DHAVE_UNION_WAIT option for CPPDEFINES.
	* groff.c: If HAVE_UNION_WAIT is defined, declare wait()'s
	argument as union wait *.
	(run_commands): If HAVE_UNION_WAIT is defined cast wait()'s
	argument to union wait *.

Sat Jan 26 12:04:52 1991  James Clark  (jjc at jclark)

	* tty/tmac.tty: Add definition of \(co.

	* pic/object.c (make_arc): Only increase radius when radius
	strictly less than d.
	(arc_object::update_bounding_box): May need to add 4.0 to end_quad
	more than once.

	* troff/env.c (environment::environment(symbol),
	environment::environment(const environment *)):  Initialize
	input_trap_count.

Sat Jan 19 08:18:35 1991  James Clark  (jjc at jclark)

	* tbl/main.c (main): Add exit(0).

	* ps/ps.c (ps_printer::~ps_printer): Use fseek instead of rewind.

	* pic/main.c (main):
	* eqn/main.c (main):
	* tbl/main.c (main):
	* etc/soelim.c (main):
	* driver/printer.c (printer::~printer):
	* troff/node.c (real_output_file::~real_output_file,
	real_output_file::flush):  Check for errors on stdout.

	* most files: Add 1991 to copyright notice.

	* macros/tmac.s: Don't test \n(.x and \n(.y.

	* troff/input.c (token::next): Rename `escape_char' label to
	`handle_escape_char' and `normal_char' label to
	`handle_normal_char'.

Thu Jan 17 15:46:35 1991  James Clark  (jjc at jclark)

	* groff.c (main, synopsis, help): Support -a option.
	* groff.sh: Likewise.  Also eliminate Zflag variable by adding -z
	to trflags while parsing options.

Tue Jan 15 13:07:27 1991  James Clark  (jjc at jclark)

	* troff/number.c (parse_term): With `m', `M' and `n' scale
	indicators, convert scale factor to hunits before scaling.

Mon Jan 14 12:39:12 1991  James Clark  (jjc at jclark)

	* lib/font.c (scale_round): Better test for overflow when n is
	negative.

Thu Jan 10 11:10:56 1991  James Clark  (jjc at jclark)

	* tbl/main.c (process_format): Add second argument of type
	options*. Change callers.  Allow opt->tab_char as well as '\t'
	between format items.

Mon Jan  7 12:30:18 1991  James Clark  (jjc at jclark)

	* macros/tmac.an (PD): With no arguments, make sure register PD is
	at least \n[.V].
	(TH): Call PD with no argument, instead of setting register PD
	directly.

Sun Jan  6 11:18:39 1991  James Clark  (jjc at jclark)

	* Version 1.00 released.

Sat Jan  5 08:44:30 1991  James Clark  (jjc at jclark)

	* ps/tmac.ps, xditview/tmac.X: Add font translation of C to CR.

	* dvi/devdvi/DESC: Mount CW instead of CR.

	* dvi/tmac.dvi: Add definition of \(tm.

	* dvi/devdvi/texsy.map: Add lh, and rh.
	* dvi/devdvi/texex.map: Add lt, rt, lb, rb, lk, rk.
	* dvi/devdvi/texmi.map: Add *o. Regenerate fonts.

	* dvi/devdvi/FontMakefile: Generate H from cmss10.
	* dvi/devdvi/Makefile: Install H.
	* dvi/devdvi/H: New file.

Fri Jan  4 15:04:57 1991  James Clark  (jjc at jclark)

	* troff/env.c (vertical_spacing): Don't allow vertical spacing to
	be 0.

Thu Jan  3 13:41:19 1991  James Clark  (jjc at jclark)

	* macros/tmac.s (@EN): Add \n(.V to the argument to ds@need.

	* macros/tmac.pic (PS): Avoid attempting to set negative indent.

	* macros/tmac.s (@EN): Handle the case where the equation is empty
	but the label is not.

Wed Jan  2 10:31:44 1991  James Clark  (jjc at jclark)

	* troff/groff.h: New warning category WARN_SPACE.
	* troff/input.c: Add WARN_SPACE to DEFAULT_WARNING_MASK. Add
	WARN_SPACE to warning_table.
	(interpolate_macro): Give a warning of type WARN_SPACE if the name
	is longer than two characters and is not defined, but the first
	two characters do make a defined name.

	* PROBLEMS: New file.

	* CHANGES: New file.
	* README-0.6, README-1.00: Deleted.

	* groff.c, groff.sh: Add X75-12 and X100-12 devices.
	* xditview/devX75/Makefile: Make devX75-12.
	* xditview/devX100/Makefile: Make devX100-12.

	* xditview/devX100/eqnchar, xditview/devX75/eqnchar,
	dvi/devdvi/eqnchar, ps/devps/eqnchar: Remove use of \R.

Tue Jan  1 19:24:01 1991  James Clark  (jjc at jclark)

	* README-0.7: Rename to README-1.00.

	* macros/tmac.pic: New file.
	* macros/Makefile (install.nobin): Install tmac.pic.

Mon Dec 31 10:40:53 1990  James Clark  (jjc at jclark)

	* troff/env.c (hyphen_word): Correct the test for whether the
	token is a hyphen.  Reset npos to 0.

	* macros/tmac.s (par@sup-start, par@sup-end): New implementations.

Sun Dec 30 15:53:13 1990  James Clark  (jjc at jclark)

	* macros/tmac.s (ds*common-end): Call par*reset.
	(PE): Likewise.
	(par@reset-indent): Deleted.

	* macros/tmac.s (@IP): Divert the label.

Sat Dec 29 14:33:32 1990  James Clark  (jjc at jclark)

	* xditview/draw.c (setGC): Use a line width of .1m rather than
	.04m by default; round rather than truncate value.

	* tbl/table.c (class empty_entry): New class.
	(empty_entry::empty_entry, empty_entry::line_type): New functions.
	(table::add_entry): Represent empty entries by objects of type
	empty_entry.
	(table_entry::line_type): Return -1.
	(table::determine_row_type): Ignore entries with line_type 0.
	Treat type -1 as non-lines.

Fri Dec 28 15:04:41 1990  James Clark  (jjc at jclark)

	* ps/devps/textmap, xditview/libXdvi/DviChar.c, tty/devlatin1/R.proto,
	macros/tmac.s: Rename \(-d to \(Sd.

Thu Dec 27 12:35:47 1990  James Clark  (jjc at jclark)

	* ps/devps/textmap: Add `sd', `/_' and `3d' characters.
	* xditview/libXdvi/DviChar.c: Likewise.
	* dvi/devdvi/texsy.map: Add `<<', `>>'.

Wed Dec 26 13:33:23 1990  James Clark  (jjc at jclark)

	* troff/div.c (top_level_diversion::begin_page): Call
	init_output() if the_output is 0.

Sat Dec 22 12:35:29 1990  James Clark  (jjc at jclark)

	* troff/input.c: Replace ESCAPE_E by ESCAPE_e and ESCAPE_C by
	ESCAPE_c.
	(get_copy): Turn \E into ESCAPE_E.
	(token::process, asciify): Handle ESCAPE_E.

	* macros/tmac.s (ds*common-end, par@reset): Add `.rj 0'.
	(RD): New macro.
	(DS): Implement `.DS R'.

Fri Dec 21 11:41:53 1990  James Clark  (jjc at jclark)

	* macros/tmac.s (FS): New macro.

	* macros/tmac.s (fn@do-FS): Use @LP instead of LP.

	* macros/tmac.s (cov*tl-init): Remove after first execution
	instead of aliasing to @nop.  Call top of page macro explicitly
	instead of setting trap; call @init first.  Set pg@top as top of
	page macro.
	(cov*auto-init): Deleted.  Set cov*tl-init instead of
	cov*auto-init as top of page trap. 
	(TL, LP): Do a break instead of calling cov*tl-init.
	(cov*print): With RP format but no TL, alias FS and FE to @FS and
	@FE; in this case also give a warning and always start another
	page. No need to set pg@top here.
	(cov*tl-init): Rename to cov*first-page-init.

	* macros/tmac.s (RP): Do `.pn 0'.
	(cov*tl-init): With RP format don't do `.pn 0'.

	* macros/tmac.s (pg@cs-top): Set no space mode.

	* macros/tmac.s (par@TL, par@AU, par@AI): New macros.
	(cov*ab-init): Alias TL, AU and AI to these.

Thu Dec 20 10:10:50 1990  James Clark  (jjc at jclark)

	* macros/tmac.s (@EQ): Move the space before the equation into @EN
	(@EN): Do nothing unless \n[dl] is > 0.

Tue Dec 18 12:20:47 1990  James Clark  (jjc at jclark)

	* pic/object.c (ellipse_object::radius): New function.

	* VERSION: Change version to 0.7.

	* tbl/table.c (block_entry::do_divert): Declare return type as
	void.
	(block_entry::divert, alphabetic_block_entry::divert): Return 1.

Mon Dec 17 12:30:34 1990  James Clark  (jjc at jclark)

	* troff/column.c: New file.
	* troff/Makefile: Corresponding changes.

	* troff/hvunits.c (scale(vunits, vunits, vunits)):  New function.
	Friend of vunits.

	* troff/div.c (top_level_diversion::space): If the space causes
	the first-page transition and springs a trap, truncate the space
	to 0.

Fri Dec 14 12:30:02 1990  James Clark  (jjc at jclark)

	* ps/ps.c (ps_printer::do_import): Add a `clear' after including
	the document.

	* pic/troff.c (troff_output::line_thickness,
	troff_output::set_fill): Do a horizontal motion to compensate for
	the width of the \D escape sequence.

Thu Dec 13 10:17:14 1990  James Clark  (jjc at jclark)

	* xditview/tmac.X: Reinstate definition of \(rn, but only for X100
	(not X75).

	* eqn/sqrt.c (sqrt_box::compute_metrics):  Supply missing argument
	to printf.

	* tbl/table.c (simple_entry::simply_print): Don't declare as pure.
	Supply empty definition.
	(text_entry::simple_print, simple_text_entry::simple_print):
	Delete declarations.
	(table::add_entry): Represent empty entries by objects of type
	`simple_entry'.

Wed Dec 12 08:50:48 1990  James Clark  (jjc at jclark)

	* troff/Makefile: Remove -DHYPHEN_CONTROL from DEFINES.

	* tbl/table.c (left_text_entry::add_tab): New function.

	* macros/tmac.s: Make @RT an alias for par@reset.  Make RT
	initialize like LP.

Mon Dec 10 11:19:55 1990  James Clark  (jjc at jclark)

	* troff/env.c (environment::start_field): Give an error message if
	there is no next tab.

Sun Dec  9 11:46:40 1990  James Clark  (jjc at jclark)

	* troff/env.c (hyphenate): Skip initial elements with zero
	hyphenation code.

	* macros/tmac.s (par@init): Keep VS in points rather than units.

Sat Dec  8 23:00:27 1990  James Clark  (jjc at jclark)

	* pic/main.c (main): Implement `-c' option.
	* pic/output.h: Declare make_tpic_output().
	* pic/tex.c (tex_output::set_pen_size): Make it virtual and
	protected.
	(tpic_output): New class.
	(tpic_output::tpic_output, tpic_output::set_pen_size,
	tpic_output::command, make_tpic_output): New functions.

Fri Dec  7 11:57:41 1990  James Clark  (jjc at jclark)

	* tbl/main.c (main): Call `.ab' if \n(.g is false.  Define TS/TE
	if they're not already defined.
	* tbl/table.c (init_output): Don't test \n(.g.

	* troff/input.c (do_if_request): Delete `g' condition. Recognize
	`d', `r' and `c' conditions even in compatibility mode.

Tue Dec  4 09:13:47 1990  James Clark  (jjc at jclark)

	* ps/tmac.ps (ps-bb): Protect against negative numbers in bounding
	box.

Mon Dec  3 07:18:26 1990  James Clark  (jjc at jclark)

	* troff/env.h (environment::prev_line_interrupted): New member.
	(environment::get_prev_line_interrupted): New function.
	* troff/env.c (environment::newline): Set prev_line_interrupted.
	(environment::environment(const environment *),
	environment::environment(symbol)): Initialize
	prev_line_interrupted.
	* troff/input.c (process_input_stack): Don't give special
	treatment to space and newline at the beginning of the line if the
	previous line was interrupted.

Sat Dec  1 15:48:37 1990  James Clark  (jjc at jclark)

	* eqn/eqn.y: Disallow PRIME by itself.
	* eqn/lex.c (token_table): Bind `opprime' instead of `prime' to
	PRIME.
	(def_table): Remove definition of '.  Define prime to be `.

	* eqn/eqn.y: Split off part of rule `script' into a new rule
	`nonsup'.

Fri Nov 30 10:23:44 1990  James Clark  (jjc at jclark)

	* macros/tmac.s ({, }): New string aliases.

Thu Nov 29 11:34:40 1990  James Clark  (jjc at jclark)

	* README-0.7: New file.

Wed Nov 28 10:09:57 1990  James Clark  (jjc at jclark)

	* macros/tmac.s: New file.
	* man/groff_ms.man: New file.
	* Makefile: Add definition of TMAC_S. Pass TMAC_S in SUBFLAGS.
	* Makefile.bd: Similarily.
	* man/Makefile: Add groff_ms.n to MAN7PAGES. Replace @TMAC_S@. Add
	definition of TMAC_S.
	* macros/Makefile: Add definition of TMAC_S. Install tmac.s.
	* macros/TODO: New file.

Sat Nov 24 20:04:54 1990  James Clark  (jjc at jclark)

	* troff/env.c (right_justify): New function.
	(init_env_requests): Bind this to request "rj".
	(center_lines): Set right_justify_lines to 0. If we get a bad
	integer, center 1 line.
	(environment::environment(symbol), environment::environment(const
	environment *)): Initialize right_justify_lines.
	(environment::get_right_justify_lines): New function.
	(init_env_requests): Bind this to number_register ".rj".

	* troff/env.c (environment::choose_breakpoint): Implement
	hyphenation_margin and hyphenation_space.
	(environment::get_hyphenation_space,
	environment::get_hyphenation_margin): New functions.
	(init_env_requests): Bind these to .hys and .hym.
	(hyphenation_space_request, hyphenation_margin_request): New
	functions
	(init_env_requests): Bind these to hys and hym.
	(environment::environment(symbol), environment::environment(const
	environment *)): Initialize hyphenation_margin and
	hyphenation_space.
	* troff/env.h: Corresponding changes to class environment.

Fri Nov 23 09:08:16 1990  James Clark  (jjc at jclark)

	* troff/div.c (blank_line): Always do a break.

	* eqn/box.c (do_text): Turn off escapes while appending text to
	string.

Thu Nov 22 10:58:59 1990  James Clark  (jjc at jclark)

	* troff/input.c (while_break_request, while_continue_request): New
	functions.
	(init_input_requests): Bind these to "break" and "continue".
	(while_depth, while_break_flag): New variables.
	(while_request): Update while_depth.  Break out of loop if
	while_break_flag is set.

Wed Nov 21 10:54:40 1990  James Clark  (jjc at jclark)

	* tbl/table.c (init_span_reg): Initialize span_width_reg to \n(.H
	rather than 0.

Mon Nov 19 00:45:03 1990  James Clark  (jjc at jclark)

	* Makefile: Include -DBROKEN_SPOOLER by default.  Expand comment.

	* stringify: New file.
	* Makefile (groff.o): Use stringify.

	* xditview/tmac.X: Remove definition of \(rn.
	* xditview/libXdvi/DviChar.c: Remove radicalex from
	Adobe_symbol_map.

Sat Nov 17 10:44:58 1990  James Clark  (jjc at jclark)

	* tbl/table.c (table::add_entry): Allow alphabetic text blocks.
	(alphabetic_block_entry::alphabetic_block_entry,
	alphabetic_block_entry::divert, alphabetic_block_entry::print):
	New functions.
	(block_entry::divert): Split off body into ...
	(block_entry::do_divert): If the block is alphabetic, subtract 2n
	from the line length; also update the span width to dl+2n, and the
	alphabetic span width to dl.

	* driver/input.c (do_file):  While reading argument to D command,
	when expanding buffer, multiply szp by sizeof(int) rather than 2
	in the argument to memcpy.

	* tbl/table.c (compute_span_width): Add 2n rather than 1n to the
	width of alphabetic columns.

Fri Nov 16 06:34:27 1990  James Clark  (jjc at jclark)

	* troff/node.c (lookup_family): Supply second argument to lookup.

	* troff/dictionary.c (dictionary::lookup): After an unsuccesful
	search, return immediately if v is 0.

	* pic/troff.c: Define EQN_NO_EXTRA_SPACE_REG.
	(troff_output::start_picture): Set this reg.
	(troff_output::end_picture): Remove this reg
	* eqn/box.c (box::extra_space): Don't produce `\x's if
	EQN_NO_EXTRA_SPACE_REG is defined.

	* eqn/eqn.y: Allow just a PRIME to be a `simple'.
	* eqn/text.c (split_text): Map ' to \(fm when it's the first
	character.

Thu Nov 15 10:35:06 1990  James Clark  (jjc at jclark)

	* macros/tmac.e: Use font 3 instead of B in $c. Remove `bd'
	requests.

	* troff/div.c (top_level_diversion::top_level_diversion):
	Initialize page_number to 0.

Wed Nov 14 21:41:58 1990  James Clark  (jjc at jclark)

	* groff/troff (environment::environment(const environment *)):
	Initialize name to e->name, rather than "anonymous".

Sat Nov 10 01:59:37 1990  James Clark  (jjc at jclark)

	* xditview/libXdvi/Dvi.c (ShowDvi): If eof is encountered, reset
	requested_page.  Split middle part into ...
	(FindPage): New function.
	(SetValues): If we don't yet know the last page, and the requested
	page is greater than the current page, call FindPage.
	Update the font_map_string before doing this.

	* xditview/tmac.X: Add definitions of \(sq, \(ga, \(dg and \(dd.
	Translate \(lh and \(rh into left and right double arrows.

	* troff/node.c (class hyphen_inhibitor_node): New class.
	(hyphen_inhibitor_node::hyphen_inhibitor_node,
	hyphen_inhibitor_node::copy, hyphen_inhibitor_node::same,
	hyphen_inhibitor_node::type,
	hyphen_inhibitor_node::get_hyphenation_type): New functions.
	(node::add_discretionary_hyphen): Use hyphen_inhibitor_node rather
	than dbreak_node(0, 0) to represent a `\%' at the beginning of a
	word.

Fri Nov  9 16:05:38 1990  James Clark  (jjc at jclark)

	* troff/node.h (dummy_node::get_hyphenation_type,
	transparent_dummy_node::get_hyphenation_type):  Declare them.
	* troff/node.c: (dummy_node::get_hyphenation_type,
	transparent_dummy_node::get_hyphenation_type): New functions.

Wed Nov  7 10:09:06 1990  James Clark  (jjc at jclark)

	* xditview/libXdvi/draw.c: If M_PI not defined after including
	math.h, then define it.

	* xditview/Makefile: Add definition of AR. Pass it to the submake
	in libXdvi.
	* xditview/libXdvi/Makefile: Add definitions of AR and RANLIB.

Tue Nov  6 10:14:27 1990  James Clark  (jjc at jclark)

	* troff/dictionary.h (object_dictionary::alias): Declare return
	value as int.
	* troff/dictionary.c (object_dictionary::alias): Return non-zero
	if the old name was defined.
	* troff/input.c (alias_macro): Give a warning if the old name was
	not defined.
	* troff/reg.c (alias_reg): Likewise.

Mon Nov  5 00:31:39 1990  James Clark  (jjc at jclark)

	* troff/input.c (token::next): Delete implementation of \R.

	* macros/Makefile: Strip comments from tmac.e while installing it.

	* troff/input.c: New variable `nroff_mode'.
	(troff_request, nroff_request): New functions.
	(init_input_requests): Bind `troff' and `nroff' to troff_request
	and nroff_request.
	(do_if_request): Compute results of t and n conditions from
	nroff_mode.

	* text/text.c (split_text): Fix typo in >=.

	* eqn/lex.c: Add definition of `==' to def_table.

Fri Nov  2 02:49:09 1990  James Clark  (jjc at jclark)

	* pic/tex.c (tex_output::start_picture): Change the definitions of
	\graph and \graphtemp so that they work properly with Plain TeX.

	* pic/tex.c (tex_output::solid_arc): Ensure that the second angle
	argument to `ar' is not less than the first.

	* pic/pic.y: Allow a comma between elements of the variable list
	in the argument to `reset'.

	* pic/object.c (arc_object::arc_object): Fix computation of
	radius.

	* eqn/main.c (main): Add exit(0).

Thu Nov  1 02:03:50 1990  James Clark  (jjc at jclark)

	* troff/div.c (begin_page): Test no_space_mode after doing the
	break, but still push the page ejector cookie before doing the
	break.  Also set the next page number after doing the break.
	
	* xditview/xditview.c (NewFile): Don't set the title and icon name
	if this is the first file and its name is `-'.
	* groff/groff.c: Define a new device flag XT_OPTION.  Set it for
	the X75 and X100 devices.
	(main): If a device has the XT_OPTION flag set and there's exactly
	one file argument, pass the driver -xrm and -title options to set
	the icon name and window title to the name of the file.

	* troff/env.c (environment_switch): If there was an argument but
	it wasn't a valid number or name, then pop an environment but
	don't give an error message on underflow.

	* troff/number.c (start_number): Correct spelling in error message.

	* troff/input.c (token::delimiter): Don't print an error message
	if err is false.

	* xditview/libXdvi/parse.c (ParseInput): In case 'D', only call
	ParseDrawFunction if dw->display_enable is true.

Wed Oct 31 05:49:50 1990  James Clark  (jjc at jclark)

	* pic/pic.y: Parse text positioning like normal attributes, so as
	to allow `"text" at 0,0 ljust'.  Don't allow `center' as a
	positioning attribute.

Mon Oct 29 22:50:38 1990  James Clark  (jjc at jclark)

	* tbl/main.c (process_data): When in state START while reading a
	text block, don't change to state MIDDLE if c is a newline.

Sun Oct 28 21:59:56 1990  James Clark  (jjc at jclark)

	* dvi/dvi.c (dvi_printer::begin_page): Rename `i' variable to `j'
	so as to avoid shadowing parameter.

Wed Oct 24 18:35:39 1990  James Clark  (jjc at jclark)

	* tbl/table.c (trim_space): Deleted.
	(table::add_entry): Don't call trim_space.

Mon Oct 22 03:48:39 1990  James Clark  (jjc at jclark)

	* VERSION: Change version to 0.6.

	* troff/number.c (parse_expr): Make == work.

Sat Oct 20 11:28:17 1990  James Clark  (jjc at jclark)

	* man/grog.man: New file.
	* man/Makefile: Add grog.n to MAN1PAGES.
	* etc/grog.sh: New file.
	* etc/Makefile: Install grog.sh as grog.

Fri Oct 19 11:17:15 1990  James Clark  (jjc at jclark)

	* troff/input.c (token::next): Implement \E.

Thu Oct 18 11:56:24 1990  James Clark  (jjc at jclark)

	* xditview/tmac.X: Change font translations to match tmac.ps.

	* troff/input.c (non_empty_name_warning): Don't give a warning if
	`\{' terminates the name.

Tue Oct 16 10:04:23 1990  James Clark  (jjc at jclark)

	* ps/devps/symbol.diff: New file.
	* ps/devps/FontMakefile: Mention symbol.diff.

Sun Oct 14 11:46:46 1990  James Clark  (jjc at jclark)

	* troff/node.c (font_position): Use get_long_name to read the
	external_name.

	* troff/env.c (environment_switch): If we get a number that's < 0
	or >= NENVIRONMENTS, treat it like a name.
	Change NENVIRONMENTS to 10.

	* troff/groff.h: Remove definition of FONTS_MAX.
	* troff/node.h (class font_family): Make map a pointer instead of
	an array. Add a map_size member. Make it a class. Make nm const
	and public. Make invalidate_fontno a friend.
	* troff/node.c: Define font_table_size. Make font_info a pointer
	rather than an array.
	(class troff_output_file): Allocate font_position dynamically. Add
	nfont_positions member.
	(troff_output_file::set_font): Grow font_position if necessary.
	(troff_output_file::~troff_output_file): Delete font_position.
	(troff_output_file::troff_output_file): Allocate font_position.
	(grow_font_table): New function.
	(troff_output_file::really_begin_page,
	troff_output_file:really_copy_page): Use nfont_positions rather
	than FONTS_MAX.
	(mount_font_no_translate, mount_style): Call grow_font_table if
	necessary.
	(font_family::font_family): Allocate map.
	(font_family::make_definite): Grow map if necessary. Use
	font_table_size instead of FONTS_MAX.
	(font_family::~font_family): New function.
	(invalidate_fontno): Use font_family::map_size.
	(get_fontno, env_space_width, env_half_narrow_space_width,
	env_narrow_space_width, symbol_fotno, is_good_fontno,
	get_bold_fontno, make_glyph_node): Use font_table_size rather than
	FONTS_MAX.
	(next_available_font_position): Never return 0.

Fri Oct 12 10:17:52 1990  James Clark  (jjc at jclark)

	* ps/tmac.ps: Add font translations for compatibility with dpost.

Thu Oct 11 12:09:03 1990  James Clark  (jjc at jclark)

	* eqn/pile.c: Rename default_baseline_sep to baseline_sep.
	Move BASELINE_SEP_FORMAT and COLUMN_WIDTH_FORMAT into pbox.h.
	Move definitions baseline_sep, shift_down, column_sep,
	matrix_side_sep into...
	* eqn/box.c: Add them to param_table.
	* eqn/pbox.h: Add declarations to pbox.h.

	* troff/input.c (set_string): Cast value to unsigned char *.

	* troff/token.h (process_input_stack): Declare it static before
	declaring it a friend.

Wed Oct 10 09:59:13 1990  James Clark  (jjc at jclark)

	* dvi/devdvi/texex.map: Fix positions of extensible brace middle
	and bottom.
	* dvi/devdvi/EX: Regenerate.

	* troff/input.c (init_charset_table): Make ", ', ), ], *, \(dg
	transparent.

Tue Oct  9 08:34:02 1990  James Clark  (jjc at jclark)

	* eqn/lex.c: In defaults_table, make definition of `dot' call
	`dot_def'.  Don't explicitly make it roman.  Similarily for other
	accents.

	* pic/lex.c (for_input::for_input): Add by_is_multiplicative
	argument.
	(for_input::get, for_input::peek): Use this.
	(do_for): Add by_is_multiplicative argument.
	* pic/pic.y: Change optional_by clause to allow '*' after `by'.
	Change semantic value of optional_by to be a double plus a flag
	saying whethet the by clause is multiplicative.

	* eqn/lex.c (get_delimited_text): Remember location of start of
	definition.  Improve error handling when EOF is encountered.

	* lib/font.h: Rename handle_x_command to
	handle_unknown_font_command.
	* lib/font.c (font::load): Call handle_unknown_font_command for
	any unknown command in the font description file.  Don't call
	handle_x_command. Include the name of the command in the argv.
	Improve message for unknown command after kernpairs or charset
	command.
	* ps/ps.c (ps_font::handle_x_command): Rename to
	handle_unknown_font_command.  Remove message about `x download'
	command.  Give error message for wrong number of arguments.
	* ps/devps/afmtodit: Generate `encoding' instead of `x encoding'.
	* dvi/dvi.c (dvi_font::handle_x_command): Rename to
	handle_unknown_font_command. Give an error message for wrong
	number of arguments.  Rename design_size to designsize.
	* dvi/tfmtodit.c (main): Generate `checksum' instead of `x
	checksum', `designsize' instead of `design_size'.

Mon Oct  8 00:38:55 1990  James Clark  (jjc at jclark)

	* eqn/*.[chy]: Change underaccent to uaccent.

	* eqn/eqn.y: Add rule for underaccent.  Declare UNDERACCENT token;
	give it the same precedence as ACCENT.
	* eqn/other.c (make_underaccent_box): New function.
	* eqn/box.h: Declare it.
	* eqn/lex.c: Add UNDERACCENT to token_table. Add utilde to
	def_table.

Sun Oct  7 11:25:16 1990  James Clark  (jjc at jclark)

	* pic/pic.y (reset_all): New function. Called in rule for RESET.
	(parse_init): Call reset_all.
	(define_variable): When defining scale reset only those
	pre-defined variables that are scaled.
	(defaults_table): Add `scale' as non-scaled value.

	* pic/pic.y: Redo parsing of text adjustments: parse adjustments
	together with the text; allow any number of positioning words;
	allow center as a positioning word.

	* pic/object.c (output::compute_scale): Get picture maximum height
	and width from variables called maxpswid and maxpsht.
	* pic/pic.y: Add maxpswid and maxpsht to defaults_table.

Sat Oct  6 10:16:56 1990  James Clark  (jjc at jclark)

	* pic/object.c (object_spec::make_text): Multiply textht by number
	of text items.

	* pic/pic.y: Allow `sprintf("string", expr,...)' wherever text can
	occur.
	(do_sprintf): New function.
	(pic.gperf): Add sprintf token.
	(text, sprintf): New rules.

	* pic/pic.y: `rand()' with no arguments returns a random number
	in the range [0,1).

	* pic/pic.y: Allow a bare expression to be an attribute: change
	precedences to support this.  Change optional_ordinal rule to
	optional_ordinal_last to avoid reduce/reduce conflict.
	* pic/object.c (object_spec::object_spec): Initialize direction.

	* pic/pic.y: Implement ^ operator meaning exponentiation.

	* troff/node.h: Add default argument to mount_font.
	* troff/node.c (font_position): Read an optional third argument
	giving the external_name.
	(mount_font): Add optional argument giving the external_name.
	(mount_font_not_translate): Have additional argument giving
	external name.  Use this name to load the font.  Pass both names
	to font_info::font_info.
	(font_info::font_info): Have additional argument giving
	external_name.
	(class tfont): New member external_name.
	(font_info::get_tfont): Use external name to construct tfont_spec.

Fri Oct  5 04:03:13 1990  James Clark  (jjc at jclark)

	* eqn/lex.c (init_table): Add argument giving device.  Define
	name of device to be "1".
	(do_ifdef): Counts as true if the argument has been defined with
	`define'.
	* eqn/main.c (main): Call init_table with device argument. Make
	device local to main.
	* eqn/eqn.h: Change declaration of init_table. Remove declaration
	of device.

	* pic/lex.c (get_delimited): Allow text to be delimited by
	matching {}s.  Don't recognize ending delimiter within a string.

	* troff/input.c (get_delim_name): New function.
	(token::next): Implement \C.

	* lib/font.c (font::load): Grok ---.  Add an alias for each
	character based on its code.
	(font::get_code_width): Deleted.
	* lib/font.h (class font): Declare font::number_to_index().
	Remove declaration of font::get_code_width.
	* lib/nametoindex.c (font::name_to_index): Add 512 rather than 256
	to indices of named characters.
	(font::number_to_index): New function.
	* troff/input.c (font::number_to_index): New function.
	(get_charinfo_by_number, charinfo::get_number,
	charinfo::set_number): New functions.
	(token::next): Turn \N into a TOKEN_NUMBERED_CHAR.
	(token::process, token::description, token::get_char,
	token::add_to_node_list, token::operator==): Handle
	TOKEN_NUMBERED_CHAR.
	* troff/charinfo.h: Declare get_charinfo_by_number,
	charinfo::get_number, charinfo::set_number.  Add NUMBERED flag to
	charinfo class.
	(charinfo::numbered): New function.
	* troff/token.h: Add TOKEN_NUMBERED_CHAR.
	* troff/env.h (class environment): Remove declaration of ...
	* troff/env.c (environment::make_numbered_char_node): Deleted.
	* troff/node.c (make_numbered_node): Deleted.
	(class numbered_glyph_node): Remove.
	(troff_output_file::put_char_width, troff_output_file::put_char):
	Handle numbered chars.
	(troff_output_file::numbered_char): Removed.
	(tfont::get_code_width): Removed.
	(make_glyph_node): Don't search special fonts for numbered
	characters.
	* troff/node.h: Remove declaration of make_numbered_node.
	* driver/input.c (do_file): Handle N command.
	* driver/printer.h: Add declaration of ...
	* driver/printer.c (printer::set_numbered_char): New function.
	* dvi/tfmtodit.c (main): Generate unnamed entries.
	* ps/devps/afmtodit: Likewise.
	* xditview/xtotroff.c (MapFont): Likewise.
	* xditview/libXdvi/parse.c (ParseInput): Grok N command.

	* tbl/main.c (process_format): If multiple widths are specified
	for a column but all the widths are the same, don't give an error
	message.

	* tbl/table.c (table::do_row): If the current row is all lines and
	the stuff doesn't contains a line, mark the top of the row after
	printing stuff before the row.  If the current row is not all
	lines and the stuff doesn't contain a line, don't unnecessarily
	mark the top of the row before printing the stuff.
	
Mon Oct  1 11:42:00 1990  James Clark  (jjc at jclark)

	* troff/groff.h: Remove MAX_PATH.
	* troff/input.c (open_file): Dynamically allocate space for the
	path.
	(open_mac_file, process_macro_file): Corresponding changes.

Sun Sep 23 18:56:26 1990  James Clark  (jjc at jclark)

	* troff/node.h (class output_file): Make copy_file pure.  Add
	vspace method ifdef COLUMN. Add is_printing method.
	* troff/node.c: Add class printing_reg. Add class
	real_output_file. Derive other output_file classes from
	real_output_file; in these classes rename begin_page to
	really_begin_page, print_line to really_print_line, copy_file to
	really_copy_file, transparent_char to really_transparent_char.
	Move output_file::flush to real_output_file. Add printing member
	to class output_file.
	* troff/div.h: Remove printing member from top_level_diversion.
	Add vspace member function to class diversion ifdef COLUMN. Add
	some declarations ifdef COLUMN.
	* troff/div.c (top_level_diversion::copy_file,
	top_level_diversion::transparent_output,
	top_level_diversion::output): Don't test printing member before
	output.
	* troff/input.c: Handle initial variable_space_request ifdef
	COLUMN.
	* troff/Makefile: Add column.c but comment it out. Add -DCOLUMN
	but comment it out.

Sat Sep 22 11:32:22 1990  James Clark  (jjc at jclark)

	* troff/div.c (diversion::need): Make any space forced.  If we
	sprung a trap, set truncated_space to minus the distance to the
	trap and set needed_space to the amount that was needed.
	(top_level_diversion::space): A forced space turns no_space_mode
	off.
	(class constant_vunits_reg): New class.
	(init_div_requests): Implement number registers .trunc and .ne
	using constant_vunits_reg.
	(class truncated_space_reg): Deleted.	

	* troff/div.h: Don't have a no_space_mode member in diversion.
	Instead have it in top_level_diversion.
	* troff/div.c (diversion::diversion): Don't initialize
	no_space_mode.
	(top_level_diversion::top_level_diversion): Initialize
	no_space_mode.
	(no_space, restore_spacing): Do nothing if curdiv != topdiv.
	(macro_diversion::output): Don't clear no_space_mode.

	* troff/input.c (diverted_space_node::reread): Don't call
	environment::do_break.  In fill mode, act like a blank line.
	(diverted_copy_file_node::reread): Don't call
	environment::do_break.

	* troff/div.c (blank_line): New function.
	* troff/div.h: Declare it.
	* troff/input.c (process_input_stack): Call it.

	* troff/div.c (truncated_space_reg::get_string): New function.
	(init_div_requests): Bind to .trunc.
	(space_request, top_level_diversion::space,
	top_level_diversion::output, macro_diversion::space,
	macro_diversion::output): Update truncated_space.
	(macro_diversion::output): Redo calculations when trap sprung.
	(macro_diversion::output, macro_diversion::space): No need for
	trap_flag.

	* troff/div.c (top_level_diversion::output): Set nl_reg_contents
	after truncating post line spacing.

Fri Sep 21 11:27:25 1990  James Clark  (jjc at jclark)

	* ps/devps/prologue (MF, SF): Make them work even if setfont is
	defined as a procedure rather than as an operator.

Thu Sep 20 12:55:05 1990  James Clark  (jjc at jclark)

	* troff/div.c (macro_diversion::space): Ignore no_space_mode.

Wed Sep 19 10:54:37 1990  James Clark  (jjc at jclark)

	* troff/div.c (top_level_diversion::output): Merge
	output_file::print_line and output_file::end_of_line member
	functions.
	* troff/div.h (class output_file):
	* troff/node.c (troff_output_file::print_line,
	troff_output_file::end_of_line, output_file::end_of_line,
	ascii_output_file::print_line, suppress_output_file::print_line):
	Corresponding changes.	

Tue Sep 18 11:31:47 1990  James Clark  (jjc at jclark)

	* troff/input.c (token::next): Don't give a warning for `\.'.

	* troff/env.c (environment::get_center_lines): New function.
	(init_env_requests): Bind number register .ce to it.
	* troff/env.h: Declare it.
	* tbl/table.c (table::init_output): Define reset macro to restore
	.ce.  If center option not given, store .ce in SAVED_CENTER_REG.
	Then do .ce 0.
	(table::print): If center option not given, then imply center
	option if SAVED_CENTER_REG > 0.

Mon Sep 17 09:19:19 1990  James Clark  (jjc at jclark)

	* ps/devps/Makefile: Remove T from FONTS. Remove TSymbol.ps and
	Troff.ps from DOWNLOAD.
	
	* troff/Makefile: Change comment in DEFINES to avoid confusing
	System V make.

	* ps/ps.c (ps_printer::do_exec): Allow newlines within PostScript
	code.  Don't try to catch errors with stopped.
	(check_line_lengths): New function.
	* ps/devps/prologue (EXEC): Deleted.
	(EBEGIN, EEND): New procedures.

Sun Sep 16 14:51:15 1990  James Clark  (jjc at jclark)

	* troff/input.c: Include request.h before node.h.
	* troff/node.c: Likewise.
	* troff/env.c: Likewise.
	* troff/div.c: Likewise.
	* troff/node.h (class special_node): Store argument as a macro
	rather than a char *.
	* troff/node.c (special_node::special_node, special_node::copy):
	Grok this.
	(special_node::~special_node): Deleted.
	(special_node::tprint): Deleted.
	(special_node::tprint_start, special_node::tprint_end,
	special_node::tprint_char): New functions.
	(troff_output_file::special): Deleted.
	(troff_output_file::start_special, troff_output_file::end_special,
	troff_output_file::special_char): New functions.
	* troff/input.c (special_node::tprint): New function.
	(do_special): Use macro not char *.
	(do_transparent_macro): Deleted.
	(token::next): Don't call do_transparent_macro.

	* troff/input.c (token::next): Add 'Y' case.
	(do_transparent_macro): New function.
	* troff/node.c (troff_output_file::special): Handle newlines with
	argument using new continuation convention.
	* driver/input.c (get_string): Cope with continuation convention.
	(do_file): Don't call skip_line after calling get_string(1).
	* ps/ps.c (ps_printer::special, ps_printer::do_import,
	ps_printer::do_def, ps_printer::do_exec): Cope with newlines in
	arg.
	* xditview/libXdvi/parse.c (ParseInput): Ignore lines starting
	with +.

Sat Sep 15 19:00:10 1990  James Clark  (jjc at jclark)

	* troff/input.c (asciify): By default, illegal input characters
	should return empty string.

	* troff/input.c (copy_file): Handle first page transition like title.
	(token::next, process_input_stack): Grok COPY_FILE_REQUEST.

	* troff/input.c (token::next): Improve error message for EOF after
	escape character.
	(input_char_description): New function.
	(get_char_for_escape_name): Use input_char_description.
	(token::next): Warn about unrecognized escape sequences.
	(warning_table): Add WARN_ESCAPE.
	* troff/groff.h: Declare WARN_ESCAPE. Change WARN_TOTAL
	accordingly.

	* troff/token.h: Remove declaration of process_input_stack.

	* troff/input.c: Remove declaration of init_hyphen_requests.
	* troff/request.h: Correct spelling in declaration of same.

	* troff/input.c (token::next): Check whether escape_char is 0.

Fri Sep 14 12:09:25 1990  James Clark  (jjc at jclark)

	* groff.c (main, usage, help): Implement -P and -L options.
	* groff.sh: Likewise.

	* troff/input.c (token::next): Use some gotos to avoid code
	duplication.

	* troff/input.c (get_long_name, get_name, read_long_ecsape_name):
	Avoid calling symbol::symbol if name empty.

Thu Sep 13 06:21:45 1990  James Clark  (jjc at jclark)

	* troff/input.c (init_input_requests): Make \n(.x return the major
	version number and \n(.y return the minor version number.
	* troff/Makefile: Construct file majorminor.c defining
	major_version and minor_version automatically from ../VERSION.

	* troff/node.c (class glyph_node): Make operator new and operator
	delete public.
	(class ligature_node): Similarily.

	* troff/input.c (operator==(const macro &, const macro &)): New
	function.
	(non_interpreted_node::same): Use this.
	(string_iterator::string_iterator): Make macro& argument const.

	* troff/input.c (input_iterator::get): New function. Don't make
	asciify_macro or class non_interpreted_node friends of class
	input_iterator.
	(non_interpreted_node::interpret): Use input_iterator::get.
	(asciify_macro): Likewise.

	* troff/input.c (~token_node, ~string_iterator, ~arg_list,
	~non_interpreted_node): Deleted.
	* troff/node.c: (~suppress_output_file, ~ascii_output_file):
	Deleted.

	* troff/symbol.h: Make all symbol member functions const.

	* lib/strtol.c: New file.
	* lib/Makefile: Add strtol.c.
	* Makefile: Define STRTOL as strtol.o to include strtol in
	libgroff.a.

Wed Sep 12 10:00:49 1990  James Clark  (jjc at jclark)

	* pic/troff.c (troff_output::simple_circle): Divide by scale.

Tue Sep 11 14:17:16 1990  James Clark  (jjc at jclark)

	* troff/input.c (do_special): Use input_level.

	* troff/token.h (TOKEN_BACKSPACE): New token.
	(token::backspace): New function.
	* troff/input.c (token::description, token::next, token::process):
	Grok TOKEN_BACKSPACE.
	(do_special): Turn TOKEN_BACKSPACE back into \b.

	* troff/token.h (token::leader): New function.
	* troff/input.c (do_special): Turn TOKEN_LEADER back into \001.

	* troff/input.c (do_special): Turn TOKEN_TAB back into \t.

	* troff/input.c (do_special): Use token::description in error
	message.

Mon Sep 10 11:06:27 1990  James Clark  (jjc at jclark)

	* troff/input.c (decode_args): Combine quoted and
	quote_input_level variables. Make it a for (;;) loop.

	* troff/input.c (get_char_for_escape_name): Check for \001 and \b.

	* troff/input.c (read_long_escape_name): The test for whether to
	expand buffer was off by 1.
	(read_string): Similarily.

Fri Sep  7 11:45:50 1990  James Clark  (jjc at jclark)

	* troff/input.c: Use `const int' rather than `static const int'.

	* troff/div.h (diversion::copy_file): Declare as pure virtual.
	(macro_diversion::copy_file): New function.
	* troff/node.h: New class diverted_copy_file_node.
	* troff/node.c: Implement it.
	* troff/input.c (copy_file): Use diversion::copy_file. Handle
	first page transition by pushing a diverted_copy_file_node.
	* troff/input.c (token::next, process_input_stack): Don't handle
	COPY_FILE_REQUEST.

Thu Sep  6 13:29:10 1990  James Clark  (jjc at jclark)

	* ps/ps.c (flush_sbuf): Remember to add sbuf_kern when checking
	whether space widths need adjusting.

	* troff/charinfo.h: Generalize translated_to_space to
	special_translation so as to allow translation to \&.
	* troff/input.c (translate): Allow translation to \&.
	(charinfo::*): Corresponding changes.
	* troff/node.c (make_node, node::add_char): Corresponding changes.
	* troff/node.h (dummy_node::dummy_node): Allow optional first
	argument.

	* lib/lib.h: Make codes 0200 to 0237 illegal input characters.
	* troff/token.h: Remove TOKEN_TITLE. Remove token::title. Add
	TOKEN_REQUEST.
	* troff/input.c (token::next): Turn a TITLE_REQUEST into a
	TOKEN_REQUEST with an argument of TITLE_REQUEST.
	(token::process): Grok that.
	* troff/input.c (copy_file): Handle first page transition like
	title by pushing a COPY_FILE_REQUEST cookie.
	(token::next, process_input_stack): Grok that.
	* troff/node.h (output_file::copy_file): Add x and y arguments.
	Make it non-pure.
	* troff/div.c (top_level_diversion::copy_file): Supply them.
	* troff/node.c (troff_output_file::copy_file): Add x and y
	arguments; moveto specified position.  Invalidate font_position
	array after copying file.
	(output_file::copy_file): New function.
	(suppressed_output_file::copy_file, ascii_output::copy_file):
	Removed.
	* troff/input.c (transparent_file): New function.
	(init_input_requests): Bind to "trf".
	(token::next): Handle TRANSPARENT_FILE_REQUEST cookie.
	(process_input_stack): Likewise.

	* troff/Makefile: Add ../lib/lib.h to GROFF_H.

	* troff/node.c (init_node_requests): New number registers .kern
	pointing to global_kern_mode, and .lg pointing to
	global_ligature_mode.

	* troff/node.c (ligature): Don't change it if we get a bad
	integer.

	* troff/input.c (do_define_string): Don't strip tabs.

	* troff/input.c (asciify_macro): Make the string_iterator auto.

	* troff/node.c (init_font_requests): Rename to...
	(init_node_requests):
	* troff/node.h: Change declaration.
	* troff/input.c (main): Change call.

	* troff/input.c (node::reread, diverted_space_node::reread): New
	methods.
	(process_input_stack): Call reread rather than
	get_diverted_space_node.
	* troff/node.c (node::get_diverted_space_node,
	diverted_space_node::get_diverted_space_node): Removed.
	* troff/node.h: Declare reread methods instead of
	get_diverted_space_node methods. Make `n' member private.
	* troff/input.c: (token::diverted_space): Removed.
	* troff/token.h: Removed declaration.
	

Tue Sep  4 00:48:04 1990  James Clark  (jjc at jclark)

	* eqn/script.c (script_box::compute_metrics): Don't let
	SUP_RAISE_FORMAT become negative.

	* tbl/table.c (table::do_row): Entries that don't end in the
	this row shouldn't make the row non-blank.
	
	* tbl/table.c (table::make_columns_equal): Only set the width of
	columns which are marked as equal.
	
	* tbl/main.c (process_data): Before issuing excess data error,
	if last character was a newline unget it; then get it again after
	the error.  Also include the contents of the entry in the message.

	* groff.c: New file.
	* Makefile: Build groff from groff.c.  Make it possible to use
	either groff.sh or groff.c as groff.
	* Makefile.bd: Similarily.

Mon Sep  3 09:39:49 1990  James Clark  (jjc at jclark)

	* groff.sh: Don't delay expansion of $@ in assignment to files.
	Remove occurrences of \".

Sun Sep  2 09:56:59 1990  James Clark  (jjc at jclark)

	* all Makefiles: Simplify and rearrange.

	* Makefile: Handle fmod like malloc.
	* lib/Makefile: Similarily.
	* lib/fmod.c: Remove #ifdef NEED_FMOD.

	* Makefile: Rename OPTIMISE to OPTIMIZE.

	* groff.sh: Remove assignment to PATH.
	* Makefile: Remove SHPATH variable.
	* Makefile.bd: Similarily.

	* groff.sh: Add -V option to print the pipeline instead of
	executing it.

Fri Aug 31 00:56:46 1990  James Clark  (jjc at jclark)

	* lib/font.c: Split off file searching into ...
	* lib/fontfile.c: New file.

	* lib/strerror.c (strerror): Use `Error %d' for unknown errors.

Thu Aug 30 13:13:55 1990  James Clark  (jjc at jclark)

	* tbl/table.c (table::do_hspan): Delete assertion that e != 0.
	Also change misleading comment.
	(table::do_vspan): Change similarily misleading comment.
	* tbl/main.c (process_data): A format row with an explicit `s'
	uses up a data line, even if all the other columns are `_' or `='.

	* troff/input.c (token::description): Fix description of
	TOKEN_DUMMY and TOKEN_EMPTY.

Wed Aug 29 04:12:08 1990  James Clark  (jjc at jclark)

	* groff.sh: Fix description of -Z in help message.

Tue Aug 28 07:28:33 1990  James Clark  (jjc at jclark)

	* pic/object.c (object_spec::make_object): Allow negative and zero
	line thicknesses.
	* pic/pic.y: Give linethick default value of -1.0.
	* pic/troff.c (troff_output::troff_output): Initialize
	last_line_thickness to BAD_THICKNESS.
	(troff_output::finish_picture): Set thickness to BAD_THICKNESS.
	(troff_output::line_thickness): Canonicalize negative thicknesses
	to RELATIVE_THICKNESS.
	* pic/tex.c (tex_output::set_pen_size): Silently map negative line
	thicknesses to DEFAULT_PEN_SIZE. Canonicalize negative pen sizes
	to -1.0.
	(tex_output::start_picture): Set pen_size to -2.0.

	* ps/ps.c (ps_printer::set_line_thickness): If line_thickness is
	0, then use 0 linewidth.
	(ps_printer::ps_printer): Initialize line_thickness to -1.

	* pic/troff.c (troff_output::simple_ellipse): Divide by scale.

	* ps/devps/symbolchars: Remove `or'.
	* ps/tmac.ps: Implement \(or with .char.

	* ps/devps/symbolchars: Move most characters into textmap.
	* ps/devps/textmap: Add names for troff bracket characters. Remove
	ul, ru, br, bv.

	* ps/devps/TSymbol.ps: Removed.
	* ps/devps/FontMakefile: Make S from Symbol not TSymbol.
	* ps/tmac.ps: Do with .char what TSymbol did.
	* ps/devps/download: Remove TSymbol.

	* ps/devps/T: Removed.
	* ps/devps/Troff.ps: Removed.
	* ps/devps/Troff.afm: Removed.
	* ps/tmac.ps: Implement \(ru, \(ul, and \(br with .char.
	* ps/devps/download: Remove Troff.
	* ps/devps/FontMakefile: Remove T target.
	* ps/devps/DESC-A4: Remove T from font list.
	* ps/devps/DESC-letter: Likewise.

	* troff/input.c (macro_to_node): Rename to ...
	(charinfo_to_node): Don't pass mac argument.  Temporarily remove the
	character's definition while processing it.
	* troff/node.c (node::add_char, make_node): Change calls to
	macro_to_node accordingly.

	* troff/input.c (token::next): Translate \_ to \(ul.

	* tty/devascii/R.proto: Add `|'.
	* tty/devlatin1/R.proto: Likewise.

Mon Aug 27 11:25:41 1990  James Clark  (jjc at jclark)

	* man: Put the version number in all the man pages.

Sun Aug 26 11:40:05 1990  James Clark  (jjc at jclark)

	* Makefile.bd: New file.
	* README.bd: New file.

	* VERSION: New file.
	* lib/version.c: Removed.
	* lib/Makefile: Create version.c from ../VERSION. Remove version.c
	in clean target.

	* troff/input.c (main): Get hyphen_file from GROFF_HYPHEN
	environment variable.

	* all Makefiles: Split install target into install.bin for
	binaries, and install.nobin for everything else.
	* Makefile: Add bindist target.

	* man/afmtodit.man: New file.
	* man/Makefile: Add afmtodit.n to MAN1PAGES.
	* ps/devps/Makefile: Add textmap to DEVICEFILES. Install afmtodit
	in BINDIR.
	* ps/Makefile: Pass BINDIR to make install in devps.

	* ps/ps.c (ps_printer::set_char): Do nothing if the character is
	the space character.

	* ps/devps/FontMakefile: Rename symbol.afm to tsymbol.afm.

Sat Aug 25 15:39:03 1990  James Clark  (jjc at jclark)

	* ps/ps.c: Redo font downloading.
	* ps/devps/download: New file.
	* ps/devps/Makefile: Add download to DEVICEFILES.
	* ps/devps/afmtodit: Remove -d option.
	* ps/devps/FontMakefile: Don't use -d option with afmtodit.
	* ps/devps/symbosl.ps: Add %%DocumentFonts comment.
	* ps/devps/zapfdr.ps: Likewise.
	* ps/devps/TSymbol.ps: Likewise.

Fri Aug 24 20:10:30 1990  James Clark  (jjc at jclark)

	* groff.sh: Initialize dev to ${GROFF_TYPESETTER:-@DEVICE@}.

Thu Aug 23 10:03:47 1990  James Clark  (jjc at yquem)

	* ps/ps.c (ps_output::include_file): If BROKEN_SPOOLER is defined,
	then strip the first line if it starts with %.
	* Makefile: Add a comment about this.

	* man/tfmtodit.man: New file.
	* man/Makefile: Add tfmtodit.n to MAN1PAGES.
	* dvi/Makefile: Install tfmtodit in BINDIR.

	* dvi/tfmtodit.c (usage): Mention -v option.

Wed Aug 22 09:56:36 1990  James Clark  (jjc at yquem)

	* troff/node.c (troff_output_file::end_of_line): Call do_motion.
	* troff/node.c (troff_output_file::transparent_char): Don't call
	flush_tbuf.

	* eqn: Add check_tabs method to most box classes.
	* eqn/box.c (box::top_level): Call check_tabs.

	* eqn/script.c (script_box::output): Use \Z.
	* eqn/limit.c (limit_box::output): Use \Z.

	* eqn/box.c (box::top_level): Use itoa.

Tue Aug 21 09:29:28 1990  James Clark  (jjc at yquem)

	* dvi/tmac.dvi: Add font translations for CR, C, TT.
	* dvi/devdvi/Makefile: Don't make links to CW.

	* ps/tmac.ps: Add font translations for C, CW, CO, CX, CD, H, HO,
	HX, HD.
	* xditview/tmac.X: Likewise.

	* troff/node.c: Add font translation feature.
	(get_font_translation): New function.
	(symbol_fontno): Translate the font name.
	(mount_font_no_translate): Rename to mount_font to this.
	(mount_font): New function.
	(font_family::make_definite): Call mount_font_no_translate instead
	of mount_font.
	(mount_style): Translate the font name.
	(font_translate): New function.
	(init_font_requests): Bind "ftr" to font_translate.

	* ps/devps/prologue (SN): New procedure that rounds a position to
	the nearest (pixel + (.25,.25)).
	(DL): Use SN to round endpoints.

	* lib/version.c: Changed version to 0.5.

Sat Aug 18 04:43:21 1990  James Clark  (jjc at yquem)

	* Makefile: Move definition of PAGE to the very beginning, so that
	people are less likely to miss it.

Fri Aug 17 02:15:11 1990  James Clark  (jjc at yquem)

	* man/Makefile: Don't need to sed out @UPCASE_PROG_PREFIX@.

	* troff/env.c (environment::choose_breakpoint): Make `can't find
	breakpoint' error a warning of type WARN_BREAK.  Change message to
	`can't break line'.
	* troff/groff.h: Declare WARN_BREAK with code 4; change WARN_INPUT to
	code 040000.
	* troff/input.c: Add WARN_BREAK to warning_table.  Include
	WARN_BREAK in DEFAULT_WARNING_MASK.

	* tty/tmac.tty: Add definition of \(+-.

	* groff.sh: Remove `--' option to set command.

	* dvi/devdvi/texsy.map: Remove duplicate md entry.

	* ps/devps/eqnchar: Better definition of cdot using md.
	* dvi/devdvi/eqnchar:  Likewise.
	* xditview/devX100/eqnchar:  Likewise.
	* xditview/devX75/eqnchar: Likewise.
	* eqn/lex.c: Add definition of cdot.

Thu Aug 16 09:33:57 1990  James Clark  (jjc at yquem)

	* troff/input.c (get_optional_char): New function.
	* troff/input.c (set_page_character): Use get_optional_char(),
	rather than has_arg() and tok.get_char(1).
	* troff/env.c (tab_character, leader_character, hyphen_char,
	field_characters): Likewise.
	(margin_character): Likewise.  Also always delete the
	margin_character_node.

	* troff/input.c (token::get_char): Use token::description.

	* troff/input.c (has_arg): Don't skip over tab and \}.
	* troff/number.c (start_number): Give a warning if the number
	starts with \} (WARN_RIGHT_BRACE) or tab (WARN_TAB).

Wed Aug 15 10:04:37 1990  James Clark  (jjc at yquem)

	* troff/input.c (empty_name_warning, non_empty_name_warning): New
	functions.
	(get_name, get_long_name): Use these.  Rename `warn' argument to
	`required'.

	* troff/node.c (get_fontno): Test that the symbol is not null.

	* troff/input.c (token::description): New function.
	* troff/number.c (parse_term): Use token::description in `numeric
	expression expected' message.
	* troff/groff.h: Add WARN_MISSING.
	* troff/number.c (start_number): New function.
	* troff/number.c (get_vunits, get_hunits, get_number, get_integer,
	get_incr_number): Use start_number().
	* troff/input.c (DEFAULT_WARNING_MASK): Enable WARN_NUMBER by
	default.
	* troff/input.c (get_name, get_long_name): Use WARN_MISSING.
	* troff/reg.c (alter_format): Use WARN_MISSING. Also use
	token::descripion.
	* troff/input.c (token::get_char): Use WARN_MISSING.
	* troff/input.c (token::delimiter): Use token::description.
	* troff/env.c (environment_switch): Back out Aug 3 change.
	* troff/input.c (has_arg): Skip over \}s and tabs but give a
	warning.
	* troff/token.h (token::tab): New function.
	* troff/node.c (get_fontno): Use tok.skip() rather than has_arg().
	* troff/reg.c (alter_format): Likewise.
	* troff/node.c (bold_font): Use has_arg() rather than tok.skip().

Tue Aug 14 10:11:21 1990  James Clark  (jjc at yquem)

	* troff (most files): Redo warnings. Divide warnings into various
	categories; warning() has an additional first argument indicating
	the category it falls into.
	* troff/input.c (main): -w now takes an argument. New option -W.
	(enable_warning, disable_warning): New functions.

	* ps/devps/afmtodit: Add -a option to lie about the italic angle.
	* ps/devps/FontMakefile: Pretend TI has an angle of 7.

Mon Aug 13 10:11:16 1990  James Clark  (jjc at yquem)

	* ps/devps/eqnchar: Better definitions of dotdot, vec, dyad, inf.
	* xditview/devX100/eqnchar: Likewise. Remove definition of dot.
	* xditview/devX75/eqnchar: Likewise.
	* dvi/devdvi/eqnchar: Better definitions of vec, dyad, dotdot.

	* eqn/other.c: When bar or over applies to a single character
	don't produce an overline_box or an underline_box. Instead produce
	an accent_box or an underaccent_box, with the accent a line
	whose width is accent_width.  New classes underaccent_box,
	overline_char_box and underline_char_box.
	* eqn/box.h: Move overline_box, underline_box, accent_box class
	declarations into eqn/other.c. Add declarations of
	make_underline_box, make_overline_box, make_accent_box.
	* eqn/eqn.y: Call make_overline_box, make_underline_box
	make_accent_box instead	of constructors.
	* eqn/pbox.h, eqn/box.c: Add accent_width parameter.

	* eqn/other.c: Add accent_box::~accent_box.
	* eqn/box.h: Declare it.

	* groff.sh: With -Tps, use eqn -D.

	* eqn/other.c (overline_box::output): Use \Z. If draw_flag use \D
	rather than \l.
	(underline_box::output): Similarily.
	(accent_box::output): Use \Z.

	* xditview/tmac.X: Add definitions of ~ and ^ (so that they are a
	bit smaller.)

Sun Aug 12 09:41:15 1990  James Clark  (jjc at yquem)

	* troff/div.c (top_level_diversion::transparent_output(unsigned
	char)): Use asciify.
	* troff/input.c (asciify): Don't make it static.
	* troff/token.h (asciify): Declare it.
	
	* troff/input.c (get_name, get_long_name, token::get_char,
	token::delimiter): Add an extra default argument which says
	whether a warning should be printed.
	* troff: Pass a non-zero argument to one of these rather than
	printing a warning directly.

Sat Aug 11 09:02:21 1990  James Clark  (jjc at yquem)

	* troff: Consistently use symbol::is_null.

	* troff/dictionary.h: Move some inline functions into
	dictionary.c.

	* troff/request.h: Move inline functions into input.c.
	(request_or_macro::invoke): Make it pure.

	* troff/input.c, troff/reg.h: New class `constant_int_reg'.
	* troff/input.c (init_input_requests): Use class constant_int_reg.
	(class compatible_reg): Deleted.
	* troff/div.c (init_div_requests): Use class constant_int_reg.
	(class last_post_line_extra_space_reg): Deleted.

	* troff/env.c (tab_character): Don't change the tab character if
	we get an invalid argument.
	(hyphen_char): Similarily.

	* troff/reg.c (alter_format): Check that nm is not null.

	* Makefile, groff.sh: Make it possible to customize the commands
	used for printing PostScript and dvi files. Also make it possible
	to customize the path used by groff.sh.

	* eqn/eqn.y: Make `left' right associative.

Fri Aug 10 18:20:39 1990  James Clark  (jjc at yquem)

	* pic/pic.h: Added definition of M_SQRT2 for those systems that
	don't have it.

	* pic/pic.h: Removed definition of INT_MAX.

	* troff/node.c (italic_corrected_node::vertical_extent): Omit
	`return'.

	* troff/input.c (token::next):  Handle \R like \n.

Tue Aug  7 09:46:33 1990  James Clark  (jjc at yquem)

	* ps/tmac.pc (PSPIC): Simplify.

	* troff/env.c (tab_stops::to_string):
	* pic/pic.y (object_type_name):
	* pic/troff.c (simple_output::line):
	* pic/tex.c (tex_output::spline):
	* pic/object.c (object_spec::make_object):
	* tbl/main.c (process_data):  Add cases to switch statements to
	avoid cfront warnings. (Some of these are spurious, since the
	switch already has a default case.)

	* ps/tmac.ps (PSPIC): Reformatted.  Prefix all local names with
	`ps-'.  Don't test systat; instead check number of arguments to
	ps-bb.

Mon Aug  6 00:13:07 1990  James Clark  (jjc at yquem)

	* macros/tmac.e: Do not decrease the page offset by 0.5i.

	* ps/ps.c (ps_printer::ps_printer): Use mktemp instead of tempnam.
	Unlink the file as soon as we have opened it, so that we don't
	have to bother with signal handlers.
	(handler): Deleted.
	(fatal_error_exit): Deleted.
	(main): Don't call signal.

	* dvi/tfmtodit.c: Add -k option so that kerns with the skewchar
	can be ignored.
	* dvi/devdvi/Makefile: Use the -k option with S and MI.

	* pic/pic.y:  If there is a label, or an nth construction before
	the first `.' in the argument to `with', ignore it and generate a
	warning.
	* pic/lex.c (lex_warning): New function.

	* tbl/table.c (table::init_output): In section keep and release
	macro, use 0 indent when diverting and the correct indent when
	rereading.

	* troff/input.c (interpolate_number_format): Do not interpolate
	anything if the number register is not defined.

	* tbl/main.c (process_data): Don't add entry when col >= ncolumns.

Sat Aug  4 08:12:05 1990  James Clark  (jjc at yquem)

	* ps/devps/prologue (PICTURE): Set components of graphics state to
	their default values.

	* ps/devps/text.enc: Add trademark
	* ps/devps/textmap: Add names for club, spade, heart, diamond,
	carriagereturn, suchthat. Use Upsilon1 rather than Upsilon.
	* ps/devps/symbolchars: Add names for summation and product.

	* dvi/devdvi/texsy.map: Add names for club, spade, heart, diamond,
	suchthat. Add pp. Add upper-case letters.

	* xditview/libXdvi/DviChar.c: Add names for club, spade, heart,
	diamond, carriagereturn, suchthat. Use Upsilon1 rather than
	Upsilon.

	* dvi/devdvi/texsy.map: Rename lA (left angle bracket) to la, and
	rA (right angle bracket) to ra.  Introduce names for double-headed
	arrows and double-barred arrows: <>, va, lA, rA, hA, uA, dA, vA.
	* ps/devps/textmap: Likewise for ps device.
	* xditview/libXdvi/DviChar.c: Likewise for X100 and X75 devices.
	* tty/devascii/R.proto: Rename lA to la and rA to ra.
	* tty/devascii/R.proto: Likewise.
	* tty/tmac.tty: Provide definitions for \(<>, \(lA, \(rA, \(hA,
	\(uA, \(dA.
	* eqn/delim.c: In delim_table, rename \(lA to \(la and \(rA to \(ra.

	* xditview/tmac.X: Add definitions for \(fi \(fl \(ff \(Fi \(Fl.

	* eqn/lex.c: Added definitions of `approx', `grad' and `del' to
	def_table.

Fri Aug  3 09:59:27 1990  James Clark  (jjc at yquem)

	* troff/div.c (when_request): Use symbol::is_null rather than
	has_arg to determine whether we have an argument.
	(change_trap): Remove the trap if we get an invalid number. Give
	an error if we don't get at least the macro name.
	(diversion_trap): Remove trap if we get an invalid name or number.

	* troff/env.c (environment_switch): Pop if we get an invalid
	symbol or numeric expression.

	* troff/input.c (do_define_macro):  If EOF is encoutered while
	defining the macro, do tok.next() before returning.

	* troff/token.h (has_arg): Move definition from here, to ...
	* troff/input.c (has_arg): ... here

	* troff/env.c (space_size): Do nothing if we get an invalid argument.
	* troff/input.c (shift): Likewise.

	* pic/lex.c (get_token_after_dot):  Accept `.center' as a synonym
	for `.c'.

	* pic/troff.c (troff_output::start_picture):  Comment out calls to
	`..'.

	* eqn/main.c (do_file): Subtract 1 from current_lineno if
	interpret_lf_args succeeds.

	* eqn/main.c (do_file): Don't recognize delimiter if preceded by
	\\.  This avoids problems with \$N.

	* groff.sh: Pass -C to preprocessors.

	* lib/lf.c (interpret_lf_args):  Be more flexible.

	* tbl/main.c (main): Add -C option.
	(table_input::get): Do not recognize TE if followed by character
	other than a space or newline unless -C option given.
	(process_input_file): Likewise for lf, TS.
	(process_data): Likewise for lf in text blocks.

	* eqn/main.c (main): Add -C option.
	(do_file): Don't recognize EQ, EN or lf if followed by character
	other than space or newline unless -C option given.
	* eqn/lex.c (file_input::read_line): Similarily.
	* eqn/eqn.h: Declare compatible_flag.

	* etc/soelim.c (main): Add -C option.
	(interpret_lf_args): Use version in libgroff.
	(do_file):

	* pic/main.c (main): Add -C option, which sets compatible_flag.
	(top_input::get), (top_input::peek):  If -C option not given,
	do not recognize .PS/.PE/.PF/.lf if followed by a character
	other than space or newline.
	* pic/lex.c (file_input::read_line): Similarily.
	* pic/pic.h: Add declaration of compatible_flag.

Thu Aug  2 11:11:27 1990  James Clark  (jjc at yquem)

	* ps/tmac.ps (PSPIC): Avoid use of `echo -n'.

	* troff/node.c, troff/node.h:  Add `asciify' methods to classes
	derived from node.  New class space_char_hmotion_node.
	* troff/input.c (asciify_macro): New function.
	* troff/input.c (init_input_requests): New request `asciify' bound
	to asciify_macro.
	* macros/mm.diff: New file.
	* Makefile:  In install.mm target use `patch' to apply
	macros/mm.diff.

	* troff/input.c (macro::print_size): Just print the size in bytes.

	* troff/div.c (return_request): Correct the argument
	interpretation.

Wed Aug  1 12:38:36 1990  James Clark  (jjc at yquem)

	* troff/node.h (class composite_node): Add sz member.
	* troff/node.c (composite_node::size): Return sz.
	* troff/input.c (macro_to_node):  Use the initial size in the
	environment as the size of the composite_node.

	* troff/node.c (node::zero_width_tprint):  Provide a reasonable
	default.

Tue Jul 31 10:07:10 1990  James Clark  (jjc at yquem)

	* troff/div.c (change_trap): If we get a bad number expression,
	do nothing.

Mon Jul 30 10:30:49 1990  James Clark  (jjc at yquem)

	* lib/matherr.c (matherr): Define this only if math.h defines
	TLOSS.

Sun Jul 29 10:34:27 1990  James Clark  (jjc at yquem)

	* troff/div.c (macro_diversion::distance_to_next_trap): If there
	no diversion trap return vunits(INT_MAX - vresolution).

Sat Jul 28 14:28:14 1990  James Clark  (jjc at yquem)

	* troff/input.c (do_zero_width): New implementation that doesn't
	use a temporary environment. Use instead:
	(token::add_to_node_list): New function.
	* troff/env.c (environment::get_prev_char_height),
	(environment::get_prev_char_height),
	(environment::get_prev_char_skew): New functions.
	(environment::get_prev_char): New function.
	(environment::get_prev_char_width): Change to use get_prev_char.
	(init_env_request): Implement new registers .cht, .cdp, .csk.
	* eqn/sqrt.c (sqrt_box::output): Don't rely upon the argument to
	\Z being processed in a separate environment.

Fri Jul 27 10:21:25 1990  James Clark  (jjc at yquem)

	* tbl/table.c: Removed TABLE_BOTTOM_REG.

	* tbl/table.c (table::init_output): In the section release macro,
	give a warning message if the section won't fit on one page.

	* tbl/table.c (table::do_top): Emit table keep only if table is
	boxed.
	(table::do_bottom): Likewise for table release.
	(table::table), (table::add_vertical_rule):  Remove reference to
	keep member.
	* tbl/table.h: Remove keep member.

	* tbl/table.c: New register SUPPRESS_BOTTOM_REG. In
	SECTION_RELEASE_MACRO, if there's not enough space before the next
	trap to output the diversion, call T# ourselves, set
	SUPPRESS_BOTTOM_REG to 1, spring the trap, then set
	SUPPRESS_BOTTOM_REG back to 0.  In T#, do nothing if
	SUPPRESS_BOTTOM_REG is non-zero.  In T#, always mark the current
	vertical position and return to it before turning traps on again.
	
Thu Jul 26 02:54:32 1990  James Clark  (jjc at yquem)

	* troff/node.c, troff/node.h: In classes derived from node,
	replace prev_char_width method by last_char_node method.
	* troff/env.c (environment::get_prev_char_width): Use
	node::last_char_node rather than node::get_prev_char_width.

	* Makefile: Added comment about -fno-inline on 68030-based
	Apollos.

	* troff/reg.c (number_format_to_ascii), eqn/delim.c (DELIM_TABLE_SIZE),
	tty/tty.c (tty_font::load_tty_font), dvi/tfmtodit.c (main): Cast
	expressions using sizeof to int.
	* dvi/dvi.c (dvi_font::handle_x_command): Avoid long->int warnings.

	* macros/tmac.e (TS):  Don't move @f back past the current
	position.

Wed Jul 25 09:11:08 1990  James Clark  (jjc at yquem)

	* ps/ps.c (main): Buffer stderr.
	* dvi/dvi.c (main): Likewise.
	* tty/tty.c (main): Likewise.

	* ps/ps.c (ps_printer::do_import): Improve error handling.

	* troff/input.c (abort_request): Use asciify.

	* driver/printer.h (printer::draw), driver/printer.c (printer::draw),
	ps/ps.c (ps_printer::draw), dvi/dvi.c (dvi_printer::draw): Make
	type of first argument int rather than char.  This works around a
	bug on the 68030 based Apollo using g++ 1.37.1.

	* tbl/table.h (class table): Add `keep' member.
	* tbl/table.c (table::table): Initialize `keep'.
	(table::add_vertical_rule): Set `keep' to 1.
	(table::do_top): Only emit table keep macro is `keep' is non-zero.
	(table::do_bottom): Likewise for table release macro.
	(table::do_row): Emit section keep macro even if the row is 0.

Tue Jul 24 08:35:07 1990  James Clark  (jjc at yquem)

	* macros/tmac.e (@C): Preserve the font family across the change
	in environments.

Mon Jul 23 10:15:23 1990  James Clark  (jjc at yquem)

	* lib/font.c: Initialize font::hor and font::vert to 1.
	(font::load_desc): Check the values of font::hor and font::vert.

	* lib/lib.h: Added definition of INT_DIGITS. Fix it so that it can
	be included in a C compilation.
	(iftoa): Use INT_DIGITS. Include lib.h.
	(itoa): Likewise.
	(as_string): Likewise.
	* tbl/table.c: Removed definition of INT_DIGITS.
	* eqn/box.c (box::top_level): Use INT_DIGITS + 1 instead of 12.
	* troff/input.c (input_input_requests): Likewise.
	* ps/ps.c (make_encoding_name): Likewise.
	(ps_printer::set_style): Likewise.
	(ps_output::put_number): Use 1 + INT_DIGITS + 1 instead	of 12.

	* tty/devascii/R.proto: Map fm onto '.
	* tty/devlatin1/R.proto: Likewise.

Sat Jul 21 12:45:07 1990  James Clark  (jjc at yquem)

	* tbl/table.c: Use ' instead of DELIMITER_CHAR in places where the
	argument to \w is at a different input level.

	* tbl/table.c (table::init_output): Define a new macro
	REPEATED_VPT_MACRO, like vpt but if in a diversion also
	transparently outputs itself.
	(table::define_bottom_macro): Use REPEATED_VPT_MACRO instead of
	vpt.
	(table::do_row): Likewise.

	* tbl/table.c (vertical_rule::print): Prefix the .sp -1 line with
	TRANSPARENT_STRING_NAME.

	* tbl/table.c (table::init_output): In the table release macro
	print an error message and don't produce any output if after
	issuing the need request the table still will not fit.  Also
	remove the diversion after bringing it back.

	* tbl/table.c (table::init_output): Define a new macro
	REPEATED_MARK_MACRO, like mk but if in a diversion also
	transparently outputs itself.
	(table::do_row): Mark row_top_reg using	REPEATED_MARK_MACRO. This
	is necessary because .TH might not call .T#.
	(table::do_top): Likewise TOP_REG.
	(table::define_bottom_macro): If TOP_REG is no longer valid, use
	#T - DOUBLE_LINE_SEP rather than #T. This is necessary because the
	table header might contain just the two top rules.

Fri Jul 20 10:51:42 1990  James Clark  (jjc at yquem)

	* troff/div.c: Implement new request `ptr' to print all traps.

	* troff/env.c (init_env_requests): Implement `.tabs' reg with
	init_string_env_reg.
	* troff/env.c (class tab_reg): Deleted.

Thu Jul 19 12:07:16 1990  James Clark  (jjc at yquem)

	* troff/div.c: New number register .pn returns the number of the
	next page as set by the pn request.

	* macros/tmac.an: Redid headers and footers.  Number each manual
	entry starting from 1 unless \nC is > 0, like Sun.  Added an
	optional 5th argument to .TH which specifies the manual name and
	appears in the center of the header.  Understand the X, P and D
	registers like Sun.

Wed Jul 18 10:23:31 1990  James Clark  (jjc at yquem)

	* troff/env.c (init_env_requests): New number register `.lt' to
	return the title length.

	* troff/node.h (class transparent_dummy_node): New class.
	* troff/node.c (class transparent_dummy_node): Provide member
	functions. 
	* troff/env.c (interrupt): Add a transparent_dummy_node, rather
	than a dummy_node.

	* troff/input.c (token::next): New escape sequence \).
	* troff/input.c (get_copy): Recognize \) in copy mode.

	* troff/input.c (input_stack::clear): New function.
	* troff/input.c (exit_request): Use input_stack::clear.

	* troff/token.h: Removed TOKEN_NO_PRINT_CHAR.
	* troff/input.c (token::process): Removed case TOKEN_NO_PRINT_CHAR.

	* troff/env.c: Move set_page_character to input.c.  Move
	page_character to input.c also.
	* troff/env.c (title): Split off the reading of the parts of the
	title into read_title_parts.
	* troff/input.c (read_title_parts): New function.  Check the
	input_level when testing whether a token matches the delimiter.

	* troff/input.c (exit_request): New function.
	* troff/input.c (init_input_requests): Bind ex request to
	exit_request rather than exit_groff.

	* troff/input.c (exit_groff): Call tok.next() before
	process_input_stack().

Mon Jul 16 09:47:23 1990  James Clark  (jjc at yquem)

	* troff/env.c: ifdef widow control support on WIDOW_CONTROL.
	* troff/env.h: ditto.
	* troff/input.c: ditto.

	* troff/env.c (environment::is_empty): Test pending_lines.

	* troff/env.c (environment::have_pending_lines): Removed.

	* troff/input.c: Add request to flush pending lines from the
	environment.

	* troff/env.c, troff/env.h: Add automatic widow control feature.

	* troff/input.c (exit_groff):  Do process_input_stack() after
	do_break() but before setting exit_flag to 2.

	* troff/input.c: Remove FLUSH_PENDING_LINES and
	TOKEN_FLUSH_PENDING_LINES. Instead, flush pending lines from
	environment after END_TRAP token seen, but only if there aren't
	any more traps still unfinished.
	* troff/token.h: Remove TOKEN_FLUSH_PENDING_LINES.

Sun Jul 15 10:50:08 1990  James Clark  (jjc at yquem)

	* troff/env.c: Rename the `retain_size' member of class
	pending_output_line to `no_fill'.

	* troff/env.c (title): When the line is output, make the
	retain_size argument !fill.

	* troff/node.h: Add `hyphenated' member to struct breakpoint.
	* troff/node.c (space_node::get_breakpoints),
	(dbreak_node::get_breakpoints):  Fill this in.
	* troff/env.c:  Allow specification of maximum number of
	consecutive hyphenated lines.

	* troff/env.c (environment::is_empty): Add test for !current_tab.

Sat Jul 14 11:23:01 1990  James Clark  (jjc at yquem)

	* troff/env.c (environment::hyphenate_line): Don't completely give
	up if the word is not to be hyphenated; continue so that breaks
	can be made at break_char_node's.

	* lib/lib.h: Only define INT_MAX if it's not already defined;
	undef INT_MIN if it's already defined.

	* Makefile: Make it easy to define CFRONT_ANSI_BUG.

	* lib/lib.h: If CFRONT_ANSI_BUG is defined, cast INT_MIN to long.
	This works around a bug in AT&T C++ 2.0 used with an ANSI C
	compiler.
	
	* macros/tmac.an (an-header): Set no-space mode.

	* macros/tmac.an (TH): Start a new page if necessary.

	* Started using ChangeLog at version 0.4.

Local Variables:
version-control: never
End:
